{
	ADLIB.H

	Defintions of sound chip parameters.

	1987/01/20, Marc Savary
        1990/02/22, Bill Parquet
}

{ Parameters of each voice: }

CONST
     nbLocParam = 14;

     prmKsl     = 0;
     prmMulti   = 1;
     prmFeedBack= 2;			{ use for opr. 0 only }
     prmAttack  = 3;
     prmSustain = 4;
     prmStaining= 5;			{ Sustaining ... }
     prmDecay   = 6;
     prmRelease = 7;
     prmLevel   = 8;
     prmAm      = 9;
     prmVib     = 10;
     prmKsr     = 11;
     prmFm      = 12;			{ use for opr. 0 only }
     prmWaveSel = 13;		        { wave select }

{ globals parameters: }

CONST
     prmAmDepth    = 14;
     prmVibDepth   = 15;
     prmNoteSel    = 16;
     prmPercussion = 17;

{ melodic voice numbers: }

CONST
     vMelo0 = 0;
     vMelo1 = 1;
     vMelo2 = 2;
     vMelo3 = 3;
     vMelo4 = 4;
     vMelo5 = 5;
     vMelo6 = 6;
     vMelo7 = 7;
     vMelo8 = 8;

{ percussive voice numbers: }

CONST
     BD    = 6;
     SD	   = 7;
     TOM   = 8;
     CYMB  = 9;
     HIHAT = 10;

CONST
     MAX_VOLUME  = $7f;
     LOG2_VOLUME = 7;			{ log2( MAX_VOLUME) }
     MAX_PITCH   = $3fff;
     MID_PITCH	 = $2000;

CONST
     MID_C	 = 60;			{ MIDI standard mid C }
     CHIP_MID_C  = 48;			{ sound chip mid C }
     NR_NOTES	 = 96;		        { # of notes we can play on chip }
