uses
    crt,dos;

const
     dacx1 = 470;dacx2 = dacx1+12;

     mdat:array[0..63] of byte=(255,249,255,240,255,240,255,240,255,
                    240,255,240,255,224,191,192,31,128,15,128,7,128,7,
                    128,7,192,15,224,31,240,63,240,0,0,0,6,0,
                    6,0,6,0,6,0,6,0,6,0,22,64,55,224,
                    63,240,63,240,63,240,31,224,15,192,7,128,7);
var
   regs : dos.registers;
   curim,maxim,rc,sc,mx,cx,cy,a,b,c,t,x,y,width,height,color:byte;
   image:array[0..50] of array[0..32] of array[0..22] of byte;
   mess1,mess2:string[80];
   dac:array[0..767] of byte;
   fstr:string[5];
   key,ac,bc,cc:char;
   tex,tex2,tex3:text;
   dacfile : file;
   fname:string[40];
   exam:file;
   w,tt,fsav,mwidth,mheight,count,pixels,fsiz:integer;
   dax : array[0..767] of byte;
{----------------------------------------------------------------------------}
procedure eightby8; begin regs.ax:=$13;intr($10,regs);end;
{----------------------------------------------------------------------------}
procedure fixset; begin
  regs.ax:=3;intr($10,regs);
end;
{----------------------------------------------------------------------------}
procedure mouse_init; begin
  regs.ax:=0;intr($33,regs);                          {Mouse..Full reset}
  regs.ax:=7;regs.cx:=8;regs.dx:=613;intr($33,regs);  {Left/Right Boundery}
  regs.ax:=8;regs.cx:=0;regs.dx:=184;intr($33,regs);  {Up/Down Boundery}
  regs.ax:=9;regs.cx:=0;regs.es:=seg(mdat);regs.dx:=ofs(mdat);intr($33,regs);
                                                      {^^Finger mouser}
  regs.ax:=15;regs.cx:=10;regs.dx:=17;intr($33,regs); {Sensitivity}
end;
{----------------------------------------------------------------------------}
procedure mouse_on;begin
          regs.ax:=1;intr($33,regs);
end;
{----------------------------------------------------------------------------}
procedure mouse_off;begin
          regs.ax:=2;intr($33,regs);
end;
{----------------------------------------------------------------------------}
procedure tellcolor; begin
for cy:=0 to 10 do for cx:=0 to 17 do mem[$ad19:(cy*320)+cx+7]:=color;
gotoxy(28,25);write(color,'  ');
end;
{----------------------------------------------------------------------------}
procedure table; begin color:=0;count:=308;
for a:=0 to 7 do
    begin
         for y:=0 to 30 do
             begin
                  for cy:=0 to 3 do
                      for x:=0 to 4 do
                          mem[$a000:count+((cy+(y*6))*320)+x]:=color;color:=succ(color);
             end;
             count:=count-8;
    end;
end;
{----------------------------------------------------------------------------}
procedure plot; begin
if mem[$a000:x*7+(y*2560)+1931]=0 then
   begin
        for cy:=1 to 6 do
            for cx:=1 to 5 do mem[$a000:x*7+((cy+4)*320)+(y*2560)+9+cx]:=color;
        mem[$aaad:(y*320)+x]:=color;image[curim][x][y]:=color;
   end;
end;
{----------------------------------------------------------------------------}
procedure plot_off; begin
if mem[$a000:x*7+(y*2560)+1931]<>0 then
   begin
        for cy:=1 to 6 do
            for cx:=1 to 6 do mem[$a000:x*7+((cy+4)*320)+(y*2560)+9+cx]:=0;
        mem[$aaad:(y*320)+x]:=0;image[curim][x][y]:=0;
   end;
end;
{----------------------------------------------------------------------------}
procedure plotim;
var
   oldcol:byte;
begin
     mouse_off;oldcol:=color;
     for y:=0 to height do
         for x:=0 to width do
             begin
                  color:=image[curim][x][y];
                  for cy:=1 to 6 do
                      for cx:=1 to 5 do mem[$a000:x*7+((cy+4)*320)+(y*2560)+9+cx]:=color;
                  mem[$aaad:(y*320)+x]:=color;image[curim][x][y]:=color;
             end;
     color:=oldcol;tellcolor;mouse_on;
     gotoxy(39,25);write(curim,' ');
end;
{----------------------------------------------------------------------------}
procedure imp_dac;
BEGIN
     WITH regs DO
     BEGIN
          ax:=$1012;bx:=0;cx:=256;dx:=ofs(dax);es:=seg(dax);
          intr($10,regs);
     END;
END;
{----------------------------------------------------------------------------}
procedure mod_dac;
var
   range:integer;

begin
     range := (regs.dx+9) div 8;
     if regs.bx=1 THEN
      BEGIN
        case range of

          1 : dec(dax[color*3]);
          3 : inc(dax[color*3]);
          5 : dec(dax[color*3+1]);
          7 : inc(dax[color*3+1]);
          9 : dec(dax[color*3+2]);
         11 : inc(dax[color*3+2]);
        END;
        imp_dac;
        range:=1000;
        repeat regs.ax:=3;intr($33,regs);dec(range);
        until (regs.bx=0) or (range=0);
      END;
end;
{----------------------------------------------------------------------------}
procedure writedn(anx,any:byte;str:string);
var
   n:byte;

begin
     for n:=1 to ord(str[0]) DO
     begin
          gotoxy(anx,any-1+n);
          write(str[n]);
     END;
end;
{----------------------------------------------------------------------------}
procedure setcol; begin
if mem[$a000:x*7+(y*2560)+1931]<>0 then
   begin
        color:=mem[$a000:x*7+(y*2560)+1931];
        tellcolor;
   end;
end;
{----------------------------------------------------------------------------}
begin
  directvideo:=false;
  textcolor(2);fname:='';if paramcount=1 then fname:=paramstr(1);
  if (pos('.',fname)<>0) or (fname='') then begin writeln('FORMAT -- EDIT [NAME]');halt(1);end;

  regs.bx:=255;regs.ax:=3;intr($33,regs);
  if regs.bx=255 then begin
  clrscr;mess1:='                                                  Where the hell is MOUSE.COM?';
          for mx:=1 to 74 do
                   begin
                        gotoxy(1,5);mess2:=mess1;delete(mess2,1,74-mx);write(mess2);
                   end;
     halt(1);
     end else begin mouse_off;mouse_init;end;

width:=0;maxim:=0;
for c:=0 to 50 do
    for a:=0 to 32 do
        for b:=0 to 22 do
            image[c][a][b]:=0;

repeat
      str(maxim,fstr);while ord(fstr[0])<>3 do insert('0',fstr,1);
      assign(exam,fname+'.'+fstr);{$I-} reset(exam,1);cx:=ioresult;
      if cx=0 then
         begin
              fsiz:=filesize(exam);close(exam);assign(tex,fname+'.'+fstr);reset(tex);
              read(tex,ac);width:=ord(ac);read(tex,ac);height:=ord(ac);
              for y:=0 to height do
                  for x:=0 to width do
                      begin
                           read(tex,ac);image[maxim][x][y]:=ord(ac);
                      end;
              close(tex);
         maxim:=succ(maxim);
         end;
until cx<>0;if maxim>0 then maxim:=pred(maxim);curim:=0;

repeat
      textcolor(13);clrscr;color:=9;
      if width=0 then
         begin
              write('Width:');readln(width);
              write('Height:');readln(height);
         end;
         if (width>32) or (height>22) then width:=0;
until width<>0;

eightby8;table;

with regs do
begin
     ax:=$1017;bx:=0;cx:=256;dx:=ofs(dax);es:=seg(dax);
     intr($10,regs);
end;

mwidth:=width*14+19;mheight:=height*8+10;
count:=1;if width>13 then count:=0;
if width>21 then count:=-1;if width>29 then count:=-2;
write('');for t:=1 to width+count do write('');gotoxy(wherex-1,wherey);write('');gotoxy(1,wherey+1);
for a:=1 to height do begin
                           write('');gotoxy(width+count+1,wherey);writeln('');
                      end;
write('');for t:=1 to width+count do write('');gotoxy(wherex-1,wherey);write('');gotoxy(1,wherey+1);
gotoxy(27,21);write('Ŀ');
gotoxy(27,22);write('  ');
gotoxy(27,23);write('');
gotoxy(33,25);write('Image:');

writedn(31,1,'<R> <G> <B>');

assign(dacfile,'..\dtable');{$I-} reset(dacfile,1); {$I+}
if ioresult=0 then
BEGIN
     blockread(dacfile,dax,768);
     close(dacfile);
    FOR w := 2 TO 31 DO
        FOR t := (w*8)+1 TO (w*8)+7 DO
        BEGIN
             dax[t*3] := 0;
             dax[t*3+1] := 0;
             dax[t*3+2] := 0;
        END;
     imp_dac;
END;
plotim;color:=1;tellcolor;

mouse_on;key:=' ';imp_dac;
repeat
         regs.ax:=3;intr($33,regs);
         if (regs.cx<mwidth) and (regs.dx<=mheight) then
            case regs.bx of
                 1:begin x:=(regs.cx-8) div 14;y:=(regs.dx-4) div 8;mouse_off;plot;mouse_on;end;
                 2:begin x:=(regs.cx-8) div 14;y:=(regs.dx-4) div 8;mouse_off;plot_off;mouse_on;end;
                 4:begin x:=(regs.cx-8) div 14;y:=(regs.dx-4) div 8;mouse_off;setcol;mouse_on;end;
            end;

         if (regs.cx>dacx1) and (regs.cx<dacx2) then mod_dac;

         if (regs.cx>=494) and (regs.bx=1) then
            begin
                 sc:=0;rc:=0;regs.cx:=regs.cx-494;while regs.cx>=16 do begin regs.cx:=regs.cx-16;sc:=succ(sc);end;
                 if regs.cx<8 then
                    begin
                         while regs.dx>5 do begin regs.dx:=regs.dx-6;rc:=rc+1;end;
                               if (regs.dx<5) and (not (rc in [0,16]) or (sc<>7)) then
                                  begin
                                       color:=(7-sc)*31+rc;tellcolor;
                                  end;
                    end;
            end;
         if (regs.bx=6) and (curim<maxim) and ((regs.cx>=mwidth) or (regs.dx>mheight)) then begin
            curim:=succ(curim);plotim;regs.ax:=3;repeat intr($33,regs);until regs.bx=0;end;
         if (regs.bx=5) and (curim>0) and ((regs.cx>=mwidth) or (regs.dx>mheight)) then begin
            curim:=pred(curim);plotim;regs.ax:=3;repeat intr($33,regs);until regs.bx=0;end;
         if regs.bx=3 then
            begin
                 gotoxy(1,25);write('Command [C/D/Q/S/I]:');
                 repeat key:=readkey;if keypressed then key:=readkey;
                 until (key in ['q','a','c','d','s',#27,#72,#80,#75,#77,#73,#81,'\']);
                 gotoxy(1,25);write('                    ');
                 case key of
                      'c':begin maxim:=succ(maxim);curim:=maxim;plotim;end;
                      'd':if maxim>0 then begin maxim:=pred(maxim);curim:=maxim;plotim;end;
                      'q':begin
                               gotoxy(1,25);write('Confirm [Y/N]:');
                               repeat key:=upcase(readkey);until (key in ['Y','N']);
                               if key='Y' then begin regs.ax:=3;intr($10,regs);halt(0);end;
                          end;
                      's':regs.bx:=17;
                      #72:begin
                               for y:=1 to height do
                                   for x:=0 to width do image[curim][x][y-1]:=image[curim][x][y];
                               for t:=0 to width do image[curim][t][height]:=0;
                               plotim;
                          end;
                      #80:begin
                               for y:=height-1 downto 0 do
                                   for x:=0 to width do image[curim][x][y+1]:=image[curim][x][y];
                               for t:=0 to width do image[curim][t][0]:=0;
                               plotim;
                          end;
                      #75:begin
                               for x:=1 to width do
                                   for y:=0 to height do image[curim][x-1][y]:=image[curim][x][y];
                               for t:=0 to height do image[curim][width][t]:=0;
                               plotim;
                          end;
                      #77:begin
                               for x:=width-1 downto 0 do
                                   for y:=0 to height do image[curim][x+1][y]:=image[curim][x][y];
                               for t:=0 to height do image[curim][0][t]:=0;
                               plotim;
                          end;
                      #73:begin
                               for y:=0 to height do
                                   for x:=0 to trunc(width/2) do
                                       begin
                                            sc:=image[curim][x][y];
                                            image[curim][x][y]:=image[curim][width-x][y];
                                            image[curim][width-x][y]:=sc;
                                        end;
                               plotim;
                          end;
                      #81:begin
                               for x:=0 to width do
                                   for y:=0 to trunc(height/2) do
                                       begin
                                            sc:=image[curim][x][y];
                                            image[curim][x][y]:=image[curim][x][height-y];
                                            image[curim][x][height-y]:=sc;
                                        end;
                               plotim;
                          end;
                      '\':if curim=maxim then
                             begin
                                  for x:=0 to width do
                                      for y:=0 to height do
                                          image[curim+1][x][y]:=image[curim][x][y];
                                  curim:=succ(curim);maxim:=curim;plotim;
                             end;
                 end;
            end;
until regs.bx=17;
fixset;pixels:=(width+1)*(height+1)+1;count:=15;regs.ax:=3;intr($10,regs);
assign(tex2,fname+'u.pas');rewrite(tex2);
writeln(tex2,'UNIT ',fname,'u;',#13#10#13#10,'INTERFACE',#13#10#13#10,'CONST',#13#10);
write(tex2,'     '+fname+':array[0..',maxim,',0..',pixels,'] of byte=((');

for t:=0 to maxim do
    begin
         write(tex2,width,',',height,',');
         str(t,fstr);while ord(fstr[0])<>3 do insert('0',fstr,1);
         assign(tex,fname+'.'+fstr);rewrite(tex);
         write(tex,chr(width),chr(height));
         for y:=0 to height do
             for x:=0 to width do
                 begin
                      write(tex,chr(image[t][x][y]));
                      write(tex2,image[t][x][y]);if (x<>width) or (y<>height) then write(tex2,',');
                      count:=succ(count);
                      if count mod 20=0 then
                         begin
                              writeln(tex2);write(tex2,'               ');
                         end;
                 end;
         close(tex);if (t<>maxim) then
                       begin write(tex2,'),(');end;
    end;
    write(tex2,'));');writeln(tex2);
    writeln(tex2,'IMPLEMENTATION',#13#10,'END.');
    close(tex2);
    assign(dacfile,'..\dtable');{$I-} rewrite(dacfile,1); {$I+}
    FOR w := 0 to 767 do dax[w] := dax[w] and 63;
    FOR w := 2 TO 31 DO
        FOR tt := (w*8)+1 TO (w*8)+7 DO
        BEGIN
             dax[tt*3] := dax[w*8*3+0];
             dax[tt*3+1] := dax[w*8*3+1];
             dax[tt*3+2] := dax[w*8*3+2];
        END;
    blockwrite(dacfile,dax,768);close(dacfile);
end.

