USES
    Dos;

TYPE
    corc = RECORD
              x,y : WORD;
           END;

    descript = RECORD
                x,y : WORD;
                typ : SHORTINT;
                kill : BOOLEAN;
               END;
    Custom_Header = RECORD
                        title : STRING[18];
                        fname : NameStr;
                        ndots : WORD;
                        size1 : WORD;
                        size2 : WORD;
                    END;

VAR
   fn : STRING;
   t,a : WORD;
   f : FILE;
   k,z : BYTE;
   pix : ARRAY[1..6] OF WORD;
   tab : ARRAY[1..1000,1..6] OF corc;
   tasize : ARRAY[1..30] OF BYTE;
   tasks : ARRAY[1..30,1..100] OF descript;
   sstr : Custom_Header;

PROCEDURE Load_Table;
BEGIN
     Assign(f,fn+'.scn');{$I-} Reset(f,1); {$I+}
     FOR a := 1 TO 6 DO pix[a] := 0;
     IF ioresult <> 0 THEN Halt;
     FOR a := 1 TO 6 DO
     BEGIN
          BlockRead(f,pix[a],2);
          FOR t := 1 TO pix[a] DO
              BlockRead(f,tab[t][a],SizeOF(corc));
     END;
     BlockRead(f,tasize,Sizeof(tasize));
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN
          BlockRead(f,tasks[t],tasize[t]*Sizeof(descript));
     Close(f);
END;

PROCEDURE ScrSave(fnn : STRING);
VAR
   d : TEXT;
   zz,
   v : word;

BEGIN
     v := 0;zz := 0;
     FOR a := 1 TO 17 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;sstr.title := 'UNKNOWN';sstr.fname := fnn;sstr.ndots := 0;
     Inc(v,(pix[1]+zz)*4 + 1);
     Assign(d,fnn+'.scr');ReWrite(d);
     t := pix[1]+pix[2]+pix[3]+pix[4]+pix[5]+pix[6];
     sstr.size1 := t*6+2;
     sstr.size2 := v*2+2;
     Write(d,Chr(lo(sstr.size1+sstr.size2+SizeOf(Custom_Header))),
             Chr(hi(sstr.size1+sstr.size2+SizeOf(Custom_Header))));
     FOR z := 0 TO 18 DO Write(d,sstr.title[z]);
     FOR z := 0 TO 8 DO Write(d,sstr.fname[z]);
     Write(d,chr(lo(sstr.ndots)),chr(hi(sstr.ndots)));
     Write(d,Chr(lo(sstr.size1)),Chr(hi(sstr.size1)));
     Write(d,Chr(lo(sstr.size2)),Chr(hi(sstr.size2)));
     write(d,chr(lo(t)),chr(hi(t)));
     v := 0;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN v := a;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN
     BEGIN
          FOR t := 1 TO pix[a] DO
          BEGIN
               Write(d,chr(lo(tab[t,a].x)),chr(hi(tab[t,a].x)),
                       chr(lo(tab[t,a].y)),chr(hi(tab[t,a].y)),
                       chr(lo(a)),chr(hi(a)));
          END;
     END;
     v := 0;zz := 0;
     FOR a := 1 TO 17 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;
     Inc(v,(pix[1]+zz)*4 + 1);

     write(d,chr(lo(pix[1])),chr(hi(pix[1])));
     v := pix[1]+zz;
     z := 0;
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN Inc(z);
     FOR t := 1 TO pix[1]+zz DO
     BEGIN
          write(d,chr(lo(tab[t,1].x)),chr(hi(tab[t,1].x)),
                  chr(lo(tab[t,1].y)),chr(hi(tab[t,1].y)),
                  chr(lo(v)),chr(hi(v)));
          Inc(v,tasize[t]);Write(d,chr(lo(v-1)),chr(hi(v-1)));
     END;
     v := 0;z := 0;
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN Inc(v);
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN
     BEGIN
          Inc(z);
          FOR a := 1 TO tasize[t] DO
          BEGIN
               write(d,chr(lo(tasks[t,a].x)),chr(hi(tasks[t,a].x)),
                       chr(lo(tasks[t,a].y)),chr(hi(tasks[t,a].y)),
                       chr(lo(tasks[t,a].typ)),chr(hi(tasks[t,a].typ)),
                       chr(lo(ord(tasks[t,a].kill))),chr(hi(ord(tasks[t,a].kill))));
          END;
     END;
     Close(d);
END;

BEGIN
     fn := paramstr(1);
     Load_Table;
     ScrSave(fn);
END.
