USES
    Dos;

TYPE
    corc = RECORD
              x,y : WORD;
           END;

    descript = RECORD
                x,y : WORD;
                typ : SHORTINT;
                kill : BOOLEAN;
               END;
    Custom_Header = RECORD
                        title : STRING[18];
                        fname : NameStr;
                        ndots : WORD;
                        size1 : WORD;
                        size2 : WORD;
                    END;
    RAYP = ARRAY[0..1000] OF WORD;
   PNT = ^RAYP;

VAR
   fn : STRING;
   t,a : WORD;
   f : FILE;
   k,z : BYTE;
   pix : ARRAY[1..6] OF WORD;
   tab : ARRAY[1..1000,1..6] OF corc;
   tasize : ARRAY[1..30] OF BYTE;
   tasks : ARRAY[1..30,1..100] OF descript;
   tstr,sstr : Custom_Header;

PROCEDURE Load_Table;
VAR
   dat,tas : PNT;

BEGIN
     FOR a := 1 TO 6 DO pix[a] := 0;
     FOR a := 1 TO 30 DO tasize[a] := 0;
     Assign(f,fn+'.scr');{$I-} Reset(f,1);{$I+}
     IF (ioresult <> 0) OR (filesize(f) < SizeOf(Custom_Header)+2) THEN Halt(0);
     Seek(f,2);BlockRead(f,sstr,SizeOf(Custom_Header));Close(f);
     Assign(f,fn+'.scr');{$I-} Reset(f,1);Seek(f,0); {$I+} 
     IF ioresult <> 0 THEN exit;

     Seek(f,2);BlockRead(f,tstr,SizeOf(Custom_Header));
     New(dat);New(tas);
     {$I-} BlockRead(f,dat^,tstr.size1);{$I+}
     IF ioresult = 0 THEN FOR t := 0 TO dat^[0]-1 DO
     BEGIN
          Inc(pix[dat^[t*3+3]]);
          tab[pix[dat^[t*3+3]],dat^[t*3+3]].x := dat^[t*3+1];
          tab[pix[dat^[t*3+3]],dat^[t*3+3]].y := dat^[t*3+2];
     END;
     {$I-} BlockRead(f,tas^,tstr.size2-2);{$I+} Close(f);
     IF ioresult = 0 THEN
     FOR t := 0 TO tas^[0]-1 DO
     BEGIN
          FOR z := tas^[t*4+3] TO tas^[t*4+4] DO
          BEGIN
               Inc(tasize[t+1]);
               tasks[t+1,tasize[t+1]].x := tas^[z*4+1];
               tasks[t+1,tasize[t+1]].y := tas^[z*4+2];
               tasks[t+1,tasize[t+1]].typ := tas^[z*4+3];
               tasks[t+1,tasize[t+1]].kill := tas^[z*4+4] > 0;
          END;
     END;
     Dispose(dat);Dispose(tas);
END;

PROCEDURE Save_Table;
VAR
   d : TEXT;
   zz,
   v : word;
BEGIN
     Assign(f,fn+'.scn');{$I-} ReWrite(f,1); {$I+}
     FOR a := 1 TO 6 DO
     BEGIN
          BlockWrite(f,pix[a],2);
          FOR t := 1 TO pix[a] DO
              BlockWrite(f,tab[t][a],SizeOF(corc));
     END;
     BlockWrite(f,tasize,Sizeof(tasize));
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN
          BlockWrite(f,tasks[t],tasize[t]*SizeOf(descript));
     Close(f);
END;

BEGIN
     fn := paramstr(1);
     Load_Table;
     Save_Table;
END.
