{$I Defines.inc}
UNIT Editor;

INTERFACE

USES
    Dact,Dos,Crt1,Routines,Writesu,Globals,FX,
    pel1u,gird1u,ladd1u,jman1u,ropes1u;

PROCEDURE WorkStation;

TYPE
    corc = RECORD
              x,y : WORD;
           END;

    descript = RECORD
                x,y : WORD;
                typ : SHORTINT;
                kill : BOOLEAN;
               END;
    tabt = ARRAY[1..1000,1..6] OF corc;
    taskt = ARRAY[1..17,1..100] OF descript;

VAR
   ks,fn : STRING;
   t,a : INTEGER;
   cor : corc;
   k,z : BYTE;
   ke : CHAR;
   curstep,usestep,
   curstep2,usestep2,
   fl,
   x1,y1 : WORD;
   pix : ARRAY[1..6] OF WORD;
   tab : ^tabt;
   tasize : ARRAY[1..17] OF BYTE;
   tasks : ^taskt;
   curtask : BYTE;
   ontop,saved,
   drawmode : BOOLEAN;
   citem : RECORD
              x,y,cofs : WORD;
              k        : BYTE;
           END;
   found : BOOLEAN;
   tstr,sstr : Custom_Header;
   lastim : ARRAY[0..5] OF INTEGER;
   curimz      : ARRAY[0..255] OF BYTE;

IMPLEMENTATION

{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE DrawImage(x,y,point : WORD;
                    remove : BOOLEAN;rmb : BYTE);ASSEMBLER;
VAR
   drawx : WORD;
   wd,ht : BYTE;

ASM
        mov     si,[point]
        mov     bx,[y]
        mov     dl,[remove]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        mov     [drawx],ax
        add     di,ax
        mov     ax,WORD [b64k+2] {0a000h}
        mov     es,ax
        mov     al,[si]
        mov     [wd],al
        inc     [wd]
        mov     al,[si+1]
        mov     [ht],al
        add     si,2
        cld
        xor     cx,cx
@di1:   mov     cl,[wd]
        mov     bx,[drawx]
@di2:   cmp     bx,0
        js      @nomov
        cmp     bx,319
        jg      @nomov
        mov     al,[si]
        or      al,al
        jz      @nomov
        or      dl,dl
        jz      @dodr
        mov     al,BYTE [es:di]
        and     al,[rmb]
@dodr:  {mov     BYTE [es:di],al}
        call    WriteEsDiAl
@nomov: inc     di
        inc     si
        inc     bx
        loop    @di2
        add     di,320
        mov     al,[wd]
        cbw
        sub     di,ax
        dec     [ht]
        jns     @di1
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Moveimage(x,y,pointb,point : WORD;
                    direct : BOOLEAN) : WORD;ASSEMBLER;

VAR
   movres,hilim,
   xsize,ysize : WORD;
   endy,starty,
   endx,startx : BYTE;

ASM
        push    ds
        pop     es
        xor     bx,bx
        mov     si,[point]
        lodsb
        cbw
        mov     [xsize],ax
        sub     ax,5
        mov     [hilim],ax
        lodsb
        inc     ax
        mov     [ysize],ax
        mov     al,[direct]

        mov     bx,[pointb]
        shl     bx,1
        shl     bx,1
        mov     di,offset [curimz]
        or      al,al
        jz      @normd
        mov     dx,[ysize]
@flpls: mov     cx,[xsize]
        inc     cx
        add     si,[xsize]
@flpl:  mov     al,[si]
        stosb                           (*Mirror image*)
        dec     si
        loop    @flpl
        add     si,[xsize]
        inc     si
        inc     si
        dec     dl
        jns     @flpls
        jmp     @dresume
@normd: mov     ax,[xsize]
        inc     ax
        mul     [ysize]
        mov     cx,ax

        rep     movsb                   (* New image @ 'curim' *)

@dresume:
        mov     si,offset curimz
        mov     bx,[y]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        add     di,ax                   (*DI = Screen location*)

        mov     ax,WORD [b64k+2]
        mov     es,ax                   (*ES = Screen SEG*)
        mov     dx,[ysize]              (*Get Y size*)
        mov     movres,0
@mtosc: mov     cx,[xsize]
        inc     cx
        or      dl,dl
@mtos:  lodsb                           (*Read curim*)
        mov     ah,BYTE [es:di]
        and     ah,7
        or      dl,dl
        jz      @okat2
        or      al,al
        jz      @zoko
        mov     al,$f8
        cmp     ah,4
        jle     @okat1
        cmp     ah,8
        jge     @okat1
        or      [movres],4
@okat1: cmp     ah,1
        jnz     @zoko
        cmp     cx,5
        jl      @okat2
        cmp     cx,[hilim]
        jg      @okat2
        or      [movres],3
@okat2: cmp     ah,1
        jnz     @zoko
        or      dl,dl
        jnz     @zoko
        or      [movres],1
@zoko:  or      dl,dl
        jz      @nmto
        or      al,ah
        call    WriteEsDiAl
{        mov     BYTE [es:di],al}
@nmto:  inc     di
        loop    @mtos
        add     di,319
        sub     di,[xsize]
        dec     dl
        jns     @mtosc

{----------------------------------- New image drawn ----}

        mov     di,offset lastim
        mov     ax,[di+0]
        sub     ax,[x]
        js      @leftward
        mov     bx,[xsize]
        inc     bx
        mov     [endx],bl
        sub     bx,ax
        mov     [startx],bl
        jmp     @conx

@leftward:
        neg     ax
        mov     [startx],0
        mov     [endx],al          {-}
@conx:  mov     ax,[di+2]
        sub     ax,[y]
        js      @downward
        mov     bx,[ysize]
        mov     [endy],bl
        sub     bx,ax
        mov     [starty],bl
        jmp     @cony
@downward:
        neg     ax
        mov     [starty],0
        dec     al
        mov     [endy],al       {-}
@cony:  mov     di,offset lastim
        push    di
        mov     bx,[di+2]
        shl     bx,1
        mov     ax,WORD [bx+m320]            (*ax is y*)
        mov     si,[di]
        add     si,ax                   (*si = scnloc*)
        mov     bl,[starty]
        mov     bh,[endy]
        mov     dl,[startx]
        mov     dh,[endx]
        xor     cx,cx
@doy:   xor     cl,cl
@dox:   cmp     cl,dl
        jl      @chks1
        cmp     cl,dh
        jl      @toff
@chks1: cmp     ch,bl
        jl      @nope
        cmp     ch,bh
        jg      @nope

@toff:  mov     al,BYTE [es:si]
        and     al,7
        {or      al,15}
        xchg    si,di
        call    WriteEsDiAl
        xchg    si,di
{        mov     BYTE [es:si],al}
@nope:  inc     cl
        inc     si
        cmp     cl,BYTE [xsize]
        jbe     @dox
        add     si,319
        sub     si,[xsize]
        inc     ch
        cmp     ch,BYTE [ysize]
        jbe     @doy

        pop     di
        mov     ax,[x]
        mov     [di],ax
        mov     ax,[y]
        mov     [di+2],ax
        mov     ax,[movres]
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION GetOfs(n : BYTE) : WORD;
BEGIN
     CASE n OF
      1 : GetOfs := Ofs(pel1);
      2 : GetOfs := Ofs(gird1);
      3 : GetOfs := Ofs(ladd1);
      4 : GetOfs := Ofs(jman1[17]);
      5 : GetOfs := Ofs(ropes1[0]);
      6 : GetOfs := Ofs(ropes1[1]);
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE EgaWrOff;
BEGIN
     IF vmode = 1 THEN
     BEGIN
          portw[$3ce] := $0005;
          portw[$3ce] := $0f01;
          portw[$3ce] := $0003;
     END;
END;
PROCEDURE EgaWrOn;
BEGIN
     IF vmode = 1 THEN
     BEGIN
          portw[$3ce] := $0005;
          portw[$3ce] := $0001;
          portw[$3ce] := $0003;
          portw[$3ce] := $ff08;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION GetKey : STRING;
VAR
   n,m : BYTE;
   rs : STRING;
BEGIN
     m := 0;rs := '';
     IF key[29] THEN rs := #254 ELSE
        IF key[42] THEN rs := #255;
     FOR n := 0 TO 127 DO IF key[n] AND (NOT(n IN [29,42])) THEN rs := rs + keyd[n];
     GetKey := rs;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Load_DAC;
TYPE
    raya = ARRAY[0..767] OF BYTE;
VAR
   ray : ^raya;
BEGIN
     New(ray);
     FOR t := 0 to 767 DO ray^[t] := dactable[t];
     FOR t := 160*3 TO 192*3 DO ray^[t] := ray^[t-(128*3)];
     IF vmode = 2 THEN
     BEGIN
          port[$3c8] := 0;
          FOR t := 0 TO 767 DO port[$3c9] := ray^[t];
     END ELSE IF vmode = 1 THEN GameCols;
     Dispose(ray);
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE DrawIt(n,m,o : WORD);
BEGIN
     CASE n OF
      1 : DrawImage(m,o,GetOfs(1),FALSE,0);
      2 : DrawImage(m,o,GetOfs(2),FALSE,0);
      3 : DrawImage(m,o,GetOfs(3),FALSE,0);
      4 : DrawImage(m,o,GetOfs(4),FALSE,0);
      5 : DrawImage(m,o,GetOfs(5),FALSE,0);
      6 : DrawImage(m,o,GetOfs(6),FALSE,0);
     END;
END;
PROCEDURE SetVGA;
BEGIN
     directvideo := FALSE;
{     r.ax := $13;Intr($10,r);}
     SetHires;
     Load_DAC;
{     IF port[$3da] < 256 THEN IF port[$3ba] = 0 THEN;
     port[$3c0] := $11;port[$3c0] := 2;port[$3c0] := $20;}
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Choose_1(sp : BYTE) : STRING;
VAR
   ts : STRING[8];
   kk : BYTE;

BEGIN
     IF t > 0 THEN
     BEGIN
          FOR z := 1 TO t DO WITH scrnames[0,z] DO
          BEGIN
               GotoXY(1,z);Write(fname);
               GotoXY(40,z);Write(title);
          END;z := sp;
          REPEAT
                GotoXY(1,z);
                TextColor(14);TextBackGround(1);
                ts := scrnames[0,z].fname;
                Write(ts);gotoxy(40,z);Write(scrnames[0,z].title);
                REPEAT kk := GetAKey2 UNTIL kk IN [72,80,28,1];
                IF (kk = 72) AND (z > 1) THEN
                BEGIN
                     GotoXY(1,z);TextBackGround(0);
                     Write(scrnames[0,z].fname);
                     GotoXY(40,z);Write(scrnames[0,z].title);
                     Dec(z);
                END ELSE
                IF (kk = 80) AND (z < t) THEN
                BEGIN
                     GotoXY(1,z);TextBackGround(0);
                     Write(scrnames[0,z].fname);
                     GotoXY(40,z);Write(scrnames[0,z].title);
                     Inc(z);
                END;
          UNTIL kk IN [1,28];
          IF kk = 1 THEN ts := '';
     END ELSE ts := '';
     TextBackGround(0);
     Choose_1 := ts;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE GetScrnames;
VAR
   junk : ExtStr;
   junk2 : DirStr;

BEGIN
     t := 0;
     REPEAT
           IF t = 0 THEN FindFirst('*.scr',Archive,scrs) ELSE FindNext(scrs);
           z := DosError;
           IF z = 0 THEN
           BEGIN
                Inc(t);
                FSplit(scrs.name,junk2,scrnames[0,t].fname,junk);
                Assign(f,scrnames[0,t].fname+'.scr');{$I-} Reset(f,1);Seek(f,0);{$I+}
                IF (ioresult = 0) AND (FileSize(f) > SizeOf(Custom_Header)) THEN
                BEGIN
                     Seek(f,2);
                     BlockRead(f,tstr,SizeOf(Custom_Header));
                     Close(f);
                     scrnames[0,t].title := tstr.title;
                END ELSE Dec(t);
           END;
     UNTIL z <> 0;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Get_A_Scr : STRING;
BEGIN
     r.ax := 3;Intr($10,r);GetScrnames;
     TextColor(14);GotoXY(1,25);
     Write('Cursor UP/DOWN to select screen.   [ESC] = New Screen or Abort.');
     Get_A_Scr := Choose_1(1);
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Load_Table;
VAR
   dat,tas : PNT;

BEGIN
     FOR t := 0 TO 5 DO lastim[t] := 0;
     FOR a := 1 TO 6 DO pix[a] := 0;
     fn := Get_A_Scr;
     Assign(f,fn+'.scr');{$I-} Reset(f,1);{$I+}
     IF (ioresult <> 0) OR (filesize(f) < SizeOf(Custom_Header)+2) THEN Exit;
     Seek(f,2);BlockRead(f,sstr,SizeOf(Custom_Header));Close(f);
     Assign(f,fn+'.scr');{$I-} Reset(f,1);Seek(f,0); {$I+}
     IF ioresult <> 0 THEN exit;

     Seek(f,2);BlockRead(f,tstr,SizeOf(Custom_Header));
     New(dat);New(tas);
     {$I-} BlockRead(f,dat^,tstr.size1);{$I+}
     IF ioresult = 0 THEN FOR t := 0 TO dat^[0]-1 DO
     BEGIN
          Inc(pix[dat^[t*3+3]]);
          tab^[pix[dat^[t*3+3]],dat^[t*3+3]].x := dat^[t*3+1];
          tab^[pix[dat^[t*3+3]],dat^[t*3+3]].y := dat^[t*3+2];
     END;
     {$I-} BlockRead(f,tas^,tstr.size2-2);{$I+} Close(f);
     IF ioresult = 0 THEN
     FOR t := 0 TO tas^[0]-1 DO
     BEGIN
          FOR z := tas^[t*4+3] TO tas^[t*4+4] DO
          BEGIN
               Inc(tasize[t+1]);
               tasks^[t+1,tasize[t+1]].x := tas^[z*4+1];
               tasks^[t+1,tasize[t+1]].y := tas^[z*4+2];
               tasks^[t+1,tasize[t+1]].typ := tas^[z*4+3];
               tasks^[t+1,tasize[t+1]].kill := tas^[z*4+4] > 0;
          END;
     END;
     Dispose(dat);Dispose(tas);
END;

PROCEDURE ScrSave(fnn : STRING);
VAR
   d : TEXT;
   zz,
   v : word;

BEGIN
     v := 0;zz := 0;
     FOR a := 1 TO 17 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;
     Inc(v,(pix[1]+zz)*4 + 1);
     Assign(d,fnn+'.scr');ReWrite(d);
     t := pix[1]+pix[2]+pix[3]+pix[4]+pix[5]+pix[6];
     sstr.size1 := t*6+2;
     sstr.size2 := v*2+2;
     Write(d,Chr(lo(sstr.size1+sstr.size2+SizeOf(Custom_Header))),
             Chr(hi(sstr.size1+sstr.size2+SizeOf(Custom_Header))));
     FOR z := 0 TO 18 DO Write(d,sstr.title[z]);
     FOR z := 0 TO 8 DO Write(d,sstr.fname[z]);
     Write(d,chr(lo(sstr.ndots)),chr(hi(sstr.ndots)));
     Write(d,Chr(lo(sstr.size1)),Chr(hi(sstr.size1)));
     Write(d,Chr(lo(sstr.size2)),Chr(hi(sstr.size2)));
     write(d,chr(lo(t)),chr(hi(t)));
     v := 0;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN v := a;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN
     BEGIN
          FOR t := 1 TO pix[a] DO
          BEGIN
               Write(d,chr(lo(tab^[t,a].x)),chr(hi(tab^[t,a].x)),
                       chr(lo(tab^[t,a].y)),chr(hi(tab^[t,a].y)),
                       chr(lo(a)),chr(hi(a)));
          END;
     END;
     v := 0;zz := 0;
     FOR a := 1 TO 17 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;
     Inc(v,(pix[1]+zz)*4 + 1);

     write(d,chr(lo(pix[1])),chr(hi(pix[1])));
     v := pix[1]+zz;
     z := 0;
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN Inc(z);
     FOR t := 1 TO pix[1]+zz DO
     BEGIN
          write(d,chr(lo(tab^[t,1].x)),chr(hi(tab^[t,1].x)),
                  chr(lo(tab^[t,1].y)),chr(hi(tab^[t,1].y)),
                  chr(lo(v)),chr(hi(v)));
          Inc(v,tasize[t]);Write(d,chr(lo(v-1)),chr(hi(v-1)));
     END;
     v := 0;z := 0;
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN Inc(v);
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN
     BEGIN
          Inc(z);
          FOR a := 1 TO tasize[t] DO
          BEGIN
               write(d,chr(lo(tasks^[t,a].x)),chr(hi(tasks^[t,a].x)),
                       chr(lo(tasks^[t,a].y)),chr(hi(tasks^[t,a].y)),
                       chr(lo(tasks^[t,a].typ)),chr(hi(tasks^[t,a].typ)),
                       chr(lo(ord(tasks^[t,a].kill))),chr(hi(ord(tasks^[t,a].kill))));
          END;
     END;
     Close(d);
END;

FUNCTION MkTemp : STRING;
VAR
   c : DateTime;
   k : WORD;
   tm : LONGINT;
   ss : STRING;

BEGIN
     GetTime(c.Hour,c.Min,c.Sec,k);
     GetDate(c.Year,c.Month,c.Day,k);
     PackTime(c,tm);
     Str(tm,ss);
     WHILE Ord(ss[0]) > 8 DO Delete(ss,1,1);
     WHILE Ord(ss[0]) < 8 DO ss := '0' + ss;
     MkTemp := ss;
END;

{$F+} PROCEDURE nut;BEGIN END;{$F-}

PROCEDURE Test_Screen;
VAR
   pm1,pm2 : POINTER;
   f : FILE;
   fn2 : STRING[8];
   ndts : BYTE;
   ts2 : STRING[1];

PROCEDURE Test_Play(pmm1, pmm2 : PNT);
VAR
   plstop1,
   gplay1,gplay2 : BOOLEAN;
   lastabs,
   lastabs2 : LONGINT;
   pls : BYTE;
   n : BYTE;

BEGIN
   Game_Music := FALSE;
   Modify(@nut,@nut,@nut,@nut,@nut,@nut,@nut);
   FX_Init(TRUE);disapp := FALSE;p[12] := p[1];
   plstopnow := FALSE;pl := 1;
   WITH p[pl] DO
   BEGIN
{        r.ax := $13;Intr($10,r);}
        SetHires;{GameCols;}
        abstime := 0;jpump := 20;jump := FALSE;jumpup := FALSE;
        special := FALSE;plstop1 := FALSE;wasmoving := FALSE;
        GenDraw(pmm1,pmm2);cbeg;altat := 0;btick := START_BTICK;
        TextBackGround(0);TextColor(6);GotoXY(1,24);EgaWrOn;
        Write('Using how many bullets (ENTER = 0) : ');
        ts2 := GetInp2(1,FALSE);
        Val(ts2,ndts,t);
        IF (t > 0) OR (ndts > 6) THEN ndts := 0;
        GotoXY(1,24);WriteLn('                                      ');
        Write('Testing : ',sstr.title);EgaWrOff;
        WITH p[1] DO
        BEGIN
             FOR t := 0 TO 25 DO pels[t] := FALSE;
             next_speed := 3;lives := 120;
             idevice := 0;
             keys[0] := 75;
             keys[1] := 77;
             keys[2] := 72;
             keys[3] := 80;
             keys[4] := 57;
        END;
        WHILE (lives > 0) AND (NOT plstop1) AND (NOT plstopnow) DO
        BEGIN
          FOR t := 1 TO 10 DO WITH dots[t] DO on := FALSE;
          im := 0;killed := FALSE;
          scn[0] := #20;p[pl].x := plsx;p[pl].y := plsy;
          jump := FALSE;jumpup := FALSE;
          abstime := 0;lastabs := 0;lastabs2 := 0;
          speed := next_speed;last_score := score;
          Draw_Man;pdeath := 0;
          REPEAT
                gplay1 := abstime-lastabs > PLAYSPEED[speed];
                gplay2 := (abstime-lastabs2 > DIESPEED) AND (p[pl].pdeath > 1);
                IF gplay1 THEN lastabs := abstime;
                IF gplay2 THEN lastabs2 := abstime;
                IF pdeath = 50 THEN cproc;
                IF gplay1 OR gplay2 THEN
                BEGIN
                     rres := Routines.MoveImage(x,y,pl,Ofs(jman1[im]),
                                            32,32,255,NOT dir);
                     res := rres AND 15;
                     IF NOT ( (x > -5) AND (x < 309) ) THEN res := 0;
                     IF res AND 4 = 4 THEN Pel_Hit(pmm2);
                     IF (res AND 8 = 8) AND (pdeath < 2) THEN
                     BEGIN
                          pdeath := 2;
                          pumps := 0;
                     END;
                     IF (pdeath < 2) AND gplay1 THEN
                     BEGIN
                          Check_Ladder;MovePlayer;
                          Check_Ladder;Check_Green;
                          MoveDots(ndts,TRUE);
                          IF (ltouch < 5) OR ((res AND 7)>0) THEN pdeath := 0;
                     END ELSE IF pdeath IN [2..40] THEN IF gplay2 THEN
                     BEGIN
                          disapp := FALSE;
                          Dying;
                          IF killed THEN
                          BEGIN
                               Routines.Drawimage(x,y,Ofs(jman1[im]),TRUE,FALSE,FALSE,FALSE,7);
                               x := pmm1^[t*3-2];
                               y := pmm1^[t*3-1];
                               Dec(lives);
                          END;
                     END;
                END;
                pls := 0;FOR t := 0 TO 25 DO Inc(pls,ORD(pels[t]));
                plstopnow := key[1];
                plstop1 := (pls = pels_drawn);
          UNTIL plstopnow OR (p[pl].killed) OR plstop1;
        END;
   END;
   Delay2(100);
   FX_Kill;
   p[1] := p[12];
END;

BEGIN
     fn2 := MkTemp;
     ScrSave(fn2);Assign(f,fn2+'.scr');Reset(f,1);
     Seek(f,SizeOf(WORD)+SizeOf(Custom_Header));
     WITH sstr DO
     BEGIN
          GetMem(pm1,size1);
          BlockRead(f,pm1^,size1);
          GetMem(pm2,size2);
          BlockRead(f,pm2^,size2-2);
          Close(f);
          Test_Play(pm1,pm2);
          FreeMem(pm1,size1);
          FreeMem(pm2,size2);
     END;
     Erase(f);
END;

PROCEDURE Save_Table;
VAR
   ch : CHAR;

BEGIN
     IF fn = '' THEN fn := 'NONAME';
     REPEAT
           Clrscr;TextColor(14);
           Writeln('1. Number of bullets : ',sstr.ndots);
           Writeln('2. Screen Title : ',sstr.title);
           Writeln('3. Screen save name : ',fn);
           Writeln('4. I change my mind, I don''t want to save.');
           Writeln('5. Save');
           Writeln;Write('Option (1-3 to modify entry) : ');
           REPEAT ch := keyd[GetAKey2] UNTIL ch IN ['1'..'5'];
           IF ch = '1' THEN
           BEGIN
                GotoXY(1,9);Write('Number of bullets : ');
                REPEAT t := GetAKey2 UNTIL keyd[t] IN ['0'..'6'];
                sstr.ndots := Ord(keyd[t])-Ord('0');
           END ELSE
           IF ch = '2' THEN
           BEGIN
                GotoXY(1,9);Write('Screen Title : ');
                sstr.title := GetInp2(18,TRUE);
           END ELSE
           IF ch = '3' THEN
           BEGIN
                GotoXY(1,9);Write('Screen save name : ');
                REPEAT fn := GetInp2(8,FALSE) UNTIL fn <> '';
                Assign(f,fn+'.scr');{$I-} Reset(f,1);Seek(f,0);{$I+}
                IF ioresult = 0 THEN
                BEGIN
                     Close(f);
                     Writeln;Writeln;
                     Write('That file exists, Overwrite? (Y/N) : ');
                     REPEAT t := GetAKey2 UNTIL keyd[t] IN ['y','n'];
                     IF keyd[t] = 'n' THEN fn := 'NONAME';
                END;
           END ELSE
           IF ch = '4' THEN
           BEGIN
                GotoXY(1,9);Write('Changes will be lost! ARE YOU SURE? (Y/N) : ');
                REPEAT t := GetAKey2 UNTIL keyd[t] IN ['y','n'];
                IF keyd[t] = 'y' THEN Exit;
           END;
     UNTIL ch = '5';
     Write('Saving...');sstr.fname := fn;
     ScrSave(fn);
END;

PROCEDURE Update_DMode;
BEGIN
     EgaWrOn;GotoXY(11,25);
     IF (drawmode) THEN TextColor(15-Ord(vmode=0)) ELSE TextColor(7);
     IF curtask = 0 THEN TextColor(7);
     Write('DRAW');
     IF (drawmode) THEN TextColor(7) ELSE TextColor(15-Ord(vmode=0));
     IF curtask = 0 THEN TextColor(7);
     Write(' ERASE');
     EgaWrOff;
END;

PROCEDURE Update_Steps;
BEGIN
     TextColor(7);EgaWrOn;
     GotoXY(3,24);Write(curstep);
     GotoXY(7,24);Write(curstep2);
     EgaWrOff;
END;

PROCEDURE Update_Task(o : BYTE);
VAR
   s : STRING[3];

BEGIN
     EgaWrOn;
     IF o = curtask THEN TextColor(15-Ord(vmode=0)) ELSE TextColor(7);
     Str(curtask,s);
     IF curtask < 10 THEN s := '0'+s;
     GotoXY(23+curtask,24);Write(s[1]);
     GotoXY(23+curtask,25);Write(s[2]);
     EgaWrOff;
END;

PROCEDURE Update_Tasks;
VAR
   o : BYTE;
BEGIN
     EgaWrOn;o := curtask;
     FOR curtask := 0 TO 16 DO Update_Task(o);
     curtask := o;
     EgaWrOn;
     TextColor(7);GotoXY(22,24);Write('R');
     EgaWrOff;
END;

PROCEDURE Update_TStat;
BEGIN
     EgaWrOn;GotoXY(17,24);
     IF curtask = 0 THEN
     BEGIN
          TextColor(7);
          Write('OFF');
     END ELSE
     BEGIN
          TextColor(15-Ord(vmode=0));
          Write('ON ');
     END;
     EgaWrOff;
END;

PROCEDURE DrawPix(n : BYTE);
BEGIN
     IF n = 0 THEN
     BEGIN
          curtask := 0;
          SetVGA;
          Gotoxy(1,24);EgaWrOn;
          TextColor(7);Write('X:  Y:  ');
          GotoXY(1,25);TextColor(6);Write('RECORDING:');
          GotoXY(11,24);TextCOlor(7);Write('TASKS:');
          Update_DMode;Update_Steps;Update_Tasks;Update_TStat;
          EgaWrOff;
          FOR a := 1 TO 6 DO
              FOR t := 1 TO pix[a] DO
                  DrawIt(a,tab^[t][a].x,tab^[t][a].y);
     END ELSE
     BEGIN
          FOR t := 1 TO tasize[n] DO
              Drawimage(tasks^[n,t].x,tasks^[n,t].y,GetOfs(tasks^[n,t].typ),tasks^[n,t].kill,0);
     END;
     Update_Task(n);
     curtask := n;
     Update_Task(n);
END;

{$IFDEF DOX}
PROCEDURE EditHlp1;EXTERNAL;{$L EditHlp1}
PROCEDURE EditHlp2;EXTERNAL;{$L EditHlp2}
PROCEDURE EditHlp3;EXTERNAL;{$L EditHlp3}
PROCEDURE EditHlp4;EXTERNAL;{$L EditHlp4}   {Holy Shit!}
PROCEDURE LibHlp1;EXTERNAL;{$L LibHlp1}
PROCEDURE LibHlp2;EXTERNAL;{$L LibHlp2}
{$ENDIF}

PROCEDURE Edit_Help(b : BOOLEAN);
BEGIN
     r.ax := 3;Intr($10,r);
     {$IFDEF DOX}
     PutUp(@edithlp1);
     PutUp(@edithlp2);
     PutUp(@edithlp3);
     PutUp(@edithlp4);
     {$ENDIF}
     IF b THEN DrawPix(0);
END;

PROCEDURE Library_Help;
BEGIN
     r.ax := 3;Intr($10,r);
     {$IFDEF DOX}
     PutUp(@libhlp1);
     PutUp(@libhlp2);
     {$ENDIF}
END;

PROCEDURE Editit;
CONST
     defs : ARRAY[1..6,0..1] OF BYTE = ( (4,2),(8,2),(8,8),(4,2),(4,4),(4,8) );
BEGIN
     FOR t := 1 TO 17 DO tasize[t] := 0;
     FOR t := 1 TO 6 DO pix[t] := 0;
     r.ax := 0;Intr($33,r);
     IF r.ax = 0 THEN
     BEGIN
{          r.ax := $13;Intr($10,r);}
          SetHires;IF vmode = 1 THEN EgaGreys;
          Writes('A MOUSE DRIVER IS',0,0,TRUE);
          Writes('REQUIRED.',0,20,TRUE);
          Writes('PRESS A KEY',0,60,TRUE);
          IF GetAKey2 = 0 THEN;
          Exit;
     END;
     sstr.title := '';sstr.ndots := 0;
     New(tasks);New(tab);
     fn := paramstr(1);
     curstep := 4;curstep2 := 2;
     curtask := 0;Load_Table;saved := FALSE;
     DrawPix(0);drawmode := TRUE;ontop := TRUE;
     r.ax := 7;r.cx := 8*2;r.dx := 304*2;Intr($33,r);
     r.ax := 8;r.cx := 8;r.dx := 176;Intr($33,r);
{     IF fn = '' THEN Halt(255);}
     citem.cofs := GetOfs(1);
     citem.k := 1;
     WITH r DO
     REPEAT
         IF ontop THEN
         BEGIN
           IF keypress THEN WITH citem DO
           BEGIN
                ks := GetKey;ke := ks[Ord(ks[0])];
                IF (ke IN ['1'..'6']) AND (Ord(ks[0])=1) THEN
                BEGIN
                     DrawImage(x,y,cofs,TRUE,7);
                     k := Ord(ke)-48;
                     cofs := GetOfs(k);
                     curstep := defs[k,0];
                     curstep2 := defs[k,1];
                     Update_Steps;
                END ELSE
                BEGIN
                     IF keypress THEN
                     BEGIN
                          ks := GetKey;
                          IF key[77] THEN
                          BEGIN
                               IF curstep < 8 THEN Inc(curstep);
                               Update_Steps;
                               delay2(40);
                          END ELSE
                          IF key[75] THEN
                          BEGIN
                               IF curstep > defs[k,0] THEN Dec(curstep);
                               Update_Steps;
                               delay2(40);
                          END ELSE
                          IF key[80] THEN
                          BEGIN
                               IF curstep2 > defs[k,1] THEN Dec(curstep2);
                               Update_Steps;
                               delay2(40);
                          END;
                          IF key[72] THEN
                          BEGIN
                               IF curstep2 < 8 THEN Inc(curstep2);
                               Update_Steps;
                               delay2(40);
                          END;
                          IF ks[1] IN ['s','t'] THEN
                          BEGIN
                               IF pix[1] = 0 THEN
                               BEGIN
                                    REPEAT UNTIL NOT keypress;
                                    TextColor(6);GotoXY(1,1);
                                    EgaWrOn;
                                    Write('Error: No bombs placed.  (Any Key)');
                                    REPEAT UNTIL keypress;
                                    REPEAT UNTIL NOT keypress;
                                    EgaWrOff;
                               END ELSE
                               IF pix[4] = 0 THEN
                               BEGIN
                                    REPEAT UNTIL NOT keypress;
                                    TextColor(6);GotoXY(1,1);
                                    EgaWrOn;
                                    Write('Error: No jumpman placed.  (Any Key)');
                                    REPEAT UNTIL keypress;
                                    REPEAT UNTIL NOT keypress;
                                    EgaWrOff;
                               END ELSE
                                   IF ks[1] = 's' THEN saved := TRUE ELSE
                                   BEGIN
                                        DrawImage(x,y,cofs,TRUE,7);
                                        Test_screen;
                                        DrawPix(0);
                                   END;
                               EgaWrOn;
                               GotoXY(1,1);Write('                                    ');
                               EgaWrOff;
                          END;
                          if ks[1] = 'h' THEN Edit_Help(TRUE);
                     END;
                END;
           END;
           ax := 3;Intr($33,r);
           WITH citem DO
           BEGIN
                x1 := x;y1 := y;
                x := cx DIV 2;
                y := dx;
                IF key[29] THEN x := x1;
                IF key[42] THEN y := y1;
                usestep := curstep;
                usestep2 := curstep2;
                IF NOT key[56] THEN
                BEGIN
                     x := (x DIV usestep)*usestep;
                     y := (y DIV usestep2)*usestep2;
                END;

                IF MoveImage(x,y,0,cofs,FALSE)=1 THEN;
                IF key[57] THEN
                BEGIN
                     DrawImage(x,y,cofs,TRUE,$7);
                     r.ax := 8;r.cx := 186;r.dx := 200;Intr($33,r);
                     r.ax := 7;r.cx := 0;r.dx := 320*2;Intr($33,r);
                     r.ax := 1;Intr($33,r);
                     ontop := FALSE;
                     REPEAT UNTIL NOT key[57];
                END;
                IF bx = 1 THEN
                BEGIN
                     IF curtask = 0 THEN
                     BEGIN
                          found := FALSE;
                          FOR t := 1 TO pix[k] DO
                              IF (tab^[t][k].x = x) AND (tab^[t][k].y = y) THEN found := TRUE;
                          IF (NOT found) AND NOT((k=1) AND (pix[1] = 16)) AND
                             NOT((k=4) AND (pix[4] > 0)) THEN
                          BEGIN
                               Inc(pix[k]);
                               tab^[pix[k]][k].x := x;
                               tab^[pix[k]][k].y := y;
                               DrawImage(x,y,cofs,FALSE,0);
                          END;
                     END ELSE IF k IN [2,3,5,6] THEN
                     BEGIN
                          repeat ax := 3;Intr($33,r) until bx = 0;
                          IF drawmode THEN
                          BEGIN
                               Inc(tasize[curtask]);
                               tasks^[curtask,tasize[curtask]].x := x;
                               tasks^[curtask,tasize[curtask]].y := y;
                               tasks^[curtask,tasize[curtask]].typ := k;
                               tasks^[curtask,tasize[curtask]].kill := FALSE;
                               Drawimage(x,y,Getofs(k),FALSE,0);
                          END ELSE
                          BEGIN
                               FOR t := 1 TO tasize[curtask] DO
                                   IF (tasks^[curtask,t].x = x) AND
                                      (tasks^[curtask,t].y = y) AND
                                      (tasks^[curtask,t].typ = k) AND
                                      (tasks^[curtask,t].kill = TRUE) THEN
                                   BEGIN
                                        FOR z := t TO tasize[curtask] DO
                                        BEGIN
                                             tasks^[curtask,z] := tasks^[curtask,z+1];
                                             Dec(tasize[curtask]);
                                        END;
                                        Drawimage(x,y,Getofs(k),FALSE,0);
                                   END;
                          END;
                     END;
                END ELSE
                IF bx = 2 THEN
                BEGIN
                     IF curtask = 0 THEN
                     BEGIN
                          fl := 0;
                          FOR t := 1 TO pix[k] DO
                              IF (tab^[t][k].x = x) AND (tab^[t][k].y = y) THEN fl := t;
                          IF fl > 0 THEN
                          BEGIN
                               FOR t := fl+1 TO pix[k] DO tab^[t-1][k] := tab^[t][k];
                               Dec(pix[k]);
                               DrawImage(x,y,cofs,TRUE,$f8);
                               IF (k=1) THEN
                               BEGIN
                                    FOR t := fl TO 16 DO
                                        tasks^[t] := tasks^[t+1];
                                    FOR t := fl TO 16 DO
                                        tasize[t] := tasize[t+1];
                                    tasize[17] := 0;
                               END;
                          END;
                     END ELSE IF k IN [2,3,5,6] THEN
                     BEGIN
                          repeat ax := 3;Intr($33,r) until bx = 0;
                          IF NOT drawmode THEN
                          BEGIN
                               Inc(tasize[curtask]);
                               tasks^[curtask,tasize[curtask]].x := x;
                               tasks^[curtask,tasize[curtask]].y := y;
                               tasks^[curtask,tasize[curtask]].typ := k;
                               tasks^[curtask,tasize[curtask]].kill := TRUE;
                               Drawimage(x,y,Getofs(k),TRUE,$f8);
                          END ELSE
                          BEGIN
                               FOR t := 1 TO tasize[curtask] DO
                                   IF (tasks^[curtask,t].x = x) AND
                                      (tasks^[curtask,t].y = y) AND
                                      (tasks^[curtask,t].typ = k) AND
                                      (tasks^[curtask,t].kill = FALSE) THEN
                                   BEGIN
                                        FOR z := t TO tasize[curtask] DO
                                        BEGIN
                                             tasks^[curtask,z] := tasks^[curtask,z+1];
                                             Dec(tasize[curtask]);
                                        END;
                                        Drawimage(x,y,Getofs(k),FALSE,0);
                                   END;
                          END;
                     END;
                END;
           END;
         END ELSE
         BEGIN
              IF key[57] THEN
              BEGIN
                   r.ax := 8;r.cx := 8;r.dx := 176;Intr($33,r);
                   r.ax := 7;r.cx := 8*2;r.dx := 304*2;Intr($33,r);
                   r.ax := 2;Intr($33,r);
                   ontop := TRUE;
                   REPEAT UNTIL NOT key[57];
                   EgaWrOff;
              END ELSE
              BEGIN
                   ax := $3;Intr($33,r);
                   IF (dx IN [192..198]) AND (r.bx = 1) AND (curtask > 0) THEN
                      IF ((cx DIV 2) IN [81..110]) THEN
                      BEGIN
                           drawmode := TRUE;
                           GotoXY(11,25);
                           ax := 2;Intr($33,r);
                           EgaWrOn;
                           TextColor(15-Ord(vmode=0));Write('DRAW');
                           TextColor(7);Write(' ERASE');
                           EgaWrOff;
                           ax := 1;Intr($33,r);
                      END ELSE
                      IF ((cx DIV 2) IN [121..158]) THEN
                      BEGIN
                           drawmode := FALSE;
                           GotoXY(11,25);
                           ax := 2;Intr($33,r);
                           EgaWrOn;
                           TextColor(7);Write('DRAW');
                           TextColor(15-Ord(vmode=0));Write(' ERASE');
                           EgaWrOff;
                           ax := 1;Intr($33,r);
                      END;
                   WITH r DO
                   IF ((cx / 16) >= 21.0) AND ((cx / 16) < 39.0) AND ((cx MOD 16) IN [0..13])
                      AND (bx = 1) AND (INTEGER((cx DIV 16) - 22) <= pix[1]) THEN
                   BEGIN
                        t := (cx DIV 16) - 22;
                        ax := 2;Intr($33,r);
                        IF cx < 350 THEN
                        BEGIN
                             DrawPix(0);
                        END ELSE
                        IF cx < 366 THEN
                        BEGIN
                             Update_Task(0);
                             curtask := 0;
                             Update_Task(0);
                        END ELSE
                        BEGIN
                             EgaWrOff;
                             DrawPix(t);
                        END;
                        Update_DMode;
                        t := (cx DIV 16) - 22;
                        IF t > 0 THEN FOR z := 1 TO 6 DO
                        BEGIN
                             EgaWrOff;
                             Drawimage(tab^[t,1].x,tab^[t,1].y,Ofs(pel1),TRUE,0);
                             Delay2(10);
                             Drawimage(tab^[t,1].x,tab^[t,1].y,Ofs(pel1),FALSE,0);
                             Delay2(10);
                        END;
                        Update_TStat;
                        ax := 1;Intr($33,r);
                   END;
              END;
         END;
     UNTIL (key[59] AND key[60]) OR saved;
     r.ax := 3;Intr($10,r);
     IF saved THEN Save_Table;
     Dispose(tasks);Dispose(tab);
END;

PROCEDURE Manager;
VAR
   ch : CHAR;
   wl : BYTE;

PROCEDURE Pick_Lib(b : BOOLEAN);
VAR
   ts : STRING;
   junk : ExtStr;
   junk2 : DirStr;
   kk : BYTE;
   tmps : NameStruct;

BEGIN
     r.ax := 3;Intr($10,r);
     t := 0;
     REPEAT
           IF t = 0 THEN FindFirst('*.jml',Archive,scrs) ELSE FindNext(scrs);
           z := DosError;
           IF z = 0 THEN
           BEGIN
                Inc(t);
                FSplit(scrs.name,junk2,scrnames[0,t].fname,junk);
                Assign(f,scrnames[0,t].fname+'.jml');{$I-} Reset(f,1);Seek(f,0);{$I+}
                IF (ioresult = 0) AND (FileSize(f) > SizeOf(NameStruct)) THEN
                BEGIN
                     Seek(f,1);
                     BlockRead(f,tmps,SizeOf(NameStruct));
                     Close(f);
                     scrnames[0,t].title := tmps.title;
                END ELSE Dec(t);
           END;
     UNTIL z <> 0;
     IF b THEN
     BEGIN
          Inc(t);
          scrnames[0,t].title := '';
          scrnames[0,t].fname := '[NewLIB]';
     END;
     TextColor(14);GotoXY(1,25);
     Write('Cursor UP/DOWN to select work library. [ESC] to Abort.');
     ts := Choose_1(1);
     wl := t;
     IF ts = '[NewLIB]' THEN
     BEGIN
          Clrscr;
          Write('Enter mission name (appears at mission selection screen) : ');
          REPEAT scrnames[0,wl].title := GetInp2(17,TRUE) UNTIL scrnames[0,wl].title <> '';
          scrnames[0,wl].fname := MkTemp;
          Assign(f,scrnames[0,wl].fname+'.jml');{$I-} ReWrite(f,1);Seek(f,0);{$I+}
          IF ioresult = 0 THEN
          BEGIN
               t := 0;
               BlockWrite(f,t,1);
               BlockWrite(f,scrnames[0,wl],SizeOf(NameStruct));
               Close(f);
          END;
     END;
     libname := scrnames[0,z];
     IF ts = '' THEN libname.fname := '';
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION  GetLibscrs(sci : BYTE) : BYTE;
VAR
   f : FILE;
   kk : BYTE;
   nfp : WORD;
BEGIN
     Assign(f,libname.fname+'.jml');{$I-} Reset(f,1);Seek(f,0);{$I+}
     BlockRead(f,kk,1);
     BlockRead(f,libname,SizeOf(NameStruct));
     FOR t := 1 TO kk DO WITH scrnames[sci,t] DO
     BEGIN
          BlockRead(f,a,2);
          BlockRead(f,sstr,SizeOf(Custom_Header));
          fname := sstr.fname;
          title := sstr.title;
          nfp := FilePos(f) + a - (Sizeof(Custom_Header)+2);
          Seek(f,nfp);
     END;
     Close(f);
     GetLibscrs := kk;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Extract;
VAR
   somerror : BOOLEAN;
   kk : BYTE;
   mlc : WORD;
   ofp,nfp : LONGINT;
   ts : STRING;
   g : FILE;
   mpf,mp : POINTER;

PROCEDURE MakeIt;
VAR
   mp2 : POINTER;
BEGIN
     Assign(g,ts+'.scr');{$I-} Rewrite(g,1);{$I+}
     Seek(f,ofp);
     GetMem(mp2,nfp-ofp);
     BlockRead(f,mp2^,nfp-ofp);
     BlockWrite(g,mp2^,nfp-ofp);
     Close(g);
     FreeMem(mp2,nfp-ofp);
END;

BEGIN
     Pick_Lib(FALSE);
     WITH libname DO IF fname <> '' THEN
     BEGIN
          somerror := FALSE;
          Assign(f,fname+'.jml');{$I-} Reset(f,1);Seek(f,0);{$I+}
          IF ioresult = 0 THEN
          BEGIN
               IF FileSize(f) > 0 THEN
               BEGIN
                    BlockRead(f,kk,1);
                    IF kk = 0 THEN somerror := TRUE;
               END ELSE somerror := TRUE;
               Close(f);
          END ELSE somerror := TRUE;
          IF somerror THEN
          BEGIN
               ClrScr;
               Writeln('One of the following problems has occured.');
               Writeln;
               Writeln('1. You''re trying to extract from an empty library.');
               Writeln('2. The selected library cannot be found.');
               Writeln('3. The selected library is a splat (0) file.');
               Writeln;
               Write('Press a key.');
               IF GetAKey2 = 0 THEN;
          END ELSE
          BEGIN
               t := GetLibScrs(0);
               REPEAT
                     ClrScr;TextColor(14);GotoXY(1,25);
                     Write('Cursor UP/DOWN to select screen to extract. [ESC] to Abort.');
                     ts := Choose_1(1);
                     IF ts <> '' THEN
                     BEGIN
                          FOR a := z+1 TO 20 DO scrnames[0,a-1] := scrnames[0,a];
                          Dec(t);
                          Reset(f,1);Seek(f,0);BlockRead(f,z,1);
                          Dec(z);Seek(f,0);BlockWrite(f,z,1);
                          Seek(f,SizeOf(NameStruct)+1);
                          REPEAT
                                ofp := FilePos(f);
                                BlockRead(f,a,2);
                                BlockRead(f,sstr,SizeOf(Custom_Header));
                                nfp := FilePos(f) + a - (Sizeof(Custom_Header)+2);
                                Seek(f,nfp);
                          UNTIL (ts = sstr.fname);
                          Seek(f,0);
                          GetMem(mpf,ofp);
                          BlockRead(f,mpf^,ofp);
                          mlc := FileSize(f)-nfp;
                          IF mlc = 0 THEN
                             MakeIt ELSE
                          BEGIN
                               GetMem(mp,mlc);
                               Seek(f,nfp);
                               BlockRead(f,mp^,mlc);
                               MakeIt;
                          END;
                          Close(f);ReWrite(f,1);Seek(f,0);
                          BlockWrite(f,mpf^,ofp);
                          FreeMem(mpf,ofp);
                          IF NOT(mlc = 0) THEN
                          BEGIN
                               BlockWrite(f,mp^,mlc);
                               FreeMem(mp,mlc);
                          END;
                          Close(f);
                     END;
               UNTIL ts = '';
          END;
     END;
END;

PROCEDURE Import;
VAR
   g : FILE;
   tlr,maxr : ARRAY[0..1] OF BYTE;
   aborted : BOOLEAN;
   ch : BYTE;
   ts : STRING;
   mp1,mp2,mp3 : POINTER;
   tv,ms1,ms2,ms3 : WORD;
   kfp,nfp,ofp : LONGINT;

BEGIN
     Pick_Lib(TRUE);
     IF libname.fname <> '' THEN
     BEGIN
          GetScrnames;maxr[0] := t;
          maxr[1] := GetLibscrs(1);
          FOR t := 0 TO 1 DO
              FOR z := 1 TO maxr[t] DO WITH scrnames[t,z] DO
              BEGIN
                   while Ord(fname[0]) < 8 DO fname := fname + ' ';
                   while Ord(title[0]) < 18 DO title := title + ' ';
              END;
          IF maxr[0] > 0 THEN
          REPEAT
                TextBackGround(0);ClrScr;aborted := FALSE;Inc(maxr[1]);
                scrnames[1,maxr[1]].fname := '        ';
                scrnames[1,maxr[1]].title := '                  ';
                FOR t := 0 TO 1 DO
                BEGIN
                    FOR z := 1 TO maxr[t] DO WITH scrnames[t,z] DO
                    BEGIN
                         GotoXY((t*40)+1,t+z);
                         Write(scrnames[t,z].fname,'     ',scrnames[t,z].title);
                    END;
                    tlr[t] := 1;
                END;
                z := 1;
                GotoXY(1,25);Write('Cursor up/down to select screen to be moved into the library. [ESC] = Abort');
                REPEAT
                      GotoXY(1,z);
                      TextColor(14);TextBackGround(1);
                      ts := scrnames[0,z].fname;
                      Write(ts,'     ',scrnames[0,z].title);
                      REPEAT ch := GetAKey2 UNTIL ch IN [72,80,28,1];
                      IF ch = 1 THEN aborted := TRUE;
                      IF (ch = 72) AND (z > 1) THEN
                      BEGIN
                           GotoXY(1,z);TextBackGround(0);
                           Write(scrnames[0,z].fname,'     ',scrnames[0,z].title);
                           Dec(z);
                      END ELSE
                      IF (ch = 80) AND (z < maxr[0]) THEN
                      BEGIN
                           GotoXY(1,z);TextBackGround(0);
                           Write(scrnames[0,z].fname,'     ',scrnames[0,z].title);
                           Inc(z);
                      END;
                UNTIL ch IN [1,28];
                tlr[0] := z;z := 1;TextBackGround(0);
                GotoXY(1,25);Write('Cursor up/down to select screen placement in library.     [ESC] = Abort');
                IF NOT aborted THEN
                REPEAT
                      TextColor(14);TextBackGround(1);GotoXY(41,z);
                      Write(scrnames[0,tlr[0]].fname,'     ',scrnames[0,tlr[0]].title);
                      REPEAT ch := GetAKey2 UNTIL ch IN [72,80,28,1];
                      IF ch = 1 THEN aborted := TRUE;
                      IF (ch = 72) AND (z > 1) THEN
                      BEGIN
                           GotoXY(41,z);TextBackGround(0);
                           Write(scrnames[1,z-1].fname,'     ',scrnames[1,z-1].title);
                           Dec(z);
                      END ELSE
                      IF (ch = 80) AND (z < maxr[1]) THEN
                      BEGIN
                           GotoXY(41,z);TextBackGround(0);
                           Write(scrnames[1,z].fname,'     ',scrnames[1,z].title);
                           Inc(z);
                      END;
                UNTIL ch IN [1,28];
                tlr[1] := z;
                IF NOT aborted THEN
                BEGIN
                     FOR t := maxr[1] DOWNTO tlr[1]+1 DO
                         scrnames[1,t] := scrnames[1,t-1];
                     scrnames[1,tlr[1]] := scrnames[0,tlr[0]];
                     FOR t := tlr[0] TO maxr[0]-1 DO
                         scrnames[0,t] := scrnames[0,t+1];
                     Dec(maxr[0]);
                     Assign(f,scrnames[1,tlr[1]].fname+'.scr');Reset(f,1);Seek(f,0);
                     ms1 := FileSize(f);
                     GetMem(mp1,ms1);
                     BlockRead(f,mp1^,ms1);Close(f);Erase(f);
                     Assign(f,libname.fname+'.jml');Reset(f,1);Seek(f,0);
                     BlockRead(f,ch,1);
                     BlockRead(f,libname,SizeOf(NameStruct));
                     kfp := FilePos(f);ms2 := 0;
                     ofp := kfp;nfp := ofp;
                     FOR t := 1 TO tlr[1]-1 DO
                     BEGIN
                          BlockRead(f,tv,2);
                          nfp := ofp + tv;
                          Inc(ms2,tv);
                          ofp := nfp;
                          Seek(f,nfp);
                     END;
                     Seek(f,kfp);kfp := nfp;
                     IF ms2 > 0 THEN
                     BEGIN
                          GetMem(mp2,ms2);
                          BlockRead(f,mp2^,ms2);
                     END;
                     ms3 := FileSize(f) - kfp;
                     IF ms3 > 0 THEN
                     BEGIN
                          Seek(f,kfp);
                          GetMem(mp3,ms3);
                          BlockRead(f,mp3^,ms3);
                     END;
                     Close(f);ReWrite(f,1);Seek(f,0);
                     Inc(ch);BlockWrite(f,ch,1);
                     BlockWrite(f,libname,SizeOf(NameStruct));
                     IF ms2 > 0 THEN
                     BEGIN
                          BlockWrite(f,mp2^,ms2);
                          FreeMem(mp2,ms2);
                     END;
                     BlockWrite(f,mp1^,ms1);
                     FreeMem(mp1,ms1);
                     IF ms3 > 0 THEN
                     BEGIN
                          BlockWrite(f,mp3^,ms3);
                          FreeMem(mp3,ms3);
                     END;
                     Close(f);
                END;
          UNTIL aborted OR (maxr[0] = 0);
          TextBackGround(0);
     END;
END;

BEGIN
     REPEAT
{           r.ax := $13;Intr($10,r);}
           SetHires;IF vmode = 1 THEN EgaGreys;
           Writes('1. EXTRACT SCREENS',0,0,TRUE);
           Writes('2. STORE SCREENS',0,20,TRUE);
           Writes('3. LIBRARY HELP',0,40,TRUE);
           Writes('4. QUIT',0,60,TRUE);
           REPEAT ch := keyd[GetAKey2] UNTIL ch IN ['1'..'4','~'];
           IF ch = '1' THEN Extract ELSE
           IF ch = '2' THEN Import ELSE
           IF ch = '3' THEN Library_Help;
     UNTIL ch IN ['4','~'];
END;

PROCEDURE WorkStation;
VAR
   ch : CHAR;
BEGIN
     REPEAT
{           r.ax := $13;Intr($10,r);}
           SetHires;IF vmode = 1 THEN EgaGreys;
           Writes('1. EDITOR',0,0,TRUE);
           Writes('2. EDITOR HELP',0,20,TRUE);
           Writes('3. LIBRARY MANAGER',0,40,TRUE);
           Writes('4. QUIT',0,60,TRUE);
           REPEAT ch := keyd[GetAKey2] UNTIL ch IN ['1'..'4','~'];
           IF ch = '1' THEN Editit ELSE
           IF ch = '2' THEN Edit_Help(FALSE) ELSE
           IF ch = '3' THEN Manager;
     UNTIL ch IN ['4','~'];
END;
END.
