UNIT Globals;

INTERFACE

USES
    Dos,Dact;

PROCEDURE HClrScr;
PROCEDURE Delay2(n : WORD);
FUNCTION  Getc(n : byte) : WORD;
PROCEDURE GetInput;
FUNCTION  Itoa(n : INTEGER) : STRING;
FUNCTION  Ltoa(n : LONGINT) : STRING;
FUNCTION  keypress : BOOLEAN;
PROCEDURE Displaypic(n : POINTER);
PROCEDURE WriteEsDiAl;
PROCEDURE WriteEsDiAl9;
PROCEDURE SetHires;
PROCEDURE EgaGreys;
PROCEDURE Wipe(n : POINTER);
PROCEDURE GameCols;
PROCEDURE PicCols;
PROCEDURE Load_DAC;
PROCEDURE VgaGreys;
PROCEDURE EgaNorms;

CONST
     DIESPEED = 6;
     PLAYSPEED : ARRAY[1..8] OF BYTE = (3,7,11,15,17,20,27,38);
     trainer : BOOLEAN = FALSE;
     nosnd : BOOLEAN = FALSE;
     b64k : POINTER = NIL;
     Game_Music : BOOLEAN = TRUE;
     in_intro : BOOLEAN = TRUE;
     abstime : LONGINT = 0;
     current_level : BYTE = 1;
     bonus : LONGINT = 0;
     maxpl : BYTE = 1;
     calibrated : ARRAY[0..1] OF BOOLEAN = (FALSE,FALSE);
     GenAddr : WORD = $388;
     MAXJP1 = 21;
     MAXJP2 = 24;
     SCBOT = 8*21+4;
     jp1 : ARRAY[0..MAXJP1] OF SHORTINT = (2,2,2,2,2,2,0,0,0,-2,-2,-2,
                                           -2,-2,-2,-2,-2,-2,-2,-2,-2,-2);
     jp2 : ARRAY[0..MAXJP2*2-1] OF SHORTINT = (2,2,0,2,2,2,0,2,
                                               2,2,2,2,2,0,2,0,
                                               2,0,2,-2, 2,-2,0,-2,
                                               2,-2,0,-2, 2,-2,0,-2,
                                               0,-2,2,-2, 0,-2,0,-2,
                                               0,-2,2,-2, 0,-2,0,-2);

     ups : ARRAY[0..3] OF BYTE = (4,5,6,3);
     ftwo : ARRAY[0..5] OF BYTE = ($01,$2b,$03,$2a,$17,$01);
     DelayV : WORD = 0;
     keyd : STRING[128] = '~1234567890-=BTqwertyuiop[]ECasdfghjkl;''`L\zxcvbnm,./R*A C||||||||||NS|||-|||+||||.';
     egacros2 : ARRAY[0..255] OF BYTE = (0,2,6,13,1,1,4,7, 0,0,0,0,0,0,0,0,
                                         15,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         4,0,0,0,0,0,0,0, 15,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         14,0,0,0,0,0,0,0, 4,0,0,0,0,0,0,0,
                                         7,0,0,0,0,0,0,0, 15,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 5,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 6,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 7,0,0,0,0,0,0,0,
                                         7,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         9,0,0,0,0,0,0,0, 7,0,0,0,0,0,0,0,
                                         7,0,0,0,0,0,0,0, 7,0,0,0,0,0,0,0,
                                         14,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         5,0,0,0,0,0,0,0, 12,0,0,0,0,0,0,0,
                                         9,0,0,0,0,0,0,0, 14,0,0,0,0,0,0,0 );
     egacros1 : ARRAY[0..255] OF BYTE = (0,1,2,3,4,5,6,7, 8,9,10,11,12,13,14,15,
                                         7,0,0,0,0,0,0,0, 15,0,0,0,0,0,0,0,
                                         4,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         4,0,0,0,0,0,0,0, 6,0,0,0,0,0,0,0,
                                         14,0,0,0,0,0,0,0, 14,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 10,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         3,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         13,0,0,0,0,0,0,0, 5,0,0,0,0,0,0,0,
                                         13,0,0,0,0,0,0,0, 4,0,0,0,0,0,0,0,
                                         6,0,0,0,0,0,0,0, 6,0,0,0,0,0,0,0,
                                         6,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         6,0,0,0,0,0,0,0, 6,0,0,0,0,0,0,0,
                                         14,0,0,0,0,0,0,0, 6,0,0,0,0,0,0,0 );
     cgacross : ARRAY[0..255] OF BYTE = (0,1,2,1,2,1,2,3, 1,2,3,1,2,3,1,1,
                                         3,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         3,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         3,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         3,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
                                         2,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0 );

TYPE
    {$I Types.inc}
VAR
   r : Registers;
   ninecol,
   vmode : BYTE;
   lastims : ARRAY[0..20,0..3] OF INTEGER;
   key : ARRAY[0..127] OF BOOLEAN;
   intscrp : ^RAY;
   cudj,clrj,
   lj,rj,uj,dj : ARRAY[0..1] OF INTEGER;
   res,t,a : WORD;
   f : FILE;
   p : ARRAY[1..12] OF player;
   dots : ARRAY[1..10] OF dot;
   m320,m40,m80 : ARRAY[0..199] OF WORD;
   oldtimer : PROCEDURE;
   OldKBd : POINTER;
   which_to_play,
   pels_drawn,
   cus_max,
   cus_play,
   level_start,
   level_current,
   which_base,
   pl : BYTE;
   cproc,cdot,
   cdied,caction,
   cbeg,cend,ctim : PROCEDURE;
   plsx,plsy,
   altat,rres,
   btick,eomission,
   max_screens,
   somex,somey : INTEGER;
   taskp : PNT;
   kbdinst,
   special,plstopnow,
   disapp : BOOLEAN;
   dbuf   : ARRAY[0..40,0..40] OF BYTE;
   pnt1,pnt2 : PNT;
   scrtitle : STRING[20];
   screeninfo : Custom_Header;
   scrnames : ARRAY[0..1,1..20] OF NameStruct;
   scrs : SearchRec;
   libname : NameStruct;
   egacross : ARRAY[0..767] OF BYTE;

IMPLEMENTATION

PROCEDURE Load_DAC;
BEGIN
     WITH r DO IF vmode = 2 THEN
     BEGIN
          ax := $1012;es := SEG(dactable);dx := OFS(dactable);
          bx := 0;cx := $100;Intr($10,r);
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE HClrScr;ASSEMBLER;
CONST
     MAXC = 200;
ASM
        cmp     [vmode],1
        jnz     @nega
        mov     dx,$3ce
        mov     ax,0
        out     dx,ax
        mov     ax,$ff08
        out     dx,ax
        mov     ax,$a000
        mov     es,ax
        mov     cx,40*200
        xor     di,di
@ecl:   or      [es:di],al
        inc     di
        loop    @ecl
        jmp     @eclr
@nega:  mov     ax,$a000
        mov     es,ax
        mov     cx,(160*MAXC)
        xor     ax,ax
        xor     di,di
        rep     stosw
        mov     ax,$b800
        mov     es,ax
        mov     cx,$2000
        xor     ax,ax
        xor     di,di
        rep     stosw
@eclr:
END;

PROCEDURE Delay2(n : WORD);
BEGIN
     DelayV := 0;
     WHILE DelayV < n DO;
END;

FUNCTION Getc(n : byte) : WORD;ASSEMBLER;
var
   lval : word;
ASM
        mov     [lval],-1
        mov     dx,$201
        mov     bl,[n]
@again: xor     cx,cx
        mov     ax,0
        out     dx,al
@more:  in      al,dx
        test    al,bl
        je      @gotit
        inc     cx
        cmp     cx,4000
        jl      @more
        jmp     @dead
@gotit: mov     ax,cx
        out     dx,al
        out     dx,al
        push    ax
        and     ax,$3ff-63
        cmp     ax,[lval]
        jz      @gotv
        mov     [lval],ax
        pop     ax
        jnz     @again
@gotv:  pop     ax
        jmp     @jend
@dead:  mov     ax,cx
@jend:
END;

PROCEDURE GetInput;
BEGIN
     WITH p[pl] DO
     CASE idevice OF
       0    : BEGIN
                   absl := (key[keys[0]]);
                   absr := (key[keys[1]]);
                   absd := (key[keys[2]]);
                   absu := (key[keys[3]]);
                   absb := (key[keys[4]]);
              END;
{       0    : BEGIN
                r.ax := 3;Intr($33,r);
                absl := (r.bx AND 4)=4;
                absr := (r.bx AND 2)=2;
                absd := (mem[$40:$17] and 4) =4;
                absu := (mem[$40:$17] and 8) =8;
                absb := (r.bx AND 1)=1;
              END;}
       1        : BEGIN
                    absl := Getc(1) < lj[0];
                    absr := Getc(1) > rj[0];
                    absd := Getc(2) < uj[0];
                    absu := Getc(2) > dj[0];
                    absb := (Port[$201] AND (16+32)) < (16+32);
                  END;
       2        : BEGIN
                    absl := Getc(4) < lj[1];
                    absr := Getc(4) > rj[1];
                    absd := Getc(8) < uj[1];
                    absu := Getc(8) > dj[1];
                    absb := (Port[$201] AND (64+128)) < (64+128);
                  END;
       3       : BEGIN
                    absl := FALSE;
                    absr := FALSE;
                    absd := FALSE;
                    absu := FALSE;
                    absb := FALSE;
                 END;
     END;
END;

FUNCTION  Itoa(n : INTEGER) : STRING;
VAR
   s : STRING;
BEGIN
     Str(n,s);
     Itoa := s;
END;

FUNCTION  Ltoa(n : LONGINT) : STRING;
VAR
   s : STRING;
BEGIN
     Str(n,s);
     WHILE Ord(s[0]) < 6 DO s := '0' + s;
     Ltoa := s;
END;

FUNCTION keypress : BOOLEAN;
VAR
   n : BYTE;
   fo : BOOLEAN;
BEGIN
     fo := FALSE;
     FOR n := 0 TO 127 DO IF key[n] THEN fo := TRUE;
     keypress := fo;
END;

PROCEDURE Displaypic(n : POINTER);ASSEMBLER;
VAR
   oldds : WORD;
   vmod : BYTE;
ASM
        mov     al,[vmode]
        mov     [vmod],al
        cmp     al,2
        jnz     @scd1
        mov     dx,$3c8
        mov     al,0
        out     dx,al
        inc     dx
@scd1:  mov     ax,ds
        mov     [oldds],ax
        push    ds
        mov     ax,WORD [b64k+2]
        mov     es,ax
        lds     si,[n]
        mov     bx,ds
        cld
        xor     di,di
@rdb:   mov     ax,bx
        lodsb
        cmp     al,255
        je      @storb
        mov     cx,1
        jmp     @stcnt
@storb: lodsb
        cmp     al,255
        je      @skate
        xor     cx,cx
        push    ax
        lodsb
        mov     cl,al
        pop     ax
@stcnt: or      di,di
        js      @normsb
        cmp     di,767
        jg      @normsb
@abnsb: cmp     di,767
        jg      @stb1
        cmp     [vmod],2
        jnz     @skd2
        out     dx,al
@skd2:  inc     di
        loop    @abnsb
        jmp     @rdb
@stb1:  sub     di,768
        push    ds
        mov     ds,[oldds]
        call    WriteEsDiAl
        pop     ds
        add     di,769
        {stosb}
        loop    @abnsb
        jmp     @rdb
@normsb:sub     di,768
        push    ds
        mov     ds,[oldds]
        call    WriteEsDiAl
        pop     ds
        add     di,769
        loop    @normsb
{        rep     stosb}
        jmp     @rdb
@skate: pop     ds
END;

PROCEDURE Wipe(n : POINTER);ASSEMBLER;
ASM
        les     di,[n]
        mov     cx,32767
        xor     ax,ax
        rep     stosw
END;

PROCEDURE SetHires;
BEGIN
     CASE vmode OF
      0 : BEGIN
               IF b64k = NIL THEN GetMem(b64k,65535);
               r.ax := 4;Intr($10,r);
               r.ah := $b;r.bx := $0100;Intr($10,r);
          END;
      1 : BEGIN
               IF b64k = NIL THEN GetMem(b64k,65535);
               r.ax := $d;Intr($10,r);
               portw[$3ce] := $0005;
               portw[$3ce] := $0f01;
               portw[$3ce] := $0003;
          END;
      2 : BEGIN
               b64k := Ptr($A000,0);
               r.ax := $13;Intr($10,r);
          END;
     END;
     Wipe(b64k);
END;

PROCEDURE WriteEsDiAl;ASSEMBLER;
ASM
        mov     [es:di],al
        push    es
        cmp     [vmode],1
        jnz     @nmode2
        push    dx
        push    cx
        push    bx
        push    di
        push    ax
        mov     bx,ax
        xor     bh,bh
        mov     ah,BYTE [egacross+bx]
        mov     dx,$3ce
        mov     al,0
        out     dx,ax
        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m40+bx]
        mov     ax,dx
        mov     cx,8
        div     cl
        mov     cl,ah
        cbw
        add     di,ax
        mov     bx,128
        shr     bx,cl
        mov     bh,bl
        xor     bh,255
        mov     dx,$3ce
        mov     al,8
        mov     ah,bl
        out     dx,ax

        mov     ax,$a000
        mov     es,ax
        or      BYTE [es:di],al         {AL is insignificant when using Set/Reset}

        pop     ax
        pop     di
        pop     bx
        pop     cx
        pop     dx
        jmp     @expr
@nmode2:
        push    dx
        push    cx
        push    bx
        push    di
        push    ax
        mov     bx,ax
        xor     bh,bh
        mov     ah,BYTE [cgacross+bx]
        push    ax

        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m80+bx]
        mov     ax,dx
        mov     cx,4
        div     cl
        mov     cl,ah
        shl     cl,1
        cbw
        add     di,ax
        pop     ax
        xchg    al,ah
        xor     ah,ah
        ror     al,1
        ror     al,1
        shr     ax,cl
        mov     bx,255-(128+64)
        ror     bl,cl
        mov     ah,bl

        mov     bx,$b800
        mov     es,bx
        mov     bl,BYTE [es:di]
        and     bl,ah
        or      bl,al
        mov     BYTE [es:di],bl

        pop     ax
        pop     di
        pop     bx
        pop     cx
        pop     dx

@expr:  pop     es
END;

PROCEDURE WriteEsDiAl9;ASSEMBLER;
ASM
        push    es
{        mov     [es:di],al}
        cmp     [vmode],2
        jnz     @teg
        stosb
        stosb
        stosb
        add     di,320-3
        stosb
        stosb
        stosb
        add     di,320-3
        stosb
        stosb
        stosb
        sub     di,320*2
        jmp     @expr
@teg:
        cmp     [vmode],1
        jnz     @nmode2
        push    dx
        push    cx
        push    bx
        mov     cx,3
@egw9:  push    cx
        push    di
        push    ax
        mov     ah,BYTE [ninecol]
        mov     dx,$3ce
        mov     al,0
        out     dx,ax
        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m40+bx]
        mov     ax,dx
        mov     cx,8
        div     cl
        mov     cl,ah
        cbw
        add     di,ax
        mov     bx,128
        shr     bx,cl
        mov     bh,bl
        xor     bh,255
        mov     dx,$3ce
        mov     al,8
        mov     ah,bl
        out     dx,ax

        mov     ax,$a000
        mov     es,ax
        or      BYTE [es:di],al
        or      BYTE [es:di+40],al
        or      BYTE [es:di+80],al
        pop     ax
        pop     di
        inc     di
        pop     cx
        loop    @egw9
        pop     bx
        pop     cx
        pop     dx
        jmp     @expr
@nmode2:
        push    dx
        push    cx
        push    bx
        mov     cx,3
@cgw9:  push    cx
        push    di
        push    ax
        xor     ax,ax
        cmp     [ninecol],0
        jz      @z9c
        mov     ah,1
@z9c:   push    ax

        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m80+bx]
        mov     ax,dx
        mov     cx,4
        div     cl
        mov     cl,ah
        shl     cl,1
        cbw
        add     di,ax
        pop     ax
        xchg    al,ah
        xor     ah,ah
        ror     al,1
        ror     al,1
        shr     ax,cl
        mov     bx,255-(128+64)
        ror     bl,cl
        mov     ah,bl

        mov     bx,$b800
        mov     es,bx
        or      BYTE [es:di],al
        push    di
        cmp     di,$2000
        jl      @n20
        add     di,$2000-80
        jmp     @cgdw
@n20:   add     di,$2000
@cgdw:  or      BYTE [es:di],al
        pop     di
        or      BYTE [es:di+80],al

        pop     ax
        pop     di
        inc     di
        pop     cx
        loop    @cgw9
        pop     bx
        pop     cx
        pop     dx

@expr:  pop     es
END;


PROCEDURE EgaGreys;
CONST
     edac : ARRAY[0..16] OF BYTE = (0,0,0,0,0,0,0,0,16,16,16,7,7,7,255,255,0);
BEGIN
     r.ax := $1002;r.es := Seg(edac);
     r.dx := Ofs(edac);Intr($10,r);
END;

PROCEDURE EgaNorms;
CONST
     edac : ARRAY[0..16] OF BYTE = (0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,0);
BEGIN
     r.ax := $1002;r.es := Seg(edac);
     r.dx := Ofs(edac);Intr($10,r);
END;

PROCEDURE VgaGreys;
BEGIN
     port[$3c8] := 17;
     FOR t := 17 TO 31 DO
     BEGIN
          port[$3c9] := (t-16)*4+2;
          port[$3c9] := (t-16)*4+2;
          port[$3c9] := (t-16)*4+2;
     END;
END;

PROCEDURE GameCols;
BEGIN
     FOR t := 0 TO 255 DO egacross[t] := egacros2[t];
     FOR t := 8 TO 255 DO egacross[t] := egacross[(t DIV 8)*8];
END;

PROCEDURE PicCols;
BEGIN
     FOR t := 0 TO 255 DO egacross[t] := egacros1[t];
     FOR t := 16 TO 255 DO egacross[t] := egacross[(t DIV 8)*8];
END;

END.
