{$I defines.inc}
{$A+,B-,D+,E-,F-,G-,I+,L+,N-,O-,R-,S-,V+,X-}
{$M 4096,0,655360}

USES
    Routines,Globals,Dos,FX,Intro,Writesu,Crt1,
    {$IFDEF REG} Editor,CusPlayU, {$ENDIF}
    midiplay,adlibu
{$IFDEF BIG}
    ,sc27u,sc02u,sc06u,sc04u,sc07u,sc03u,sc12u,sc05u,sc11u,sc18u,sc23u,sc21u
{$IFDEF REG}
   ,sc01u,sc41u,sc43u,sc28u,sc10u,sc08u,sc17u,sc34u,sc38u,sc44u,sc14u,sc39u,
    sc22u,sc15u,sc13u,sc09u,sc19u,sc24u,sc29u,sc37u,sc31u,sc32u,sc40u,sc30u,
    sc33u,sc42u,sc20u,sc45u,sc36u,sc25u,sc35u,sc16u,sc26u
{$ENDIF}
{$ELSE}
    ,sc01u,sc02u
{$ENDIF}
    ;

TYPE
    bptr = ^BYTE;

VAR
   men_choice : BYTE;
   buffer : bptr;
   ts : STRING;
   ch : CHAR;
   rayindex : BYTE;
   playray : ARRAY[0..44] OF BYTE;
   plr : BOOLEAN;

{$F+}
PROCEDURE NewExitProc;
BEGIN
     ExitProc := NIL;
     r.ax := 3;Intr($10,r);
     Midi_Kill;FX_Kill;
     SetIntVec(8,@OldTimer);
     SetIntVec(9,OldKbd);
     kbdinst := FALSE;
     FX_Kill;
     port[$40] := 0;port[$40] := 0;
     {$IFDEF DOX}
     PutUpOrder;
     GotoXY(1,22);
     {$ENDIF}
     TextColor(7);TextBackGround(0);
END;
{$F-}

BEGIN
     IF MaxAvail < $20000 THEN
     BEGIN
          TextColor(14);
          ClrScr;
          Write('WARNING : I may need ',($20000-MaxAvail) DIV 1024,'K more free memory.');
          Writeln;
          Write('Try to run anyway? (Y/N) : ');
          REPEAT ch := Upcase(Readkey) UNTIL ch IN ['Y','N'];
          IF ch = 'N' THEN Halt(0);
     END;
     SwapVectors;SwapVectors;vmode := 7;nosnd := FALSE;
     FOR a := 1 TO paramcount DO
     BEGIN
          ts := paramstr(a);
          FOR t := 1 TO Ord(ts[0]) DO ts[t] := UpCase(ts[t]);
          IF Pos('NOSOUND',ts) > 0 THEN nosnd := TRUE
          ELSE IF Pos('VGA',ts) > 0 THEN vmode := 2
          ELSE IF Pos('EGA',ts) > 0 THEN vmode := 1
          ELSE IF Pos('CGA',ts) > 0 THEN vmode := 0;
     END;
     IF MemW[$0:$463] <> $3d4 THEN vmode := 7 ELSE WITH r DO IF vmode > 2 THEN
     BEGIN
          ax := $13;Intr($10,r);Mem[$a000:0] := $55;t := MemW[$a000:0];ax := $3;Intr($10,r);
          IF t = $55 THEN vmode := 2 ELSE
          BEGIN
               ax := $d;Intr($10,r);Mem[$a000:0] := $55;t := MemW[$a000:0];ax := $3;Intr($10,r);
               IF t = $55 THEN vmode := 1 ELSE
               BEGIN
                    ax := $4;Intr($10,r);Mem[$b800:0] := $55;t := MemW[$b800:0];ax := $3;Intr($10,r);
                    IF t = $55 THEN vmode := 0 ELSE vmode := 4;
               END;
          END;
     END;
     IF vmode > 2 THEN
     BEGIN
          ClrScr;TextColor(14);
          Writeln('Error detecting video hardware.',#13#10);
          Writeln('Try using /VGA, /EGA or /CGA switch to override.'#13#10);
          Halt(0);
     END;
     FOR t := 0 TO 127 DO key[t] := FALSE;
     Randomize;Init_Once;ExitProc := @NewExitProc;FX_Init(TRUE);
     FOR t := 0 TO 127 DO key[t] := FALSE;
{     REPEAT
           clrscr;
           for t := 0 to 127 do if key[t] then write(t:4);
     UNTIL key[1];
}
     port[$40] := 10;port[$40] := 16;
     Pre_Intro;PicCols;Do_Intro;
     GameCols;
     REPEAT
      men_choice := Main_Selector;
      CASE men_choice OF
       31 : CASE which_to_play OF
             1 : BEGIN
                  eomission := 100;
{$IFDEF BIG}
                  max_screens := 12;
{$ELSE}
                  max_screens := 2;
{$ENDIF}
                  SetVGA;Load_Dac;
{$IFDEF BIG}
                  if sc27_0 and sc02_0 and sc06_0 and sc04_0 and sc07_0 and
                     sc03_0 and sc12_0 and sc05_0 and sc11_0 and sc18_0 and
                     sc23_0 and sc21_0 THEN;
{$ELSE}
                  IF sc01_0 AND sc02_0 THEN;
{$ENDIF}
                 END;
             2 : BEGIN
                  eomission := 250;
                  max_screens := 15;
                  SetVGA;Load_Dac;
{$IFDEF BIG}
{$IFDEF REG}
                  if sc01_0 and sc41_0 and sc43_0 and sc28_0 and sc10_0 and
                     sc08_0 and sc17_0 and sc34_0 and sc38_0 and sc44_0 and
                     sc14_0 and sc39_0 and sc22_0 and sc15_0 and sc13_0 THEN;
{$ENDIF}
{$ENDIF}
                 END;
             3 : BEGIN
                  eomission := 500;
                  max_screens := 15;
                  SetVGA;Load_Dac;
{$IFDEF BIG}
{$IFDEF REG}
                  if sc09_0 and sc19_0 and sc24_0 and sc29_0 and sc37_0 and
                     sc31_0 and sc32_0 and sc40_0 and sc30_0 and sc33_0 and
                     sc42_0 and sc20_0 and sc45_0 and sc36_0 and sc25_0 and
                     sc35_0 and sc16_0 and sc26_0 THEN;
{$ENDIF}
{$ENDIF}
                 END;
             4 : BEGIN
                  eomission := 750;
                  max_screens := 45;
                  SetVGA;Load_Dac;
{$IFDEF BIG}
{$IFDEF REG}
                  if sc27_0 and sc02_0 and sc06_0 and sc04_0 and sc07_0 and
                     sc03_0 and sc12_0 and sc05_0 and sc11_0 and sc18_0 and
                     sc23_0 and sc21_0 and
                     sc01_0 and sc41_0 and sc43_0 and sc28_0 and sc10_0 and
                     sc08_0 and sc17_0 and sc34_0 and sc38_0 and sc44_0 and
                     sc14_0 and sc39_0 and sc22_0 and sc15_0 and sc13_0 and
                     sc09_0 and sc19_0 and sc24_0 and sc29_0 and sc37_0 and
                     sc31_0 and sc32_0 and sc40_0 and sc30_0 and sc33_0 and
                     sc42_0 and sc20_0 and sc45_0 and sc36_0 and sc25_0 and
                     sc35_0 and sc16_0 and sc26_0 THEN;
{$ENDIF}
{$ENDIF}
                 END;
             5 : BEGIN
                  eomission := 0;
                  max_screens := 32000;
                  SetVGA;Load_Dac;
                  rayindex := 45;
{$IFDEF BIG}
{$IFDEF REG}
                  REPEAT
                        IF rayindex = 45 THEN
                        BEGIN
                             rayindex := 0;
                             playray[0] := 28;
                             FOR t := 1 TO 44 DO
                             BEGIN
                                  REPEAT
                                        res := Random(45)+1;
                                        FOR a := 0 TO t-1 DO
                                            IF res = playray[a] THEN res := 46;
                                  UNTIL (res < 46);
                                  playray[t] := res;
                             END;
                        END;
                        CASE (playray[rayindex]) OF
                         1:plr := sc01_0;2:plr := sc02_0;3:plr := sc03_0;
                         4:plr := sc04_0;5:plr := sc05_0;6:plr := sc06_0;
                         7:plr := sc07_0;8:plr := sc08_0;9:plr := sc09_0;
                         10:plr := sc10_0;
                         11:plr := sc11_0;12:plr := sc12_0;13:plr := sc13_0;
                         14:plr := sc14_0;15:plr := sc15_0;16:plr := sc16_0;
                         17:plr := sc17_0;18:plr := sc18_0;19:plr := sc19_0;
                         20:plr := sc20_0;
                         21:plr := sc21_0;22:plr := sc22_0;23:plr := sc23_0;
                         24:plr := sc24_0;25:plr := sc25_0;26:plr := sc26_0;
                         27:plr := sc27_0;28:plr := sc28_0;29:plr := sc29_0;
                         30:plr := sc30_0;
                         31:plr := sc31_0;32:plr := sc32_0;33:plr := sc33_0;
                         34:plr := sc34_0;35:plr := sc35_0;36:plr := sc36_0;
                         37:plr := sc37_0;38:plr := sc38_0;39:plr := sc39_0;
                         40:plr := sc40_0;
                         41:plr := sc41_0;42:plr := sc42_0;43:plr := sc43_0;
                         44:plr := sc44_0;45:plr := sc45_0;
                        END;
                        Inc(rayindex);
                  UNTIL NOT plr;
{$ENDIF}
{$ENDIF}
                 END;
             6..9 : BEGIN
             {$IFDEF REG}
                         eomission := 500;
                         Assign(f,scrnames[0,which_to_play-which_base].fname+'.jml');
                         {$I-} Reset(f,1);{$I+}
                         IF ioresult = 0 THEN
                         BEGIN
                              BlockRead(f,cus_max,1);Close(f);
                              max_screens := cus_max;
                              cus_play := 0;current_level := 0;
                              REPEAT Inc(cus_play)
                              UNTIL (cus_play > cus_max) OR Play_Custom;
                         END;
             {$ENDIF}
             END;
            END;  (* End if inner case *)
       18 : {$IFDEF REG} WorkStation; {$ELSE}
            BEGIN
                 SetHires;IF vmode = 1 THEN EgaGreys;
                 Writes('THE EDITOR IS ONLY',0,0,TRUE);
                 Writes('AVAILABLE IN THE',0,16,TRUE);
                 Writes('REGISTERED VERSION',0,32,TRUE);
                 Writes('OF JUMPMAN LIVES!',0,48,TRUE);
                 Writes('PLEASE REFER TO THE',0,64,TRUE);
                 Writes('ORDERING INFO FOR',0,80,TRUE);
                 Writes('DETAILS. THANK YOU!',0,96,TRUE);
                 IF GetAKey2 = 0 THEN;
            END; {$ENDIF}
      END;
     UNTIL men_choice = 1;
END.
