MODEL tpascal

.CODE

SIZEX   = 20
SIZEY   = 17

Public  Moveimage
Public  Drawimage
Public  InitTable
Public  Rotate_Pow
Public  Bump_It
Public  P_Stretch_1
Public  P_Stretch_2
Public  P_Stretch_3
Public  P_Stretch_4

Drawimage       PROC NEAR x,y,point

        mov     si,point
        mov     bx,y
        shl     bx,1
        mov     di,[m320+bx]
        mov     ax,x
        mov     drawx,ax
        add     di,ax
        mov     ax,0a000h
        mov     es,ax
        mov     al,[si]
        mov     wd,al
        inc     wd
        mov     al,[si+1]
        mov     ht,al
        add     si,2
        cld
        xor     cx,cx
di1:    mov     cl,wd
        mov     bx,drawx
di2:    cmp     bx,0
        js      nomov
        cmp     bx,319
        jg      nomov
        movsb
        dec     si
        dec     di
nomov:  inc     di
        inc     si
        inc     bx
        loop    di2
        add     di,320
        mov     al,wd
        cbw
        sub     di,ax
        dec     ht
        jns     di1
        ret

Drawimage       ENDP

Moveimage       PROC NEAR       x,y,pointb,point : WORD,key1 : BYTE,key2 : BYTE,direct : BYTE

        push    ds
        pop     es
        xor     bx,bx
        mov     al,key1
        mov     bl,key2
        cbw
        mov     si,refr
        add     si,ax
        mov     ah,byte ptr [si]
        mov     al,ah
        add     al,ah
        add     al,ah
        mov     si,refr2
        cbw
        add     si,ax
        mov     al,byte ptr [si]
        mov     key1c,al
        add     si,bx
        mov     al,byte ptr [si]
        mov     key2c,al
        mov     al,direct
        mov     si,point
        add     si,2
        mov     di,offset curim+2
        cmp     al,0
        jz      normd
        mov     dl,SIZEY
flpls:  mov     cx,SIZEX
        add     si,SIZEX-1
flpl:   mov     al,[si]
        mov     [di],al
        dec     si
        inc     di
        loop    flpl
        add     si,SIZEX+1
        dec     dl
        jnz     flpls
        jmp     short   dresume
normd:  mov     cx,(SIZEY*(SIZEX/2))
        rep     movsw                   ;New image @ 'curim'
dresume:mov     bx,pointb
        shl     bx,1
        mov     ax,[tblref+bx]
        mov     lastim,ax

        mov     si,offset curim+2
        mov     bx,y
        mov     movey,bl
        shl     bx,1
        mov     di,[m320+bx]
        mov     ax,x
        mov     movex,ax
        add     di,ax                   ;DI = Screen location

        mov     ax,0a000h
        mov     es,ax                   ;ES = Screen SEG
        cld
        mov     dl,SIZEY                   ;21 High
        xor     bx,bx
        mov     bl,movey
        cmp     bx,200
        jl      mtosc
        dec     bh
mtosc:  mov     cx,SIZEX                   ;24 Wide
mtos:   lodsb                           ;Read curim
        or      al,al
        jz      nmto                    ;Don't write 0's
        or      bx,bx
        js      nmto
        cmp     bx,200
        jge     skate1
        mov     ah,es:[di]
        or      ah,ah
        jz      zoko
        cmp     ah,32                   ;
        jl      nmto                    ;Illegal Attributes to write over
        cmp     ah,64                   ;
        jg      nmto
zoko:   cmp     al,key1c
        jnz     wnkey
        mov     al,key2c
wnkey:  mov     es:[di],al
nmto:   inc     di
        loop    mtos
        inc     bx
        jnz     okmy
        mov     di,SIZEX-320
        add     di,movex
okmy:   add     di,320-SIZEX
        dec     dl
        jnz     mtosc
skate1: mov     di,lastim               ;DI = OldImage
        mov     si,offset curim+2       ;SI = Newimage
        push    di
        push    si

        mov     ax,[di+0]
        sub     ax,x
        js      leftward

        add     si,ax
        mov     bl,SIZEX-1
        sub     bl,al
        mov     endx,bl
        mov     startx,0
        jmp     short conx

leftward:
        neg     ax
        sub     si,ax
        mov     startx,al
        mov     endx,SIZEX-1
conx:   mov     ax,[di+2]
        sub     ax,y
        js      downward
        mov     bl,SIZEY-1
        sub     bl,al
        mov     endy,bl
        cbw
        mov     bx,ax
        shl     bx,1
        mov     ax,[two4tab+bx]
        add     si,ax
        cbw
        mov     starty,ah
        jmp     short cony
downward:
        neg     ax
        mov     starty,al
        cbw
        mov     bx,ax
        shl     bx,1
        mov     ax,[two4tab+bx]
        sub     si,ax
;off screen?
        mov     endy,SIZEY-1
cony:   mov     bx,[di+2]
        mov     movey,bl
        shl     bx,1
        push    bp
        mov     ax,[bx+m320]            ;ax is y
        mov     bp,[di]                 ;bp is x coord
        mov     movex,bp
        add     bp,ax                   ;bp is scnloc
        xor     cx,cx
        add     di,4                    ;DI=offs to old data
        mov     ah,movey
        mov     bl,starty
        mov     bh,endy
        mov     dl,startx
        mov     dh,endx
doy:    xor     cl,cl
dox:    mov     al,[di]
        or      al,al
        jz      nope                    ;Don't bother w/a zero
        mov     al,ah
        or      al,al
        jnz     okah
        and     al,127
        cmp     al,102
        jge     nope
        cmp     ah,72
        jge     skate2

okah:   cmp     ch,bl
        jb      toff                    ;Exceeds boundery
        cmp     ch,bh
        ja      toff                    ;Exceeds boundery
        cmp     cl,dl
        jb      toff                    ;Exceeds boundery
        cmp     cl,dh
        ja      toff                    ;Exceeds boundery
        mov     al,[si]
        or      al,al
        jnz     nope
toff:   mov     al,es:[bp]
        cmp     al,32
        jl      nope
        cmp     al,64
        jg      nope
        xor     al,al
;        mov     al,15
        cmp     al,key1c
        jnz     wrnc
        mov     al,key2c
wrnc:   mov     es:[bp],al
nope:   inc     cl
        inc     di
        inc     si
        inc     bp
        cmp     cl,SIZEX-1
        jbe     dox
        inc     movey
        jnz     okpos
        mov     bp,SIZEX-320
        add     bp,movex
okpos:  add     bp,320-SIZEX
        inc     ch
        cmp     ch,SIZEY-1
        jbe     doy

skate2: pop     bp
        pop     si
        pop     di
        mov     ax,x
        mov     [di],ax
        mov     ax,y
        mov     [di+2],ax
        add     di,4
        push    ds
        pop     es
        mov     cx,SIZEY*(SIZEX/2)
        rep     movsw
        ret

MoveImage       endp

InitTable PROC  NEAR lasts,ptorad,p2,p3 : WORD;
        push    ds
        pop     es
        xor     ax,ax
        mov     cx,200
        cld
        mov     di,offset m320
loptb:  stosw
        add     ax,320
        loop    loptb
        mov     ax,lasts
        mov     di,offset tblref
        mov     cx,30
loptr:  stosw
        add     ax,SIZEX*SIZEY+4
        loop    loptr
        mov     al,15
        mov     blucomp,al
        mov     al,40
        mov     redcomp,al
        mov     al,2
        mov     pow_del,al
        mov     si,offset ptorad
        mov     di,offset radis
        mov     cx,32
        rep     movsw
        mov     di,offset two4tab
        mov     ax,0
        mov     cx,30
lop24:  stosw
        add     ax,SIZEX
        loop    lop24
        mov     ax,p2
        mov     refr,ax
        mov     ax,p3
        mov     refr2,ax
        ret
InitTable ENDP

GRNCOMP EQU     10

Rotate_Pow PROC NEAR
        dec     pow_del
        jnz     powex
        call    Pause
        mov     al,20
        mov     pow_del,al
        mov     dx,3c8h
        mov     al,85
        out     dx,al
        inc     dx
        mov     al,redcomp
        out     dx,al
        mov     al,GRNCOMP
        out     dx,al
        mov     al,blucomp
        out     dx,al
        mov     al,redcomp
        mov     ah,blucomp
        mov     redcomp,ah
        mov     blucomp,al
powex:  ret

Rotate_Pow ENDP

Pause   PROC    NEAR
        mov     dx,3dah
        sti
        sub     ah,ah
rast1:  cli
        in      al,dx
        test    al,8
        jz      rast1
        sti
        ret
Pause   ENDP

Bump_It PROC NEAR a,b,c,d : WORD;

        mov     ax,a
        mov     bmx,ax
        mov     ax,b
        mov     bmy,ax
        mov     ax,d
        mov     dx,c
        mov     bmstage,dx
        xor     bx,bx
        xor     bp,bp
        or      al,al
        jz      stbx
        mov     bx,BSIZE
        mov     bp,2
stbx:   mov     badd,bx

        cmp     dx,-3
        jnz     inprog

        mov     dl,22
        mov     di,offset bmp1
        add     di,badd
        mov     bx,bmy
        shl     bx,1
        mov     si,[m320+bx]
        add     si,bmx
        mov     ds:[bmploc+bp],si
        push    ds
        pop     es
        mov     ax,0a000h
        mov     ds,ax
        cld
bmin1:  mov     cx,16
bmin2:  lodsb
        cmp     al,32
        jl      bmkl
        cmp     al,64
        jg      bmkl
        xor     al,al
bmkl:   stosb
        loop    bmin2
        add     si,320-16
        dec     dl
        jnz     bmin1
        push    es
        pop     ds
        mov     di,offset bmp2+(16*13)
        add     di,badd
        xor     al,al
        mov     cx,9*16
        rep     stosb

inprog: mov     bx,bmstage
        cmp     bx,0
        jns     backdn
        add     bx,4
        call    Construct
        jmp     short bment
backdn: mov     ax,bx
        mov     bx,2
        sub     bx,ax
        call    Construct
bment:  mov     di,ds:[bmploc+bp]
        mov     si,offset bmp2
        add     si,badd
        mov     ax,0a000h
        mov     es,ax
        mov     dl,18
bmdr1:  mov     cx,16
bmdr2:  lodsb
        or      al,al
        jnz     bdrw
        mov     ah,es:[di]
        cmp     ah,32
        jl      bdrw
        cmp     ah,64
        jl      bndrw
bdrw:   stosb
        dec     di
bndrw:  inc     di
        loop    bmdr2
        add     di,320-16
        dec     dl
        jnz     bmdr1
        ret

Bump_It ENDP

Construct PROC  NEAR            ;Construct the bent matrix

        mov     cl,4
        shl     bx,cl                    ;*16
        add     bx,offset radis
        push    bx
        mov     dl,15                   ;0 TO 14
        mov     si,offset bmp1
        add     si,badd
        mov     di,offset bmp2
        add     di,badd
bmup1:  mov     cx,16                   ;0 TO 15
        pop     bx
        push    bx
bmup2:  mov     al,[bx]                 ;get y radius factor
        push    bx
        cbw
        shl     ax,1
        shl     ax,1
        shl     ax,1
        shl     ax,1
        mov     bx,ax
        mov     al,[bx+si]              ;# from orig data+curve
        inc     si
        stosb
        pop     bx
        inc     bx
        loop    bmup2
        dec     dl
        jnz     bmup1
        pop     bx
        ret

Construct ENDP

P_Stretch_1 PROC NEAR a,b : WORD;

STRET1L EQU     22    ;18
STRET1R EQU     47    ;39

        mov     ax,a
        mov     bmx,ax
        mov     si,b
        mov     bx,STRET1R
        sub     bx,ax
        mov     rtcnt,bl
        mov     bx,ax
        sub     bx,STRET1L
        mov     lfcnt,bl
        mov     di,(-320*1)+2
        mov     dl,20
        call    Draw_Stretch
        ret

P_Stretch_1 ENDP

P_Stretch_2 PROC NEAR a,b : WORD;

STRET2L EQU     268
STRET2R EQU     293

        mov     ax,a
        mov     bmx,ax
        mov     si,b
        mov     bx,STRET2R
        sub     bx,ax
        mov     rtcnt,bl
        mov     bx,ax
        sub     bx,STRET2L
        mov     lfcnt,bl
        mov     di,(-320*1)+2
        mov     dl,20
        call    Draw_Stretch
        ret

P_Stretch_2 ENDP

P_Stretch_3 PROC NEAR a,b : WORD;

STRET3L EQU     7
STRET3R EQU     31

        mov     ax,a
        mov     bmx,ax
        mov     si,b
        mov     bx,STRET3R
        sub     bx,ax
        mov     rtcnt,bl
        mov     bx,ax
        sub     bx,STRET3L
        mov     lfcnt,bl
        mov     di,320*172-7
        mov     dl,17
        call    Draw_Stretch
        ret

P_Stretch_3 ENDP

P_Stretch_4 PROC NEAR a,b : WORD;

STRET4L EQU     302
STRET4R EQU     326

        mov     ax,a
        mov     bmx,ax
        mov     si,b
        mov     bx,STRET4R
        sub     bx,ax
        mov     rtcnt,bl
        mov     bx,ax
        sub     bx,STRET4L
        mov     lfcnt,bl
        mov     di,320*172-7
        mov     dl,17
        call    Draw_Stretch
        ret

P_Stretch_4 ENDP

Draw_Stretch PROC NEAR

        cld
        add     di,bmx
        mov     ax,0a000h
        mov     es,ax
drst1:  mov     cx,20
        mov     bl,lfcnt
        mov     bh,rtcnt
drst2:  lodsb
        cmp     bl,0
        js      nstr
        cmp     bh,0
        js      nstr
dstr:   stosb
        dec     di
nstr:   inc     di
        inc     bl
        dec     bh
        loop    drst2
        add     di,320-20
        dec     dl
        jnz     drst1
        ret

Draw_Stretch ENDP

.DATA

refr    dw      ?
refr2   dw      ?

key1c   db      ?
key2c   db      ?

curim   db      SIZEY*SIZEX+2 DUP (?)

m320    dw      200 DUP (?)

lastim  dw      ?

tblref  dw      30 DUP (?)
two4tab dw      30 DUP (?)

startx  db      ?
endx    db      ?
starty  db      ?
endy    db      ?
newloc  dw      ?
movey   db      ?
movex   dw      ?

wd      db      ?
ht      db      ?

drawx   dw      ?

pow_del db      ?
redcomp db      ?
blucomp db      ?

bmx     dw      ?
bmy     dw      ?
bmstage dw      ?
radis   db      4*16 DUP(?)
bmploc  dw      ?,?
bmp1    db      44*16 DUP(?)
bmp2    db      44*16 DUP(?)
badd    dw      ?                 ;Offset add to 2nd image
BSIZE   EQU     22*16

lfcnt   db      ?
rtcnt   db      ?

DATA    ENDS

END

