{$I defines.inc}
UNIT Routines;

INTERFACE

USES
    Dos,Dact,FX,Crt1,MidiPlay,Adlibu,Globals,Writesu,jman2u,
    pel1u,gird1u,ladd1u,jman1u,ropes1u,bull1u,rock4u,rock3u,MusicU;

PROCEDURE DrawImage(x,y,point : INTEGER;
                    remove,
                    draw0,
                    orit,
                    flip  : BOOLEAN;
                    andb   : BYTE);
FUNCTION  Moveimage(x,y,pointb,point,p1,p2,mask : INTEGER;
                    direct : BOOLEAN) : WORD;
PROCEDURE Scan(x,y,point : WORD);
FUNCTION  GetOfs(n : BYTE) : WORD;
PROCEDURE SetVGA;
PROCEDURE GenDraw(n,m : PNT);
PROCEDURE Check_Ladder;
PROCEDURE Do_Actions;
PROCEDURE MovePlayer;
PROCEDURE Check_Green;
PROCEDURE Pel_Hit(n : PNT);
PROCEDURE Dying;
PROCEDURE MoveDots(n : BYTE;m : BOOLEAN);
PROCEDURE Play(pnn1,pnn2 : PNT;
               mdot,in1,in2 : BYTE);
PROCEDURE Modify(p1,p2,p3,p4,p5,p6,p14 : POINTER);
PROCEDURE RTime;
PROCEDURE SetBorder(n : BYTE);
PROCEDURE Init_Once;
PROCEDURE Status_All;
PROCEDURE Draw_Man;
PROCEDURE InitPl;
PROCEDURE DrawPtrs(n : BOOLEAN);

CONST
     START_BTICK = 1100;
VAR
   violent,
   bonus_change : BOOLEAN;
   last_score   : LONGINT;
   curim        : ARRAY[0..1500] OF BYTE;
   oldis        : ARRAY[1..2] OF BYTE;
   oldpl        : BYTE;

IMPLEMENTATION
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE D1;EXTERNAL;{$L d1}
PROCEDURE D3;EXTERNAL;{$L d3}
PROCEDURE D4;EXTERNAL;{$L d4}
PROCEDURE D5;EXTERNAL;{$L d5}
PROCEDURE D6;EXTERNAL;{$L d6}
PROCEDURE D7;EXTERNAL;{$L d7}
{$F+} PROCEDURE Nothin;BEGIN END;{$F-}
{$IFDEF PICS}
PROCEDURE Satrnexp;EXTERNAL;{$L Satrnexp}
{$ENDIF PICS}
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE SetBorder(n : BYTE);
BEGIN
{     port[$3c0] := $11;
     port[$3c0] := n;
     port[$3c0] := $20;}
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Modify(p1,p2,p3,p4,p5,p6,p14 : POINTER);
PROCEDURE Moddit(VAR p7,p8,p9,p10,p11,p12,p13 : POINTER);
BEGIN
     p7 := p1;
     p8 := p2;
     p9 := p3;
     p10 := p4;
     p11 := p5;
     p12 := p6;
     p13 := p14;
END;
BEGIN
     FOR t := 1 TO 4 DO p[t].pdeath := 5;
     asm cli end;
     Moddit(@cproc,@cdot,@caction,@cdied,@cbeg,@cend,@ctim);
     asm sti end;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
{$F+}
PROCEDURE NewTimer;INTERRUPT;
CONST
     ints : WORD = 0;
     entered : BOOLEAN = FALSE;

BEGIN
     Inc(AbsTime);
     Inc(ints);
     Inc(DelayV);
     On_Timer;ctim;RTime;
     IF (ints AND 15) = 0 THEN
     BEGIN
          ASM pushf END;
          OldTimer;
     END ELSE port[$20] := $20;
     IF key[29] AND key[56] AND key[83] AND (NOT entered) THEN
     BEGIN
          entered := TRUE;
          Halt(0);
     END;
END;
PROCEDURE NewKbd;INTERRUPT;ASSEMBLER;
VAR
   keyw : BYTE;
ASM
        in      al,$60
        mov     dl,1
        test    al,128
        jz      @ispr
        mov     dl,0
@ispr:  and     al,127
        cbw
        mov     bx,ax
        mov     BYTE [key+bx],dl
        in      al,$61
        or      al,$80
        out     $61,al
        and     al,$7f
        out     $61,al
        mov     al,$20
        out     $20,al
END;
{$F-}
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE DrawImage(x,y,point : INTEGER;
                    remove,
                    draw0,
                    orit,
                    flip   : BOOLEAN;
                    andb   : BYTE);ASSEMBLER;
VAR
   drawx : WORD;
   ori : BYTE;
   wd,ht : INTEGER;

ASM
        mov     si,[point]
        mov     bx,[y]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        mov     [drawx],ax
        add     di,ax
        xor     ax,ax
        push    ds
        pop     es
        lodsb
        mov     [wd],ax
        inc     [wd]
        lodsb
        mov     [ht],ax
        push    di
        mov     di,offset (dbuf)
        cmp     [flip],0
        jz      @normdd
        mov     dx,[ht]
@flplsd:mov     cx,[wd]
        add     si,[wd]
        dec     si
@flpld: mov     al,[si]
        dec     si
        stosb
        loop    @flpld
        add     si,[wd]
        inc     si
        dec     dl
        jns     @flplsd
        jmp     @desume
@normdd:mov     ax,[wd]
        mov     cx,[ht]
        inc     cx
        mul     cx
        xchg    ax,cx
        rep     movsb
@desume:mov     es,WORD [b64k+2]
        mov     si,Offset(dbuf)
        pop     di
        mov     dl,[remove]
        mov     cl,[orit]
        mov     [ori],cl
        cld
        xor     cx,cx
        mov     ah,andb
@di1:   mov     cl,BYTE [wd]
        mov     bx,[drawx]
@di2:   cmp     bx,0
        js      @nomov
        cmp     bx,319
        jg      @nomov
        mov     al,[si]
        cmp     draw0,0
        jnz     @skp0t
        or      al,al
        jz      @nomov
@skp0t: or      dl,dl
        jz      @dodr
        mov     al,BYTE [es:di]
        and     al,ah
@dodr:  cmp     [ori],0
        jnz     @dodr2
        call    WriteEsDiAl
{        mov     BYTE [es:di],al}
        jmp     @nomov
@dodr2: mov     ah,BYTE [es:di]
        or      ah,al
        xchg    al,ah
        call    WriteEsDiAl
        xchg    al,ah
{        mov     BYTE [es:di],ah}
@nomov: inc     di
        inc     si
        inc     bx
        loop    @di2
        add     di,320
        mov     al,BYTE [wd]
        push    ax
        cbw
        sub     di,ax
        pop     ax
        dec     [ht]
        jns     @di1
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Moveimage(x,y,pointb,point,p1,p2,mask : INTEGER;
                    direct : BOOLEAN) : WORD;ASSEMBLER;

VAR
   movres,hilim,movex,movey,lastl,lolim,
   xsize,ysize : WORD;
   mas,
   endy,starty,
   endx,startx : BYTE;

ASM
        push    ds
        pop     es
        xor     bx,bx
        mov     si,[point]
        mov     ax,[mask]
        mov     [mas],al
        lodsb
        cbw
        mov     [xsize],ax
{        push    ax}
        inc     ax
        shr     ax,1
        add     ax,3
        mov     [hilim],ax
        sub     ax,5
        jns     @okll
        xor     ax,ax
@okll:  mov     [lolim],ax

{        pop     ax
        sub     ax,2
        cmp     [lolim],ax
        jl      @oklms
        mov     ax,[lolim]
@oklms: mov     [hilim],ax}
        lodsb
        inc     ax
        mov     [ysize],ax
        mov     al,[direct]

        mov     di,offset [curim]
        or      al,al
        jz      @normd
        mov     dx,[ysize]
@flpls: mov     cx,[xsize]
        inc     cx
        add     si,[xsize]
@flpl:  mov     al,[si]
        stosb                           (*Mirror image*)
        dec     si
        loop    @flpl
        add     si,[xsize]
        inc     si
        inc     si
        dec     dl
        jns     @flpls
        jmp     @dresume
@normd: mov     ax,[xsize]
        inc     ax
        mul     [ysize]
        mov     cx,ax

        rep     movsb                   (* New image @ 'curim' *)

@dresume:
        mov     si,offset curim
        mov     bx,[y]
        mov     [movey],bx
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        mov     [movex],ax
        add     di,ax                   (*DI = Screen location*)

        mov     ax,WORD [b64k+2]
        mov     es,ax                   (*ES = Screen SEG*)
        mov     dx,[ysize]              (*Get Y size*)
        mov     movres,0
        mov     ax,WORD [p1]
        mov     bx,WORD [p2]
        mov     bh,al
@mtosc: push    [movex]
        mov     cx,[xsize]
        add     si,[xsize]
        inc     si
        cmp     [movey],200
        jge     @skp1
        cmp     [movey],0
        jl      @skp1
        sub     si,[xsize]
        dec     si
        inc     cx
        or      dl,dl
        jnz     @mtos
        sub     cx,8
        jz      @skpa
        js      @skpa
        add     di,4
@mtos:  lodsb                           (*Read curim*)
        cmp     al,bh
        jnz     @notp1
        mov     al,bl
@notp1: mov     ah,BYTE [es:di]
        push    ax
        and     ah,$f8
        cmp     ah,248
        jnz     @popgo
        or      dl,dl
        jz      @onein
        or      [movres],3
@onein: or      [movres],1
@popgo: pop     ax
        and     ah,[mas]
        or      dl,dl
        jz      @okat2
        cmp     [disapp],0
        jnz     @n0ch
        or      al,al
        jz      @zoko
@n0ch:  or      ah,ah
        jz      @okat1
        js      @okat3
        cmp     ah,5
        jle     @okat1
        cmp     ah,7
        jle     @bkat1
        cmp     ah,39
        jle     @okat1
@bkat1: or      [movres],8
        jmp     @okat1
@okat3: or      [movres],32
@okat1: and     ah,7
        or      ah,ah
        jz      @zoko
        cmp     cx,[lolim]
        jl      @okat2
        cmp     cx,[hilim]
        jg      @okat2
        or      [movres],16
        cmp     ah,1
        jz      @fulc
        cmp     ah,2
        jnz     @okat2
        or      [movres],4
        jnz     @zoko
@fulc:  or      [movres],3
@okat2: and     ah,7
        cmp     ah,1
        jnz     @zoko
        or      dl,dl
        jnz     @zoko
        or      [movres],1
@zoko:  or      dl,dl
        jz      @nmto
        and     ah,7
        or      al,ah
        cmp     [movex],320
        jge     @nmto
        cmp     [movex],0
        jl      @nmto
        call    WriteEsDiAl
{        mov     BYTE [es:di],al}
@nmto:  inc     di
        inc     [movex]
        dec     cx
        jz      @eocx
        jmp     @mtos
@eocx:  add     di,319
        sub     di,[xsize]
        jmp     @xxx
@skp1:  mov     di,[movex]
@xxx:   pop     [movex]
        inc     [movey]
        dec     dl
        jns     @mtosc

{----------------------------------- New image drawn ----}

@skpa:  mov     di,offset lastims
        mov     bx,[pointb]
        shl     bx,1
        shl     bx,1
        add     di,bx
        mov     [lastl],di
        mov     ax,[di+0]
        sub     ax,[x]
        js      @leftward
        mov     bx,[xsize]
        inc     bx
        mov     [endx],bl
        sub     bx,ax
        mov     [startx],bl
        jmp     @conx

@leftward:
        neg     ax
        mov     [startx],0
        mov     [endx],al          {-}
@conx:  mov     ax,[di+2]
        sub     ax,[y]
        js      @downward
        mov     bx,[ysize]
        mov     [endy],bl
        sub     bx,ax
        mov     [starty],bl
        jmp     @cony
@downward:
        neg     ax
        mov     [starty],0
        dec     al
        mov     [endy],al       {-}
@cony:  mov     di,[lastl]
        push    di
        mov     bx,[di+2]
        mov     [movey],bx
        or      bx,bx
        jns     @oky
        xor     bx,bx
@oky:   shl     bx,1
        mov     ax,WORD [bx+m320]            (*ax is y*)
        mov     si,[di]
        mov     [movex],si
        add     si,ax                   (*si = scnloc*)
        mov     bl,[starty]
        mov     bh,[endy]
        mov     dl,[startx]
        mov     dh,[endx]
        xor     cx,cx
@doy:   xor     cl,cl
        push    [movex]
        cmp     [movey],200
        jge     @skp2
        cmp     [movey],0
        jl      @skp2

@dox:   cmp     cl,dl
        jl      @chks1
        cmp     cl,dh
        jl      @toff
@chks1: cmp     ch,bl
        jl      @nope
        cmp     ch,bh
        jg      @nope

@toff:  mov     al,BYTE [es:si]
        and     al,7
{        or      al,15}

{        mov     BYTE [es:si],al}
        xchg    si,di
        call    WriteEsDiAl
        xchg    si,di
@nope:  inc     cl
        inc     si
        cmp     cl,BYTE [xsize]
        jbe     @dox
        add     si,319
        sub     si,[xsize]
@skp2:  pop     [movex]
        inc     [movey]
        inc     ch
        cmp     ch,BYTE [ysize]
        jb      @doy

        pop     di
        mov     ax,[x]
        mov     [di],ax
        mov     ax,[y]
        mov     [di+2],ax
        mov     ax,[movres]
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Scan(x,y,point : WORD); ASSEMBLER;
ASM
        push    ds
        push    ds
        pop     es
        mov     di,[point]
        inc     di
        mov     bx,[y]
        or      bx,bx
        js      @clrs
        shl     bx,1
        mov     si,WORD [m320 + bx]
        add     si,[x]
        sub     si,2
        mov     cx,10
        mov     ds,WORD [b64k+2]
@scc:   lodsw
{        push    ax
        and     ax,$c0c0;
        cmp     ax,$c0c0
        jnz     @popgs
        pop     ax
        mov     ax,$0303;
        jz      @npgs
@popgs: pop     ax}
        and     ax,$0707;
@npgs:  stosw
        loop    @scc
        pop     ds
        jmp     @escn
@clrs:  mov     cx,10
        rep     stosw
        pop     ds
@escn:
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION GetOfs(n : BYTE) : WORD;
BEGIN
     CASE n OF
      1 : GetOfs := Ofs(pel1);
      2 : GetOfs := Ofs(gird1);
      3 : GetOfs := Ofs(ladd1);
      4 : GetOfs := Ofs(jman1);
      5 : GetOfs := Ofs(ropes1[0]);
      6 : GetOfs := Ofs(ropes1[1]);
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE SetVGA;
BEGIN
     directvideo := FALSE;
{     r.ax := $13;Intr($10,r);}
     SetHires;
     Load_Dac;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
{$F+}
PROCEDURE RTime;
VAR
   n : BYTE;
BEGIN
     IF pl IN [1..4] THEN FOR n := 2 TO 9 DO IF key[n] THEN p[pl].next_speed := n-1;
     IF (pl IN [1..4]) AND (p[pl].pdeath < 2) AND (bonus > 0) THEN
     BEGIN
          Dec(btick);
          IF btick = 0 THEN
          BEGIN
               btick := START_BTICK;
               bonus_change := TRUE;
               Dec(bonus,100);
          END;
     END;
END;
{$F-}
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Change(VAR p1 : POINTER);
BEGIN p1 := @Nothin; END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Init_Once;
BEGIN
     FOR t := 1 TO 4 DO WITH p[t] DO
     BEGIN
          idevice := 0;
          keys[0] := 75;
          keys[1] := 77;
          keys[2] := 72;
          keys[3] := 80;
          keys[4] := 57;
     END;
     FOR t := 0 TO 1 DO
     BEGIN
          lj[t] := 1000;
          uj[t] := 1000;
          dj[t] := 0;
          rj[t] := 0;
     END;
     FOR t := 0 TO 199 DO m320[t] := t*320;
     FOR t := 0 TO 199 DO m40[t] := t*40;
     FOR t := 0 TO 199 DO
         IF Odd(t) THEN m80[t] := $2000+(t DIV 2)*80
         ELSE m80[t] := (t DIV 2)*80;
     FOR t := 8 TO 255 DO egacross[t] := egacros1[(t DIV 8)*8];
     FOR t := 16 TO 255 DO cgacross[t] := cgacross[(t DIV 8)*8];
     FOR t := 0 TO 15 DO egacross[t] := t;
     Change(@ctim);
     GetIntVec(8,@OldTimer);
     SetIntVec(8,@NewTimer);
     GetIntVec(9,OldKbd);
     SetIntVec(9,@NewKbd);
     kbdinst := TRUE;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION ItoA2(n : BYTE) : STRING;
VAR
   sof2 : STRING[2];
BEGIN
     Str(n,sof2);
     IF sof2[0] = #1 THEN sof2 := '0' + sof2;
     ItoA2 := sof2;
END;

PROCEDURE SaveGame;
BEGIN
     Assign(f,'jmlives!.sav');Rewrite(f,1);
     BlockWrite(f,maxpl,SizeOf(maxpl));
     BlockWrite(f,which_to_play,SizeOf(which_to_play));
     BlockWrite(f,level_current,SizeOf(level_current));
     FOR t := 1 TO 4 DO
         BlockWrite(f,p[t],SizeOf(p[t]));
     Close(f);
END;

PROCEDURE Update_Lives;
BEGIN
     WritesS(ItoA2(p[pl].lives)+' ',12*8,8*23,0,6);
END;
PROCEDURE Update_Score;
VAR
   ts : STRING;
BEGIN
     Str(p[pl].score:7,ts);
     WritesS(ts+' ',7*8,8*24,0,7);
     IF (last_score DIV 10000) <> (p[pl].score DIV 10000) THEN
     BEGIN
          Inc(p[pl].lives);
          Update_Lives;
     END;
     last_score := p[pl].score;
END;
PROCEDURE Update_Bonus;
VAR
   ts : STRING;
BEGIN
     Str(bonus:7,ts);
     WritesS(ts+'  ',30*8,8*24,0,7);
     bonus_change := FALSE;
END;
PROCEDURE Status_All;
BEGIN
     WritesS('  JUMPMEN = ',0*8,8*23,0,6);
     Update_Lives;
     WritesS('  SCORE',0,8*24,0,7);
     Update_Score;
     WritesS(' LEVEL '+ItoA2(current_level)+' ',15*8,8*23,0,3);
     WritesS(' RUN SPEED '+ItoA2(p[pl].speed)+'  ',24*8,8*23,0,6);
     WritesS(' PLAYER '+Chr(pl+48),15*8,8*24,0,3);
     WritesS(' BONUS',24*8,8*24,0,7);
     Update_Bonus;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE GenDraw(n,m : PNT);
BEGIN
     SetVGA;
     IF vmode = 2 THEN
     BEGIN
{          IF port[$3da] = 0 THEN;port[$3c0] := $11;port[$3c0] := 0;}
     END;
     pels_drawn := 0;
     FOR t := 1 TO n^[0] DO
     BEGIN
          IF n^[t*3] = 4 THEN
          BEGIN
               p[pl].x := n^[t*3-2];
               p[pl].y := n^[t*3-1];
               plsx := p[pl].x;
               plsy := p[pl].y;
          END ELSE DrawImage(n^[t*3-2],n^[t*3-1],GetOfs(n^[t*3]),FALSE,FALSE,FALSE,FALSE,0);
          IF n^[t*3] = 1 THEN Inc(pels_drawn);
     END;
     IF vmode = 2 THEN
     BEGIN
{          IF port[$3da] = 0 THEN;port[$3c0] := $20;}
          port[$3c8] := 1;FOR t := 0 TO 5 DO port[$3c9] := ftwo[t];
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Check_Ladder;
PROCEDURE ScanScn;
BEGIN
     WITH p[pl] DO
          IF scn[3]+scn[4]+scn[17]+scn[18] = #4#4#4#4 THEN ltouch := 0 ELSE
             IF scn[1]+scn[3]+scn[14]+scn[16] = #4#4#4#4 THEN ltouch := 2 ELSE
                IF scn[5]+scn[7]+scn[18]+scn[20] = #4#4#4#4 THEN ltouch := -2 ELSE
                   IF scn[1]+scn[14] = #4#4 THEN ltouch := 4 ELSE
                      IF scn[7]+scn[20] = #4#4 THEN ltouch := -4 ELSE
                         ltouch := 5;
END;
BEGIN
     WITH p[pl] DO
     BEGIN
          Scan(p[pl].x,p[pl].y,ofs(p[pl].scn));
          drtouch := Pos(#3,scn) IN [10..11];
          ScanScn;
          IF ltouch = 5 THEN
          BEGIN
               Scan(p[pl].x,p[pl].y+6,ofs(p[pl].scn));
               ScanScn;
          END;
          IF NOT(drtouch) THEN drtouch := Pos(#3,scn) IN [10..11];
          Scan(p[pl].x,p[pl].y+10,ofs(p[pl].scn));
          drtoub := Pos(#3,scn) IN [10..11];
          IF (y >= SCBOT) AND (NOT in_intro) THEN
          BEGIN
               y := SCBOT-2;
               pdeath := 2;
               drtoub := FALSE;
               drtouch := FALSE;
               ltouch := 5;
          END;
          IF NOT ( (x > -5) AND (x < 309) ) THEN
          BEGIN
               ltouch := 5;
               drtouch := FALSE;
               drtoub := FALSE;
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Do_Actions;
BEGIN
     WITH p[pl] DO
     BEGIN
          IF (left OR right) AND ((res>0) OR wasmoving) AND
             NOT(jump) AND (NOT(drtouch AND (drtoub OR wasdr)) OR (res>0)) THEN
          BEGIN
               dir := right;
               im := (pumps MOD 2) + 8;
               Inc(pumps);
               x := x + (4*(ORD(right)*2-1));
               wasmoving := TRUE;
               IF pl < 5 THEN FX_Walk;
          END ELSE
          IF jump THEN
          BEGIN
               IF climbing THEN climbing := FALSE;
               Inc(x,jp2[jpump*2]*(ORD(right)*2-1)*2);
               dir := right;
               im := 7;
               Dec(y,jp2[jpump*2+1]);
               IF (jpump = 0) AND (pl < 5) THEN FX_Jump;
               Inc(jpump);
               IF (jpump > 6) AND ((res AND 3)=1) THEN
               BEGIN
                    jump := FALSE;
                    IF jp2[jpump*2-1] < 0 THEN Dec(y,2);
               END ELSE
                  IF (jpump >= MAXJP2) OR (y = SCBOT) THEN
                  BEGIN
                       IF y = SCBOT THEN y := SCBOT-2;
                       jpump := MAXJP2*2 + 2;
                       left := FALSE;
                       right := FALSE;
                       jump := FALSE;
                       Inc(pdeath);
                       pumps := 0;
                  END;
          END ELSE
          IF jumpup THEN
          BEGIN
               IF (jpump = 0) AND (pl < 5) THEN FX_Jump;
               im := 3;
               y := y - jp1[jpump];
               Inc(jpump);
               IF ( ((res AND 3) > 0) AND (jpump > 6) ) OR
                  (((ltouch < 5) OR (drtouch)) AND (jpump > MAXJP1)) THEN
               BEGIN
                    jumpup := FALSE;
                    IF (res AND 3) > 0 THEN Dec(y,2);
                    {Inc(y,jp1[jpump]);}
               END ELSE
                  IF jpump >= MAXJP1 THEN
                  BEGIN
                       left := FALSE;
                       right := FALSE;
                       jump := FALSE;
                       Inc(pdeath);
                       pumps := 0;
                  END;
          END ELSE
          IF ((up AND ((p[pl].y < 8*21-2) OR ((res AND 3)<>1))) or down) AND (ltouch < 5) THEN
          BEGIN
               IF ltouch < 5 THEN
               BEGIN
                    inc(pumps);
                    im := ups[pumps MOD 4];
                    IF pl < 5 THEN FX_Walk;
               END;
               IF ((rres AND (32+1+2) > 0) OR special) THEN x := x - ltouch;
               IF down AND (ltouch < 5) THEN
               BEGIN
                    Scan(p[pl].x,p[pl].y+4,ofs(p[pl].scn));
                    IF scn[3]+scn[4]+scn[17]+scn[18] <> #4#4#4#4 THEN
                    BEGIN
                         Scan(p[pl].x,p[pl].y,ofs(p[pl].scn));
                         IF (scn[3]+scn[4]+scn[17]+scn[18] = #4#4#4#4) THEN y := y - (ORD(down)*4-2);
                    END ELSE y := y - (ORD(down)*4-2);
               END ELSE IF (ltouch < 5) THEN y := y - (ORD(down)*4-2);
          END ELSE IF NOT (lrorj) AND (NOT climbing) AND
             (NOT (jump OR jumpup)) AND NOT(drtouch AND (drtoub OR wasdr)) THEN
          BEGIN
               im := ORD(NOT(ltouch = 5))*3;
               wasmoving := FALSE;
               pumps := 0;
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE MovePlayer;
BEGIN
     WITH r,p[pl] DO
     BEGIN
          IF NOT (jump OR jumpup) THEN jpump := 0;
          GetInput;
          up := absu;down := absd;
          IF (ltouch < 5) OR (drtouch) THEN wasmoving := FALSE;
          IF NOT (jump OR jumpup) THEN
          BEGIN
               left := absl AND (((res>0) OR wasmoving)
                       OR (ltouch < 5) OR drtouch) AND NOT(jumpup);
               right := absr AND (((res>0) OR wasmoving)
                        OR (ltouch < 5) OR drtouch) AND NOT(jumpup);
               jump := absb AND (left OR right);
               jumpup := (absb {AND absd}) AND NOT(jump);
          END;
          lrorj := absb OR absl OR absr;
     END;
     CAction;
     Do_Actions;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Check_Green;

BEGIN
     WITH p[pl] DO
     BEGIN
          climbing := ((res AND 3) = 3) AND (ltouch = 5) AND (jpump IN [0,6..99]);
          IF (ltouch = 0) AND (jpump > 6) AND (NOT climbing) THEN
          BEGIN
               jump := FALSE;
               wasmoving := FALSE;
          END ELSE
          BEGIN
               wasdr := FALSE;
               IF (drtoub OR (drtouch AND ((res AND 251) = 0))) AND (NOT jumpup) THEN
               IF NOT (jump OR wasmoving)  THEN
               BEGIN
                    wasmoving := FALSE;
                    Inc(pumps);
                    im := (pumps MOD 2) + 1;
                    y := y + 2;
                    wasdr := TRUE;
                    climbing := FALSE;
               END ELSE IF (jpump IN [0,6..99]) AND jump THEN
               BEGIN
                    wasmoving := FALSE;
                    jump := FALSE;
                    climbing := FALSE;
                    jpump := 0;
               END;
          END;
          IF climbing THEN
          BEGIN
               jpump := 20;
               jumpup := FALSE;
               jump := FALSE;
          END;
          inair := ( (res AND 3) = 0) AND (ltouch = 5) AND (NOT drtouch);
          IF climbing THEN
          BEGIN
               y := y - 2;
               IF NOT (left OR right) {AND (pumps > 0)} THEN
               BEGIN
                    Inc(pumps);
                    im := (pumps MOD 2) + 1;
               END;
          END ELSE
          IF inair AND (NOT (jump OR jumpup)) AND (NOT (ltouch < 5)) THEN
          BEGIN
               wasmoving := FALSE;
               y := y + 2;
               Inc(pdeath);
               pumps := 0;
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Pel_Hit(n : PNT);
VAR
   a : WORD;
BEGIN
     WITH p[pl] DO
     BEGIN
          FOR t := 0 TO n^[0]-1 DO
             IF ((x+12 > n^[t*4+1]) AND (x-8 < n^[t*4+1]) AND
                (y+8 > n^[t*4+2]) AND (y-8 < n^[t*4+2])) OR (pels[t]) THEN
             BEGIN
                  IF NOT pels[t] THEN
                  BEGIN
                       Inc(score,100);
                       FX_Pel;
                       somex := n^[t*4+1];
                       somey := n^[t*4+2];
                       pels[t] := TRUE;
                       DrawImage(n^[t*4+1],n^[t*4+2],GetOfs(1),TRUE,FALSE,FALSE,FALSE,$f8);
                       FOR a := n^[t*4+3] TO n^[t*4+4] DO
                       BEGIN
                            DrawImage(n^[a*4+1],n^[a*4+2],
                                      GetOfs(n^[a*4+3]),n^[a*4+4] > 0,FALSE,FALSE,FALSE,$f8);
                       END;
                       cdot;
                  END;
             END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Dying;
CONST
     MAXDIER = 11;
     dydir : SHORTINT = 0;
     inseq : BOOLEAN = FALSE;
     dier : ARRAY[0..MAXDIER,0..1] OF SHORTINT = ((2,-2),(2,-2),(2,-2),(2,-2),
                                                  (2,2),(2,0),(2,2),(2,2),
                                                  (2,2),(2,2),(2,2),(2,2));

BEGIN
     WITH p[pl] DO
     BEGIN
          ltouch := 5;
          IF (y < SCBOT) THEN
          BEGIN
               FX_Die(y,TRUE);
               IF (im < 8) THEN im := 3;
               IF ((res AND (1+2+16)) > 0) OR inseq THEN
               BEGIN
                    IF NOT inseq THEN FX_Die(y,FALSE);
                    inseq := TRUE;
                    IF pumps = 0 THEN dydir := RANDOM(3)-1;
                    x := x + ( (dier[pumps,0]) * dydir);
                    y := y + dier[pumps,1];
                    im := (pumps MOD 4)+10;
                    IF pumps = MAXDIER THEN inseq := FALSE;
               END ELSE
               BEGIN
                    y := y + 2;
               END;
               pumps := (pumps + 1) MOD (MAXDIER+1);
               IF y = SCBOT THEN pumps := 0;
               FOR t := 1 TO 10 DO WITH dots[t] DO IF on THEN
                   Drawimage(x,y,Ofs(bull1),TRUE,FALSE,FALSE,FALSE,7);
          END ELSE
          BEGIN
               IF (pumps = 20) AND Game_Music THEN
               BEGIN
                    IF NOT(nosnd OR (NOT Adlib)) THEN
                    BEGIN
                         IF SoundColdInit THEN;Midi_init;
                         IF Midi_Play(@d7) THEN;
                    END;
               END;
               Inc(pumps);
               im := ((pumps DIV 2) MOD 2) + 14;
               IF pumps > 170 THEN
               BEGIN
                    FOR t := 1 TO 10 DO WITH dots[t] DO IF on THEN
                        Drawimage(x,y,Ofs(bull1),TRUE,FALSE,FALSE,FALSE,7);
                    pdeath := 0;
                    killed := TRUE;
                    inseq := FALSE;
                    cdied;
                    IF Game_Music AND NOT(nosnd OR (NOT Adlib)) THEN
                    BEGIN
                         Stop_Melo;Midi_Kill;FX_Init(TRUE);
                         port[$40] := 10;port[$40] := 16;
                    END;
                    im := ((pumps DIV 2) MOD 2) + 14;
               END;
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE MoveDots(n : BYTE;m : BOOLEAN);
CONST
     dstart : ARRAY[0..3] OF INTEGER = (2,318,2,198);

BEGIN
     FOR t := 1 TO n DO WITH dots[t] DO
     BEGIN
          IF on THEN
          BEGIN
               IF (x < -18) OR (x > 338) OR (y < -20) OR
                  (y > 220) THEN on := FALSE ELSE
                  IF fired THEN
                  BEGIN
                       x := x + xdir*6;
                       y := y + ydir*5;
                  END ELSE
                  BEGIN
                       x := x + xdir;
                       y := y + ydir;
                       IF (x - 5 >= p[pl].x) AND (x-9 <= p[pl].x) THEN
                       BEGIN
                            xdir := 0;
                            ydir := ORD(y < p[pl].y)*2 - 1;
                            fired := TRUE;
                            FX_Shoot;
                       END ELSE
                       IF y - 4 = p[pl].y THEN
                       BEGIN
                            ydir := 0;
                            xdir := ORD(x < p[pl].x)*2 - 1;
                            fired := TRUE;
                            FX_Shoot;
                       END;
                  END;
               IF MoveImage(x,y,t+4,Ofs(bull1),0,0,255,TRUE) = 0 THEN;
          END ELSE IF m AND (Random(60) = 5) THEN
          BEGIN
               on := TRUE;fired := FALSE;
               REPEAT
                     xdir := RANDOM(3) - 1;
                     ydir := RANDOM(3) - 1;
               UNTIL NOT ((xdir = 0) AND (ydir = 0));
               IF (xdir <> 0) AND (ydir <> 0) THEN
                  IF (random(9) <> 1) THEN
                     IF Random(2) = 0 THEN xdir := 0 else ydir := 0;
               fired := FALSE;
               IF xdir = 0 THEN
               BEGIN
                    x := ((Random(350)-15) DIV 4) * 4 - 2;
                    y := dstart[ORD(ydir < 0)+2];
               END ELSE IF ydir = 0 THEN
               BEGIN
                    y := ((Random(230)-15) DIV 4) * 4 - 2;
                    x := dstart[ORD(xdir < 0)];
               END ELSE
               BEGIN
                    CASE Random(2) OF
                     0 : BEGIN
                              IF xdir < 0 THEN x := 320 ELSE x := -2;
                              IF ydir > 0 THEN
                                 y := ((Random(120)-10) DIV 4) * 4
                              ELSE y := ((Random(120)+90) DIV 4) * 4;
                         END;
                     1 : BEGIN
                              IF ydir < 0 THEN y := 200 ELSE y := -2;
                              IF xdir > 0 THEN
                                 x := ((Random(180)-10) DIV 4) * 4
                              ELSE x := ((Random(180)+130) DIV 4) * 4;
                         END;
                    END;
               END;
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE DrawPtrs(n : BOOLEAN);
BEGIN
     Wipe(b64k);
     pels_drawn := 0;
     FOR t := 1 TO intscrp^[0] DO
     BEGIN
          IF (intscrp^[t*3] IN [2,3,5,6]) OR n THEN
          DrawImage(intscrp^[t*3-2],intscrp^[t*3-1],GetOfs(intscrp^[t*3]),
                              FALSE,FALSE,FALSE,FALSE,0);
          IF intscrp^[t*3] = 1 THEN Inc(pels_drawn);
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE InitPl;
BEGIN
     FOR a := 1 TO 2 DO
     WITH p[a] DO
     BEGIN
          FOR t := 1 TO 10 DO WITH dots[t] DO on := FALSE;
          FOR t := 0 TO 25 DO pels[t] := FALSE;
          im := 0;killed := FALSE;oldis[a] := idevice;idevice := 3;
          scn[0] := #20;pumps := 0;ltouch := 5;
          jump := FALSE;jumpup := FALSE;pdeath := 0;jpump := 20;
          wasmoving := FALSE;drtouch := FALSE;drtoub := FALSE;
          absl := FALSE;absr := FALSE;absu := FALSE;absd := FALSE;absb := FALSE;
     END;
     oldpl := pl;
     pl := 1;
END;

{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE intscr3d;EXTERNAL;{$L intscr3d}
PROCEDURE intscr3t;EXTERNAL;{$L intscr3t}
PROCEDURE End_Intro;
CONST
     lastj : BOOLEAN = FALSE;
     MAXJMOV = 16;
     jmoves : ARRAY[1..MAXJMOV,0..1] OF BYTE = ( (2,39),(0,80),(1,4),(4,20),
                                                 (2,28),(0,40),(1,4),(4,28),
                                                 (1,20),(0,40),(2,30),(0,60),
                                                 (16,1),(1,24),(33,2),(1,23) );
VAR
   pp4 : PROCEDURE;
   pp1,pp2,pp3 : PNT;
   rpumps,
   stage,
   ry : INTEGER;
   jmind,jmcnt,jmmov : INTEGER;
   ch : CHAR;

PROCEDURE End_Int;
VAR
   bl_v,
   n : BYTE;
   es_v,di_v : WORD;

BEGIN
     IF AbsTime < 15 THEN Exit;
     AbsTime := 0;
     Inc(rpumps);
     IF (rpumps = 49) AND Adlib THEN
     BEGIN
          FX_Inits(FX2[14]);
          SndOutput($40+FX2[14].r2,15);
          SndOutput($b0+FX2[14].r1,$21);
     END;
     IF Adlib AND (rpumps IN [50..100]) THEN SndOutput($40+FX2[14].r2,(100-rpumps) DIV 4);
     CASE stage OF
       0 : IF (rpumps > 100) THEN
           BEGIN
                IF MoveImage(300-20,ry,3,Ofs(rock4[rpumps MOD 3]),0,0,255,FALSE) = 0 THEN;
                Inc(ry,2);
                IF (ry = 158) AND (MoveImage(300-20,ry,3,Ofs(rock4[3]),0,0,255,FALSE) < 256) THEN
                BEGIN
                     Inc(stage);
                     IF Adlib THEN SndOutput($b0+FX2[14].r1,0);
                END;
           END;
       1 : BEGIN
                p[2].x := 300-40;p[2].y := SCBOT-6;p[2].im := 0;
                FX_Inits(FX2[13]);AbsTime := 1;
                FOR n := 0 TO 9 DO WITH p[2] DO
                BEGIN
                     IF Adlib THEN WITH FX2[13] DO
                     BEGIN
                          IF n = 0 THEN
                          BEGIN
                               SndOutput($b0+r1,0);
                               SndOutput($b0+r1,$21);
                          END ELSE SndOutput($a0+r1,(9-n)*28);
                     END;
                     FOR t := 0 TO 15 DO
                     BEGIN
                          es_v := SEG(b64k^);
                          di_v := (y+n)*320+x+t;
                          bl_v := jman2[im,n*16+t+2];
                          ASM
                             mov   es,[es_v]
                             mov   di,[di_v]
                             mov   bl,[bl_v]
                             mov   al,BYTE [es:di]
                             or    al,bl
                             call  WriteEsDiAl
                          END;
                     END;
                     REPEAT UNTIL (WORD(abstime) MOD 20) = 0;
                     Inc(AbsTime);
                END;
                FX_Inits(FX2[13]);
                Inc(stage);
                p[2].dir := TRUE;
           END;
       2 : BEGIN
                IF MoveImage(p[2].x,SCBOT-6,2,Ofs(jman2[(rpumps MOD 2)+1]),0,0,255,TRUE) = 0 THEN;
                Dec(p[2].x,4);IF p[2].x < -20 THEN Inc(stage);
                FX_Walk;
           END;
     END;
     WITH p[1] DO
     BEGIN
          rres := MoveImage(x,y,1,Ofs(jman1[im]),
                            32,32,255,NOT dir);
          IF x < 10 THEN rres := 1;
          res := rres AND 15;
          Check_Ladder;
          IF (ltouch < 5) OR (drtouch) THEN wasmoving := FALSE;
          lastj := jump OR jumpup;
          left   := (jmoves[jmind,0] AND 1)  > 0;
          right  := (jmoves[jmind,0] AND 2)  > 0;
          up     := (jmoves[jmind,0] AND 4)  > 0;
          down   := (jmoves[jmind,0] AND 8)  > 0;
          jumpup := (jmoves[jmind,0] AND 16) > 0;
          jump   := (jmoves[jmind,0] AND 32) > 0;
          lrorj  := (jmoves[jmind,0] AND 64) > 0;
          IF (jump OR jumpup) AND (NOT lastj) THEN jpump := 0;
          Do_Actions;Check_Ladder;Check_Green;
          IF NOT(jump OR jumpup) THEN Dec(jmcnt);
          IF jmcnt = 0 THEN
          BEGIN
               Inc(jmind);
               jmcnt := jmoves[jmind,1];
               IF jmind > MAXJMOV THEN
                    Inc(stage);
          END;
     END;
END;

BEGIN
     pp4 := ctim;Change(@ctim);
     SetHires;Load_Dac;GameCols;InitPl;
     pp1 := pnt1;pp2 := pnt2;pp3 := taskp;
     pnt1 := @intscr3d;pnt2 := @intscr3t;taskp := pnt2;
     abstime := 1;
     intscrp := @intscr3d;DrawPtrs(FALSE);
     ry := 0;stage := 0;pl := 1;
     IF MoveImage(320,0,1,Ofs(jman1),0,0,255,FALSE) = 0 THEN;
     IF MoveImage(320,0,2,Ofs(jman1),0,0,255,FALSE) = 0 THEN;
     DrawImage(320-20,158,Ofs(rock3[3]),FALSE,FALSE,FALSE,FALSE,0);
     FX_Init(TRUE);
     stage := 0;rpumps := 0;ry := -30;
     jmind := 0;jmcnt := 1;jmmov := 0;
     p[1].x := -20;p[1].y := 54;p[1].im := 0;
     REPEAT
           End_Int;
     UNTIL (stage = 4) OR keypress;
     IF Adlib THEN SndOutput($b0+FX2[14].r1,0);
     IF NOT keypress THEN
     BEGIN
          Delay2(300);MPlay(@d3);Delay2(200);
          SetHires;IF vmode = 1 THEN EgaGreys;
{$IFDEF REG}
          Writes('SATURN IS SAFE!',0,0,TRUE);
          Writes('(UNTIL NEXT TIME)',0,16,TRUE);
{$ENDIF}
          Writes('CONGRATULATIONS',40,100-16,TRUE);
          Writes('PRESS SPACE',64,200-16,TRUE);
          AbsTime := 0;
          REPEAT
                FullSpin('CONGRATULATIONS',40,100-16,10);
          UNTIL (AbsTime > 3000) OR keypress;
     END;
{$IFNDEF REG}
     SetHires;IF vmode = 1 THEN EgaGreys;
     Writes('GREAT JOB BUT SATURN',0,0,TRUE);
     Writes('HAS NOT BEEN SAVED!',0,16,TRUE);
     Writes('YOU MUST ORDER',0,50,TRUE);
     Writes('THE REGISTERED',0,66,TRUE);
     Writes('VERSION IN ORDER',0,82,TRUE);
     Writes('TO SAVE SATURN',0,98,TRUE);
     Writes('FROM DISASTER!',0,114,TRUE);
     Writes('DISPLAY ORDERING',0,168,TRUE);
     Writes('INFORMATION? (Y/N):',0,184,TRUE);
     REPEAT ch := keyd[GetAKey2] UNTIL ch IN ['y','n'];
     IF ch = 'y' THEN
     BEGIN
          Order_Info;
          SetHires;
     END;
{$ENDIF}
     pl := oldpl;
     FOR t := 1 TO 2 DO p[t].idevice := oldis[t];
     pnt1 := pp1;pnt2 := pp2;taskp := pp3;
     ctim := pp4;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Pause_It(in1,in2 : BYTE);
CONST
     RIX_Header : ARRAY[0..9] OF BYTE = ($52,$49,$58,$33,$40,$01,$c8,$00,$af,$00);

VAR
   cgp : BYTE ABSOLUTE $B800:0;
   egp : BYTE ABSOLUTE $A000:0;
   scb2,scb : POINTER;
   oldct : PROCEDURE;
   f : FILE;
   ss : STRING;
   ior,wn : WORD;

BEGIN
     oldct := ctim;
     Change(@ctim);
     Midi_Kill;FX_Kill;
     REPEAT UNTIL NOT key[59];
     IF MaxAvail > 64000 THEN
     BEGIN
          GetMem(scb,64000);
          IF vmode <> 2 THEN
          BEGIN
               Assign(f,'jmlives!.$$$');{$I-} ReWrite(f,1);{$I+}
               IF ioresult = 0 THEN
               BEGIN
                    BlockWrite(f,b64k^,64000);
                    Close(f);
               END ELSE Halt(0);
          END;
          IF MaxAvail > 64000 THEN GetMem(scb2,64000) ELSE scb2 := NIL;
          IF scb2 <> NIL THEN Move(b64k^,scb2^,64000);
          CASE vmode OF
           2 : Move(b64k^,scb^,64000);
           1 : BEGIN
                    PortW[$3ce] := $0001;
                    PortW[$3ce] := $ff08;
                    PortW[$3ce] := $0004;
                    Move(egp,Ptr(Seg(scb^)+0,0)^,8000);
                    PortW[$3ce] := $0104;
                    Move(egp,Ptr(Seg(scb^)+500,0)^,8000);
                    PortW[$3ce] := $0204;
                    Move(egp,Ptr(Seg(scb^)+1000,0)^,8000);
                    PortW[$3ce] := $0304;
                    Move(egp,Ptr(Seg(scb^)+1500,0)^,8000);
                    PortW[$3ce] := $0f01;
               END;
           0 : Move(cgp,scb^,$4000);
          END;
{          r.ax := $13;Intr($10,r);}
          SetHires;
          IF vmode = 1 THEN EgaGreys;
          REPEAT
                FullSpin('GAME PA*USED',72,92,8);
                IF NOT (key[59] OR key[32]) THEN Delay2(100);
                IF key[32] AND (scb2 <> NIL) THEN
                BEGIN
                     REPEAT UNTIL NOT key[32];
                     wn := 0;
                     REPEAT
                           Str(wn,ss);
                           WHILE Ord(ss[0]) < 5 DO ss := '0' + ss;
                           ss := 'JMS'+ss+'.SCI';
                           Assign(f,ss);{$I-} Reset(f,1);{$I+}
                           ior := IOResult;
                           IF ior = 0 THEN Close(f);
                           Inc(wn);
                     UNTIL ior > 0;
                     ReWrite(f,1);
                     {$I-} BlockWrite(f,RIX_Header,10);
                     BlockWrite(f,dactable,768);
                     BlockWrite(f,scb2^,64000);
                     Close(f);{$I+}
                END;
          UNTIL key[59];
          REPEAT UNTIL NOT key[59];
          SetHires;Load_Dac;
          CASE vmode OF
           2 : Move(scb^,b64k^,64000);
           1 : BEGIN
                    portw[$3ce] := $0001;
                    PortW[$3ce] := $ff08;

                    PortW[$3c4] := $0102;
                    Move(Ptr(Seg(scb^)+0,0)^,egp,8000);
                    PortW[$3c4] := $0202;
                    Move(Ptr(Seg(scb^)+500,0)^,egp,8000);
                    PortW[$3c4] := $0402;
                    Move(Ptr(Seg(scb^)+1000,0)^,egp,8000);
                    PortW[$3c4] := $0802;
                    Move(Ptr(Seg(scb^)+1500,0)^,egp,8000);
                    PortW[$3c4] := $0f02;
                    PortW[$3ce] := $0f01;
               END;
           0 : Move(scb^,cgp,$4000);
          END;
          FreeMem(scb,64000);
          IF scb2 <> NIL THEN FreeMem(scb2,64000);
          IF vmode <> 2 THEN
          BEGIN
               Assign(f,'jmlives!.$$$');Reset(f,1);
               BlockRead(f,b64k^,64000);Close(f);Erase(f);
          END;
     END ELSE
     BEGIN
          REPEAT UNTIL key[59];
          REPEAT UNTIL NOT key[59];
     END;
     FX_Init(TRUE);
     IF in1 < 255 THEN FX_Inits(FX2[in1]);
     IF in2 < 255 THEN FX_Inits(FX2[in2]);
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Qconfirm(in1,in2 : BYTE) : BOOLEAN;
VAR
   cgp : BYTE ABSOLUTE $B800:0;
   egp : BYTE ABSOLUTE $A000:0;
   scb2,scb : POINTER;
   f : FILE;
   ss : STRING;
   ior,wn : WORD;
   oldct : PROCEDURE;
   ch : CHAR;

BEGIN
     oldct := ctim;
     Change(@ctim);
     Midi_Kill;FX_Kill;
     REPEAT UNTIL NOT key[1];
     GetMem(scb,64000);
     IF vmode <> 2 THEN
     BEGIN
          Assign(f,'jmlives!.$$$');{$I-} ReWrite(f,1);{$I+}
          IF ioresult = 0 THEN
          BEGIN
               BlockWrite(f,b64k^,64000);
               Close(f);
          END ELSE Halt(0);
     END;
     GetMem(scb2,64000);
     Move(b64k^,scb2^,64000);
     CASE vmode OF
       2 : Move(b64k^,scb^,64000);
       1 : BEGIN
                PortW[$3ce] := $0001;
                PortW[$3ce] := $ff08;
                PortW[$3ce] := $0004;
                Move(egp,Ptr(Seg(scb^)+0,0)^,8000);
                PortW[$3ce] := $0104;
                Move(egp,Ptr(Seg(scb^)+500,0)^,8000);
                PortW[$3ce] := $0204;
                Move(egp,Ptr(Seg(scb^)+1000,0)^,8000);
                PortW[$3ce] := $0304;
                Move(egp,Ptr(Seg(scb^)+1500,0)^,8000);
                PortW[$3ce] := $0f01;
           END;
       0 : Move(cgp,scb^,$4000);
     END;
     SetHires;IF vmode = 1 THEN EgaGreys;
     Writes('ABORT GAME?',0,0,TRUE);
     Writes('ARE YOU SURE? (Y/N):',0,92,TRUE);
     REPEAT ch := keyd[GetAKey2] UNTIL ch IN ['y','n'];
     SetHires;Load_Dac;
     IF ch = 'n' THEN CASE vmode OF
       2 : Move(scb^,b64k^,64000);
       1 : BEGIN
                portw[$3ce] := $0001;
                PortW[$3ce] := $ff08;
                PortW[$3c4] := $0102;
                Move(Ptr(Seg(scb^)+0,0)^,egp,8000);
                PortW[$3c4] := $0202;
                Move(Ptr(Seg(scb^)+500,0)^,egp,8000);
                PortW[$3c4] := $0402;
                Move(Ptr(Seg(scb^)+1000,0)^,egp,8000);
                PortW[$3c4] := $0802;
                Move(Ptr(Seg(scb^)+1500,0)^,egp,8000);
                PortW[$3c4] := $0f02;
                PortW[$3ce] := $0f01;
           END;
       0 : Move(scb^,cgp,$4000);
     END;
     FreeMem(scb,64000);
     IF scb2 <> NIL THEN FreeMem(scb2,64000);
     IF (vmode <> 2) AND (ch = 'n') THEN
     BEGIN
          Assign(f,'jmlives!.$$$');Reset(f,1);
          BlockRead(f,b64k^,64000);
          Close(f);Erase(f);
     END;
     FX_Init(TRUE);
     IF in1 < 255 THEN FX_Inits(FX2[in1]);
     IF in2 < 255 THEN FX_Inits(FX2[in2]);
     Qconfirm := ch = 'y';
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Draw_Man;
VAR
   bl_v,
   n : BYTE;
   es_v,di_v : WORD;
BEGIN
     FX_Off78;
     FX_Inits(FX2[13]);AbsTime := 1;
     FOR n := 0 TO 9 DO WITH p[pl] DO
     BEGIN
          FX_DrawSnd(n*28);
          FOR t := 0 TO 15 DO
          BEGIN
{               Mem[$a000:(y+n)*320+x+t] := Mem[$a000:(y+n)*320+x+t] OR jman1[im,n*16+t+2];}
               es_v := SEG(b64k^);
               di_v := (y+n)*320+x+t;
               bl_v := jman1[im,n*16+t+2];
               ASM
                  mov   es,[es_v]
                  mov   di,[di_v]
                  mov   bl,[bl_v]
                  mov   al,BYTE [es:di]
                  or    al,bl
                  call  WriteEsDiAl
               END;
          END;
          REPEAT UNTIL (WORD(abstime) MOD 20) = 0;
          Inc(AbsTime);
     END;
     FX_On78;
     FX_Inits(FXs[6]);
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Change2(VAR p1 : POINTER;p2 : POINTER);
BEGIN p1 := p2 END;

{$F+}
PROCEDURE Shaker;
CONST xx : WORD = 0;
BEGIN
     IF violent THEN xx := Random(5)-2 ELSE xx := 0;
     PortW[$3d4] := (LO(xx) SHL 8) + $0d;
     PortW[$3d4] := (HI(xx) SHL 8) + $0c;
END;
{$F-}

PROCEDURE EndGame;
CONST
     dse : ARRAY[0..2,0..1] OF BYTE = ( (2,$24),(1,$26),(4,$28) );
     egc : ARRAY[0..2] OF BYTE = (6,2,1);
VAR
   n : WORD;
   pp : PROCEDURE;

BEGIN
     pp := ctim;
     violent := TRUE;
     Change2(@ctim,@Shaker);
     FX_Inits(FX2[12]);
     FOR t := 0 TO 2 DO
     BEGIN
          FX_EndGame(t,dse[t,1]);
          FOR n := 0 TO 100 DO
          BEGIN
           CASE vmode OF
             2 : BEGIN
                    ASM
                                mov     dx,$3da
                       @wras:   in      al,dx
                                test    al,8
                                jz      @wras
                    END;
                    port[$3c8] := dse[t,0];
                    port[$3c9] := 50;
                    IF n < 100 THEN
                    BEGIN
                         port[$3c9] := (n*5) MOD 64;
                         port[$3c9] := (n*2) MOD 64;
                    END ELSE
                    BEGIN
                         port[$3c9] := 0;
                         port[$3c9] := 0;
                    END;
                    Delay2(2);
               END;
               1 : BEGIN
                        IF n < 100 THEN
                        BEGIN
                             r.ax := $1000;r.bh := (n*5) MOD 64;r.bl := egc[t];
                             Intr($10,r);
                        END ELSE
                        BEGIN
                             r.ax := $1000;r.bh := 4;r.bl := egc[t];
                             Intr($10,r);
                        END;
                   END;
               0 : BEGIN
                        ASM
                                 mov     dx,$3da
                        @wras:   in      al,dx
                                 test    al,8
                                 jz      @wras
                        END;
                        CASE t OF
                         0 : Port[$3d9] := Ord(Odd(n))*$20 + $10;
                         1 : Port[$3d9] := Ord(Odd(n))*$10;
                         2 : Port[$3d9] := n AND 7;
                        END;
                        IF (t=2) AND (n=100) THEN
                             Port[$3d9] := 0;
                        Delay2(2);
                   END;
             END;
           IF keypress THEN
           BEGIN
                FX_EndGame(3,0);
                ctim := pp;
                PortW[$3d4] := $000c;PortW[$3d4] := $000d;
                REPEAT UNTIL NOT keypress;
                Exit;
           END;
          END;
     END;
     FX_EndGame(3,0);
     Delay2(200);
{$IFDEF PICS}
     PicCols;
     violent := FALSE;
     Displaypic(@Satrnexp);MPlay(@d5);
     Delay2(300);
     GameCols;
{$ENDIF}
     PortW[$3d4] := $000c;PortW[$3d4] := $000d;
     ctim := pp;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Play(pnn1,pnn2 : PNT;
               mdot,in1,in2 : BYTE);
CONST
     ts : STRING[20] = '********************';
VAR
   pls2,
   tim,
   pls : BYTE;
   gplay1,
   plstop1,
   gplay2 : BOOLEAN;
   lastabs2,
   lastabs : LONGINT;
   str40 : STRING[40];
   ch : CHAR;

BEGIN
   pnt1 := pnn1;pnt2 := pnn2;
   taskp := pnt2;disapp := FALSE;
   FOR pl := 1 TO 4 DO WITH p[pl] DO
       FOR t := 0 TO 25 DO pels[t] := FALSE;
   plstopnow := FALSE;
   IF level_start > level_current THEN
   BEGIN
        Inc(level_current);
        Exit;
   END ELSE IF (level_current MOD 5 = 0)
               AND (level_current <> level_start)
               AND (which_to_play < 5)
               AND (NOT trainer) THEN
   BEGIN
        SetHires;IF vmode = 1 THEN EgaGreys;
        Writes('SAVE YOUR GAME NOW?',0,0,TRUE);
        REPEAT ch := keyd[GetAKey2] UNTIL ch IN ['y','n'];
        IF ch = 'y' THEN
           SaveGame;
   END;
   Inc(level_current);
   FOR pl := 1 TO 4 DO WITH p[pl] DO IF (lives > 0) AND (NOT plstopnow) THEN
   BEGIN
        SetHires;FX_Init(TRUE);
        IF vmode = 1 THEN EgaGreys;
        Writest('PLAYER',16,40);Writest(Itoa(pl),136,100);
        Writes(scrtitle,160-Ord(scrtitle[0])*8,200-20,TRUE);
        abstime := 0;
        REPEAT
              gplay1 := FALSE;
              FOR t := 0 TO 127 DO
                  IF key[t] THEN gplay1 := TRUE;
              GetInput;
        UNTIL gplay1 OR absb OR (abstime > 1200);
        special := FALSE;plstop1 := FALSE;
        GenDraw(pnt1,pnt2);cbeg;altat := 0;btick := START_BTICK;
        WHILE (lives > 0) AND (NOT plstop1) AND (NOT plstopnow) DO
        BEGIN
          IF in1 < 255 THEN FX_Inits(FX2[in1]);
          IF in2 < 255 THEN FX_Inits(FX2[in2]);
          FOR t := 1 TO 10 DO WITH dots[t] DO on := FALSE;
          im := 0;killed := FALSE;
          scn[0] := #20;p[pl].x := plsx;p[pl].y := plsy;
          jump := FALSE;jumpup := FALSE;
          abstime := 0;lastabs := 0;lastabs2 := 0;
          speed := next_speed;last_score := score;
          Status_All;Draw_Man;pdeath := 0;
          REPEAT
                gplay1 := abstime-lastabs > PLAYSPEED[speed];
                gplay2 := (abstime-lastabs2 > DIESPEED) AND (p[pl].pdeath > 1);
                IF gplay1 THEN lastabs := abstime;
                IF gplay2 THEN lastabs2 := abstime;
                IF pdeath = 50 THEN cproc;
                IF gplay1 OR gplay2 THEN
                BEGIN
                     tim := im;IF disapp THEN tim := 16;
                     IF NOT special THEN
                     BEGIN
                          rres := MoveImage(x,y,pl,Ofs(jman1[tim]),
                                            32,32+altat,255,NOT dir);
                          res := rres AND 15;
                     END ELSE IF gplay1 AND (pdeath <> 50) THEN cproc;
                     IF NOT ( (x > -5) AND (x < 309) ) THEN res := 0;
                     IF res AND 4 = 4 THEN Pel_Hit(pnt2);
                     IF NOT special THEN IF gplay1 THEN cproc;
                     IF bonus_change THEN Update_Bonus;
                     IF score <> last_score THEN Update_Score;
                     IF (res AND 8 = 8) AND (pdeath < 2) THEN
                     BEGIN
                          pdeath := 2;
                          pumps := 0;
                     END;
                     IF (pdeath < 2) AND gplay1 THEN
                     BEGIN
                          Check_Ladder;MovePlayer;
                          Check_Ladder;Check_Green;
                          MoveDots(mdot,TRUE);
                          IF (ltouch < 5) OR ((res AND 7)>0) THEN pdeath := 0;
                     END ELSE IF pdeath IN [2..40] THEN IF gplay2 THEN
                     BEGIN
                          disapp := FALSE;
                          Dying;
                          IF killed THEN
                          BEGIN
                               Drawimage(x,y,Ofs(jman1[im]),TRUE,FALSE,FALSE,FALSE,7);
                               x := pnt1^[t*3-2];
                               y := pnt1^[t*3-1];
                               Dec(lives);
                          END;
                     END;
                END;
                pls := 0;FOR t := 0 TO 25 DO Inc(pls,ORD(pels[t]));
                IF key[1] AND (NOT key[14]) THEN plstopnow := Qconfirm(in1,in2) ELSE
                BEGIN
                     IF trainer AND key[14] THEN
                        IF key[1] THEN plstopnow := TRUE
                        ELSE IF key[31] THEN
                        BEGIN
                             Dec(level_current);
                             SaveGame;
                             Inc(level_current);
                        END;
                END;
                plstop1 := (pls = pels_drawn);
                IF key[59] THEN Pause_It(in1,in2);
          UNTIL plstopnow OR (p[pl].killed) OR plstop1;
        END;
        cend;p[pl].pdeath := 5;
        IF plstop1 THEN
        BEGIN
             Inc(p[pl].score,bonus);
             Update_Score;Delay2(500);
             CASE Random(3) OF
              0 : MPlay(@d1);
              1 : MPlay(@d6);
              2 : MPlay(@d4);
             END;
        END;
        IF p[pl].lives = 0 THEN
        BEGIN
             EndGame;
             High_Scores(TRUE);
        END ELSE IF (max_screens = 1) AND plstop1 THEN
        BEGIN
             WritesS('                                        ',0,8*23,0,0);
             ts[0] := Chr(p[pl].lives);
             str40 := '  JUMPMEN X '+Itoa(eomission)+'  '+ts;
             WHILE Ord(str40[0]) < 39 DO str40 := str40 + ' ';
             WritesS(str40,0,8*23,0,6);
             Delay2(600);
             REPEAT
                   WritesS('*',(16+p[pl].lives)*8,8*23,0,7);FX_Pel;
                   Inc(p[pl].score,eomission);last_score := p[pl].score;
                   Update_Score;
                   Delay2(300);
                   Dec(p[pl].lives);
             UNTIL p[pl].lives = 0;
             Delay2(600);
             End_Intro;
             High_Scores(TRUE);
        END;
        IF plstopnow THEN
        BEGIN
             FOR t := 1 TO 4 DO
             BEGIN
                  IF (NOT trainer) OR (NOT key[14]) THEN
                  BEGIN
                       WHILE key[14] DO;
                       p[t].lives := 0;
                       p[t].score := 0;
                  END;
             END;
        END;
        IF p[1].lives+p[2].lives+p[3].lives+p[4].lives = 0 THEN plstopnow := TRUE;
   END;
   IF (trainer) AND (key[14]) AND plstopnow THEN plstopnow := FALSE;
   FX_Init(TRUE);
   Change(@ctim);
   Dec(max_screens);
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
END.
