UNIT sc07u;

INTERFACE

USES
    Adlibu,Globals,FX,Routines,ladd1u,b5001u;

FUNCTION sc07_0 : BOOLEAN;
PROCEDURE sc07_1;
PROCEDURE sc07_2;
PROCEDURE sc07_3;
PROCEDURE sc07_4;
PROCEDURE sc07_5;
PROCEDURE sc07_6;

VAR
   pieces : BYTE;
   n,m   : BYTE;
   lad   : BOOLEAN;
   oldx,oldy : INTEGER;
   keep : RECORD
              pumps,
              x,y : INTEGER;
          END;
IMPLEMENTATION

PROCEDURE scr07d;EXTERNAL;{$L scr07d}
PROCEDURE scr07t;EXTERNAL;{$L scr07t}

{$F+}
PROCEDURE sc07_t;
CONST
     tpump : LONGINT = 0;
BEGIN
     WITH keep DO IF pumps > 1 THEN
     BEGIN
          Inc(tpump);
          IF tpump MOD 20 = 0 THEN Dec(pumps);
     END;
     WITH FX2[4] DO IF (tick < 255) AND (p[pl].pdeath < 2) THEN
     BEGIN
      CASE tick OF
       0..155 : SndOutput($a0+r1,tick MOD 60);
       156..255 : SndOutput($a0+r1,tick-156);
      END;
      Inc(tick,2);
      IF tick >= 255 THEN SndOutput($b0+r1,0);
     END;
END;
{$F-}

PROCEDURE sc07_snd;
BEGIN
     WITH FX2[4] DO IF Adlib AND (p[pl].pdeath < 2) THEN
     BEGIN
          tick := 0;
          minor := -1;
          SndOutput($b0+r1,init[0] OR $20);
     END;
END;

FUNCTION sc07_0 : BOOLEAN;
BEGIN
     FX_Inits(FX2[4]);
     keep.pumps := 0;
     keep.x := 0;keep.y := 0;
     Modify(@sc07_1,@sc07_2,@sc07_3,@sc07_4,@sc07_5,@sc07_6,@sc07_t);
     scrtitle := 'GRAND PUZZLE I';bonus := 1500;current_level := 5;
     Play(@scr07d,@scr07t,1,4,255);
     sc07_0 := NOT plstopnow;
END;

PROCEDURE sc07_1;
BEGIN
     IF (p[pl].pdeath < 2) THEN
     BEGIN
          IF lad THEN WITH p[pl] DO
          BEGIN
               DrawImage(oldx,oldy,Ofs(ladd1[1]),TRUE,FALSE,FALSE,FALSE,127);
               DrawImage(x,y,Ofs(ladd1[1]),FALSE,FALSE,TRUE,FALSE,0);
               oldx := x;oldy := y;
               IF (x = 152) AND (y = 80-(pieces*8)) THEN
               BEGIN
                    DrawImage(x,y-8,Ofs(ladd1),FALSE,FALSE,FALSE,FALSE,0);
                    DrawImage(oldx,oldy,Ofs(ladd1[1]),TRUE,FALSE,FALSE,FALSE,127);
                    Inc(pieces);lad := FALSE;
                    sc07_snd;
               END;
          END;
          WITH keep DO IF pumps > 0 THEN
          BEGIN
               IF MoveImage(x,y,20-n,Ofs(b5001),128,(pumps MOD 2)*8+232,255,FALSE) = 0 THEN;
               IF pumps = 1 THEN
               BEGIN
                    Dec(pumps);
                    DrawImage(x,y,Ofs(b5001),TRUE,FALSE,FALSE,FALSE,7);
               END;
          END;
     END ELSE
     BEGIN
          DrawImage(oldx,oldy,Ofs(ladd1[1]),TRUE,FALSE,FALSE,FALSE,127);
          lad := FALSE;
     END;
END;

PROCEDURE sc07_2;
BEGIN
     IF lad = TRUE THEN
        DrawImage(oldx,oldy,Ofs(ladd1[1]),TRUE,FALSE,FALSE,FALSE,127);
     IF t IN [0..7] THEN lad := TRUE
     ELSE IF t IN [8..11] THEN
     BEGIN
          IF keep.x > 0 THEN
               DrawImage(keep.x,keep.y,Ofs(b5001),TRUE,FALSE,FALSE,FALSE,7);
          keep.x := somex;
          keep.y := somey;
          keep.pumps := 30;
          Inc(p[pl].score,400);
     END;
     m := 0;
     FOR n := 0 TO 15 DO Inc(m,ORD(p[pl].pels[n]));
     IF m = 12 THEN
        FOR n := 0 TO 15 DO p[pl].pels[n] := TRUE;
END;

PROCEDURE sc07_3;
BEGIN
END;

PROCEDURE sc07_4;
BEGIN
END;

PROCEDURE sc07_5;
BEGIN
     lad := FALSE;
     pieces := 0;
     keep.pumps := 0;
END;

PROCEDURE sc07_6;
BEGIN
END;

END.
