UNIT sc13u;

INTERFACE

USES
    Adlibu,Globals,FX,Routines,gpii2u,gpii1u,b5001u;

FUNCTION sc13_0 : BOOLEAN;
PROCEDURE sc13_1;
PROCEDURE sc13_2;
PROCEDURE sc13_3;
PROCEDURE sc13_4;
PROCEDURE sc13_5;
PROCEDURE sc13_6;

CONST
     ys : ARRAY[0..3] OF BYTE = (48,82,114,168);

VAR
   pls,
   pump1,pump2,
   n,m : INTEGER;
   par : ARRAY[0..20] OF RECORD
                            on : BOOLEAN;
                            pumps : INTEGER;
                         END;
   b500 : ARRAY[0..3] OF RECORD
                           pumps,y : INTEGER;
                         END;


IMPLEMENTATION

PROCEDURE scr13d;EXTERNAL;{$L scr13d}
PROCEDURE scr13t;EXTERNAL;{$L scr13t}

{$F+}
PROCEDURE sc13_t;
BEGIN
END;
{$F-}

FUNCTION sc13_0 : BOOLEAN;
BEGIN
     Modify(@sc13_1,@sc13_2,@sc13_3,@sc13_4,@sc13_5,@sc13_6,@sc13_t);
     scrtitle := 'GRAND PUZZLE II';bonus := 1500;current_level := 27;
     Play(@scr13d,@scr13t,0,255,255);
     sc13_0 := NOT plstopnow;
END;

PROCEDURE sc13_1;
BEGIN
     IF pump1 < 9 THEN
     BEGIN
          DrawImage(136,94-pump1*2,Ofs(gpii2),TRUE,TRUE,FALSE,FALSE,$f8);
          DrawImage(178,78+pump1*2,Ofs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
     END ELSE
     BEGIN
          DrawImage(178,94-(pump1-9)*2,Ofs(gpii2),TRUE,TRUE,FALSE,FALSE,$f8);
          DrawImage(136,78+(pump1-9)*2,Ofs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
     END;
     pump1 := (pump1 + 1) MOD 18;
     IF (ABS(160-p[pl].x) > 8*8) AND (pump2 > 0) THEN
     BEGIN
          Dec(pump2);
          DrawImage(178,158+(pump2)*2,Ofs(gpii2),TRUE,TRUE,FALSE,FALSE,$f8);
          DrawImage(136,158+(pump2)*2,Ofs(gpii2),TRUE,TRUE,FALSE,FALSE,$f8);
     END ELSE
     IF (ABS(160-p[pl].x) <= 8*8) AND (pump2 < 9) AND (p[pl].y > 150)
        AND (NOT disapp) THEN
     BEGIN
          Inc(pump2);
          DrawImage(178,156+(pump2)*2,Ofs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
          DrawImage(136,156+(pump2)*2,Ofs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
     END;
     IF ((res AND 4) = 4) AND (ABS(152-p[pl].x) < 10) THEN WITH p[pl] DO
     BEGIN
          par[20-(Ord(y > 150)+Ord(y > 150-5*8)+Ord(y > 150-10*8))].on := TRUE;
          FX_Pel;Inc(p[pl].score,500);
     END;
     FOR n := 0 TO 20 DO IF par[n].on THEN
         disapp := n IN [6,8];
     FOR n := 0 TO 20 DO WITH par[n] DO IF on THEN
     CASE n OF
        9 : BEGIN
                 DrawImage(136,134-pumps*2,Ofs(gpii2),TRUE,TRUE,FALSE,FALSE,$f8);
                 Inc(pumps);IF pumps > 8 THEN on := FALSE;
            END;
        7 : BEGIN
                 DrawImage(178,134-pumps*2,Ofs(gpii2),TRUE,TRUE,FALSE,FALSE,$f8);
                 Inc(pumps);IF pumps > 8 THEN on := FALSE;
            END;
        17..20: BEGIN
                     DrawImage(144,ys[20-n],Ofs(gpii1[20-n]),TRUE,FALSE,FALSE,FALSE,$f8);
                     b500[20-n].y := 34 + ((20-n)*8*5);
                     b500[20-n].pumps := 40;
                     par[n].on := FALSE;
                     par[n-4].on := TRUE;
                     Inc(pls);
                END;
        16: BEGIN
                 DrawImage(136,38+pumps*2,Ofs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
                 DrawImage(178,38+pumps*2,Ofs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
                 Inc(pumps);IF pumps > 8 THEN on := FALSE;
            END;
        13,15:on := FALSE;
        14: BEGIN
                 DrawImage(178,118+pumps*2,Ofs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
                 Inc(pumps);IF pumps > 8 THEN on := FALSE;
            END;
        ELSE on := FALSE;
     END;
     FOR n := 0 TO 3 DO WITH b500[n] DO IF pumps > 0 THEN
     BEGIN
          IF MoveImage(156,y,20-n,Ofs(b5001),128,232+(pumps MOD 2)*8,255,FALSE) = 0 THEN;
          Dec(pumps);
          IF pumps = 0 THEN
             DrawImage(156,y,Ofs(b5001),TRUE,FALSE,FALSE,FALSE,7);
     END;
     IF pls = 10 THEN
     BEGIN
          FOR n := 0 TO 9 DO p[pl].pels[n] := TRUE;
          FOR n := 10 TO 15 DO p[pl].pels[n] := FALSE;
     END;
END;

PROCEDURE sc13_2;
BEGIN
     par[t].on := TRUE;
     Inc(pls);
END;

PROCEDURE sc13_3;
BEGIN
END;

PROCEDURE sc13_4;
BEGIN
END;

PROCEDURE sc13_5;
CONST
     MAXL = 7;
     ls : ARRAY[0..MAXL] OF BYTE = (32,36, 72,94, 112,134, 152,156);
     rs : ARRAY[0..MAXL] OF BYTE = (32,36, 72,76, 112,134, 152,156);

BEGIN
     FOR n := 0 TO 3 DO
         DrawImage(144,ys[n],Ofs(gpii1[n]),FALSE,FALSE,FALSE,FALSE,0);
     FOR n := 0 TO MAXL DIV 2 DO
     BEGIN
          FOR m := ls[2*n] TO ls[2*n+1] DO
              DrawImage(136,m,OFs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
          FOR m := rs[2*n] TO rs[2*n+1] DO
              DrawImage(178,m,OFs(gpii2),FALSE,FALSE,FALSE,FALSE,0);
     END;
     pump1 := 0;pump2 := 0;
     FOR n := 0 TO 20 DO WITH par[n] DO
     BEGIN
          on := FALSE;
          pumps := 0;
     END;
     FOR n := 0 TO 3 DO b500[n].pumps := 0;
     pls := 0;
END;

PROCEDURE sc13_6;
BEGIN
END;

END.
