UNIT sc21u;

INTERFACE

USES
   Adlibu,Globals,Routines,jman1u;

FUNCTION sc21_0 : BOOLEAN;
PROCEDURE sc21_1;
PROCEDURE sc21_2;
PROCEDURE sc21_3;
PROCEDURE sc21_4;
PROCEDURE sc21_5;
PROCEDURE sc21_6;

CONST
     MAXREM = 4096;

TYPE
    BTYPE = ARRAY[0..MAXREM] OF BYTE;
    WTYPE = ARRAY[0..MAXREM] OF WORD;

VAR
   hiq,sque,eque : WORD;
   m,m2,n : INTEGER;
   dray : ^BTYPE;
   wray : ARRAY[0..1] OF ^WTYPE;
   sq : ARRAY[5..12] OF WORD;

IMPLEMENTATION

PROCEDURE scr21d;EXTERNAL;{$L scr21d}
PROCEDURE scr21t;EXTERNAL;{$L scr21t}

{$F+}
PROCEDURE sc21_t;
BEGIN
END;
{$F-}

FUNCTION sc21_0 : BOOLEAN;
BEGIN
     Modify(@sc21_1,@sc21_2,@sc21_3,@sc21_4,@sc21_5,@sc21_6,@sc21_t);
     scrtitle := 'FOLLOW THE LEADER';bonus := 1500;current_level := 12;
     Play(@scr21d,@scr21t,0,255,255);
     sc21_0 := NOT plstopnow;
END;

PROCEDURE Reset_All;
BEGIN
     sque := 0;eque := 0;hiq := 4;
     FOR n := 0 TO MAXREM DO dray^[n] := 0;
     FOR n := 5 TO 12 DO sq[n] := 0;
     FOR n := 5 TO 12 DO WITH p[n] DO
     BEGIN
          im := 0;killed := FALSE;
          scn[0] := #16;
          jump := FALSE;
          jumpup := FALSE;
          pdeath := 0;
     END;
END;

PROCEDURE sc21_1;
BEGIN
     IF p[pl].pdeath > 1 THEN sc21_3;
END;

PROCEDURE sc21_2;
BEGIN
     IF hiq < 12 THEN
     BEGIN
          Inc(hiq);
          sq[hiq] := sque;
          p[hiq].x := 0;
     END;
END;

PROCEDURE sc21_3;
BEGIN
     WITH p[pl] DO
     BEGIN
          IF pdeath < 2 THEN
          BEGIN
               dray^[eque] := (ORD(left)) +
                              (ORD(right) SHL 1) +
                              (ORD(up) SHL 2) +
                              (ORD(down) SHL 3) +
                              (ORD(jumpup) SHL 4) +
                              (ORD(jump) SHL 5) +
                              (ORD(lrorj) SHL 6);
               wray[0]^[eque] := x;
               wray[1]^[eque] := y;
               eque := (eque + 1) MOD MAXREM;
               IF eque = sque THEN Inc(sque);
          END;
          m2 := pl;
          FOR pl := 5 TO hiq DO WITH p[pl] DO
          BEGIN
               m := res;
               IF x = 0 THEN
               BEGIN
                    x := wray[0]^[0];
                    y := wray[1]^[0];
               END;
               res := MoveImage(x,y,20-pl,
                                Ofs(jman1[im]),32,64,255,NOT dir) AND 7;
               IF NOT ( (x > 0) AND (x < 309) ) THEN res := 0;
               Check_Ladder;
               IF NOT (jump OR jumpup) THEN jpump := 0;
               left := (dray^[sq[pl]] AND 1) > 0;
               right := (dray^[sq[pl]] AND 2) > 0;
               up := (dray^[sq[pl]] AND 4) > 0;
               down := (dray^[sq[pl]] AND 8) > 0;
               jumpup := (dray^[sq[pl]] AND 16) > 0;
               jump := (dray^[sq[pl]] AND 32) > 0;
               lrorj := (dray^[sq[pl]] AND 64) > 0;
               Do_Actions;
               Check_Ladder;
               Check_Green;
               pdeath := 0;
               sq[pl] := (sq[pl] + 1) MOD MAXREM;
               res := m;
          END;
          pl := m2;
          IF p[pl].pdeath > 1 THEN
          BEGIN
               FOR n := 5 TO hiq DO WITH p[n] DO
               BEGIN
                    m := MoveImage(x,y,20-n,
                                   Ofs(jman1[im]),32,64,255,NOT dir) AND 7;
                    DrawImage(x,y,Ofs(jman1[im]),TRUE,FALSE,FALSE,NOT dir,7);
               END;
               Reset_All;
               Exit;
          END;

     END;
END;

PROCEDURE sc21_4;
BEGIN
END;

PROCEDURE sc21_5;
BEGIN
     New(dray);New(wray[0]);New(wray[1]);
     Reset_All;
END;

PROCEDURE sc21_6;
BEGIN
     Dispose(dray);
     Dispose(wray[0]);
     Dispose(wray[1]);
END;

END.
