UNIT sc26u;

INTERFACE

USES
    Adlibu,Globals,Routines,gpiii1u,b5001u;

FUNCTION sc26_0 : BOOLEAN;
PROCEDURE sc26_1;
PROCEDURE sc26_2;
PROCEDURE sc26_3;
PROCEDURE sc26_4;
PROCEDURE sc26_5;
PROCEDURE sc26_6;

CONST
     mray : ARRAY[0..7,0..1] OF SHORTINT = ( (1,16),(4,40),(2,36),(8,20),
                                             (2,8),(8,60),(1,28),(4,40) );
     lastabs3 : LONGINT = 0;

VAR
   epump,
   todo,
   x,y,
   n,m : INTEGER;
   phit : BYTE;
   phit8,
   phase2 : BOOLEAN;
   par : ARRAY[0..3] OF RECORD
                          x,y,
                          pumps : INTEGER;
                          on : BOOLEAN;
                        END;

IMPLEMENTATION

PROCEDURE scr26d;EXTERNAL;{$L scr26d}
PROCEDURE scr26t;EXTERNAL;{$L scr26t}
PROCEDURE scr26ad;EXTERNAL;{$L scr26ad}
PROCEDURE scr26at;EXTERNAL;{$L scr26at}

{$F+}
PROCEDURE sc26_t;
BEGIN
END;
{$F-}

FUNCTION sc26_0 : BOOLEAN;
BEGIN
     Modify(@sc26_1,@sc26_2,@sc26_3,@sc26_4,@sc26_5,@sc26_6,@sc26_t);
     scrtitle := 'GRAND PUZZLE III';bonus := 1500;current_level := 45;
     Play(@scr26d,@scr26t,3,255,255);
     sc26_0 := NOT plstopnow;
END;

PROCEDURE sc26_1;
CONST
     gplay3 : BOOLEAN = FALSE;

BEGIN
     gplay3 := (abstime-lastabs3 > DIESPEED);
     IF gplay3 THEN lastabs3 := abstime;
     IF (p[pl].pdeath > 1) AND phase2 AND (gplay3 OR (p[pl].pdeath < 50)) THEN WITH p[pl] DO
     BEGIN
          pdeath := 50;
          disapp := FALSE;
          Dying;
          IF killed THEN
          BEGIN
               FOR n := 0 TO 25 DO pels[n] := FALSE;
               FOR n := 0 TO 7 DO pels[n] := TRUE;
               Dec(lives);
               phase2 := FALSE;
               pnt1 := @scr26d;pnt2 := @scr26t;
          END;
     END ELSE IF p[pl].pdeath IN [2..49] THEN lastabs3 := 0;
     IF ((rres AND 32) = 32) AND (NOT phase2) AND (p[pl].pdeath < 2) THEN
     BEGIN
          FOR n := 0 TO 25 DO WITH p[pl] DO pels[n] := FALSE;
          WITH p[pl] DO FOR n := 25 DOWNTO 26-(phit+4) DO pels[n] := TRUE;
          phase2 := TRUE;
          GenDraw(@scr26ad,@scr26at);
          pnt1 := @scr26ad;pnt2 := @scr26at;
          Status_All;
     END;
     IF (NOT phase2) AND (p[pl].pdeath < 50) THEN
     BEGIN
          IF MoveImage(x,y,20,Ofs(gpiii1),208,208-(Ord(NOT phit8)*136),255,FALSE) = 0 THEN;
          Dec(x,Ord((mray[epump,0] AND 1) > 0)*4);
          Inc(x,Ord((mray[epump,0] AND 2) > 0)*4);
          Inc(y,Ord((mray[epump,0] AND 4) > 0)*2);
          Dec(y,Ord((mray[epump,0] AND 8) > 0)*2);
          Dec(todo);
          IF todo = 0 THEN
          BEGIN
               epump := (epump + 1) MOD 8;
               todo := mray[epump,1];
          END;
     END;
     FOR n := 0 TO 3 DO WITH par[n] DO IF on THEN
     BEGIN
          IF MoveImage(x,y,19-n,Ofs(b5001),128,232+(pumps MOD 2)*8,255,FALSE) = 0 THEN;
          Dec(pumps);
          IF pumps = 0 THEN
          BEGIN
               on := FALSE;
               DrawImage(x,y,OFs(b5001),TRUE,FALSE,FALSE,FALSE,7);
          END;
     END;
END;

PROCEDURE sc26_2;
BEGIN
     Inc(phit);
     IF phit = 8 THEN
     BEGIN
          phit8 := TRUE;
          phit := 0;
     END;
     IF phase2 AND (t IN [0,2,4,6]) THEN WITH par[t DIV 2] DO
     BEGIN
          x := somex;
          y := somey-10;
          pumps := 40;
          on := TRUE;
          Inc(p[pl].score,400);
     END;
END;

PROCEDURE sc26_3;
BEGIN
END;

PROCEDURE sc26_4;
BEGIN
END;

PROCEDURE sc26_5;
BEGIN
     phit := 0;
     phase2 := FALSE;
     phit8 := FALSE;
     x := 8*23;y := 8*11-2;
     epump := 0;todo := mray[0,1];
     FOR n := 0 TO 3 DO par[n].on := FALSE;
END;

PROCEDURE sc26_6;
BEGIN
END;

END.
