{$I Defines.inc}
UNIT Writesu;

INTERFACE

USES
    FX,Globals,Dos;

PROCEDURE High_Scores(b : BOOLEAN);
FUNCTION  Main_Selector : BYTE;
PROCEDURE Spin(s : STRING;n,m : WORD;b : BYTE);
PROCEDURE FullSpin(s : STRING;n,m : WORD;b : BYTE);
PROCEDURE Writes(n : STRING;m,o : WORD;dw : BOOLEAN);
PROCEDURE Writest(n : STRING;m,o : WORD);
PROCEDURE WritesS(n : STRING;m,o : WORD;fg,bk : BYTE);
FUNCTION  GetAKey2 : BYTE;
FUNCTION  GetInp(n : BYTE;m,o : WORD) : STRING;
FUNCTION  GetInp2(n : BYTE;m : BOOLEAN) : STRING;
PROCEDURE PutUp(n : POINTER);
PROCEDURE PutUpOrder;
PROCEDURE Order_Info;

VAR
   blok : ARRAY[0..20*16*16] OF BYTE;
   blok2 : ARRAY[0..20*16*16] OF BYTE;
   z : STRING;
   k : BYTE;
   drot1 : ARRAY[0..1535] OF BYTE;

CONST
     curpl : BYTE = 1;
     MAXROT = 13;
     Rotable : ARRAY[0..MAXROT,0..15] OF WORD =
                (
                  (0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,0),
                  (0,0,1,2,3,5,6,7,8,9,10,12,13,14,0,0),
                  (0,0,0,1,2,3,5,6,8,9,10,12,14,0,0,0),
                  (0,0,0,0,1,3,5,6,8,9,10,12,0,0,0,0),
                  (0,0,0,0,0,0,2,5,8,10,13,0,0,0,0,0),
                  (0,0,0,0,0,0,0,2,8,13,0,0,0,0,0,0),
                  (0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0),
                  (0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0),
                  (0,0,0,0,0,0,0,13,8,2,0,0,0,0,0,0),
                  (0,0,0,0,0,0,13,10,8,5,2,0,0,0,0,0),
                  (0,0,0,0,0,12,10,9,8,6,5,3,1,0,0,0),
                  (0,0,0,0,14,12,10,9,8,6,5,4,2,1,0,0),
                  (0,0,14,13,12,10,9,8,7,6,5,3,2,1,0,0),
                  (0,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0)
                );
     avail : ARRAY[0..2] OF BOOLEAN = (TRUE,FALSE,FALSE);
     devs : ARRAY[0..2] OF STRING[10] = ('KBD','JOY 1','JOY 2');
     devs2 : ARRAY[0..2] OF STRING[20] = ('REDEFINE KEYS  ','CALIBRATE JOY 1','CALIBRATE JOY 2');

IMPLEMENTATION

PROCEDURE Font;EXTERNAL;{$L Font.obj}
PROCEDURE FontG;EXTERNAL;{$L FontG.obj}

PROCEDURE GetBlok(n,o : WORD);ASSEMBLER;
ASM
        cld
        mov     di,Offset(blok)
        mov     si,[n]
        push    ds
        push    ds
        pop     es
        mov     ax,WORD [b64k+2]
        mov     ds,ax
        mov     cx,15
        mov     bx,[o]
@gb1:   push    cx
        mov     cx,bx
        shr     cx,1
        rep     movsw
        add     si,320
        sub     si,bx
        pop     cx
        loop    @gb1
        pop     ds
END;

PROCEDURE PutBlok(n1,n2,o,o2 : WORD;b : BOOLEAN);ASSEMBLER;
CONST
     filcs : ARRAY[0..15] OF BYTE = (1,1,1,2,2,2,3,3,3,3,2,2,2,1,1,1);
     filcs2 : ARRAY[0..15] OF BYTE = (1,2,3,3,2,1,1,2,3,3,2,1,1,2,3,3);
VAR
   filc : BYTE;
   filco : WORD;
ASM
        cld
        mov     si,[o2]
        mov     cx,15
        cmp     [vmode],1
        jnz     @egpb
        mov     ax,$a000
        mov     es,ax
        mov     bx,[n2]
        shl     bx,1
        mov     di,WORD [m40+bx]
        mov     ax,[n1]
        shr     ax,1
        shr     ax,1
        shr     ax,1
        add     di,ax
        mov     bx,[o]
        shr     bx,1
        shr     bx,1
        shr     bx,1
        mov     al,7
        cmp     [b],0
        jz      @eisz
        mov     al,0
@eisz:  mov     [filc],al
@gb3:   push    cx
        mov     cx,bx
{        shr     cx,1}
@elp2:  push    cx
        mov     dx,$3ce
        mov     ax,$ff08
        out     dx,ax
        mov     ax,$0000
        out     dx,ax
        or      [es:di],al
        mov     cx,8
        xor     dx,dx
@egc:   lodsb
        shl     dx,1
        or      al,al
        jz      @egnc
        or      dx,1
@egnc:  loop    @egc
        mov     al,8
        mov     ah,dl
        mov     dx,$3ce
        out     dx,ax
        xor     ax,ax
        mov     ah,[filc]
        out     dx,ax
        or      [es:di],al              {al is insignificant}
        inc     di
        pop     cx
        loop    @elp2
{        rep     movsw}
        add     di,40
        sub     di,bx
        pop     cx
        cmp     [b],0
        jz      @eisz2
        cmp     cx,8
        jl      @dfc4
        dec     [filc]
        jmp     @dle
@dfc4:  inc     [filc]
        jmp     @dle
@eisz2: cmp     cx,8
        jl      @dfc
        inc     [filc]
        jmp     @dle
@dfc:   dec     [filc]
@dle:   loop    @gb3

        jmp     @vg1

@egpb:  cmp     [vmode],0
        jnz     @vg1
        mov     [filc],1
        mov     [filco],0
        mov     ax,$b800
        mov     es,ax
        mov     bx,[n2]
        shl     bx,1
        mov     di,WORD [m80+bx]
        mov     ax,[n1]
        shr     ax,1
        shr     ax,1
        add     di,ax
        mov     bx,[o]
        shr     bx,1
        shr     bx,1
        mov     [filc],1
@gb2:   push    cx
        mov     cx,bx
{        shr     cx,1}
@clp2:  push    cx
        mov     cx,4
        xor     dx,dx
@cgc:   lodsb
        shl     dx,1
        shl     dx,1
        or      al,al
        jz      @cgnc
        or      dl,BYTE [filc]
@cgnc:  loop    @cgc
        mov     [es:di],dl
        inc     di
        pop     cx
        loop    @clp2
{        rep     movsw}
        cmp     di,$2000
        jge     @cg20
        add     di,$2000
        jnz     @cgc2
@cg20:  sub     di,$2000-80
@cgc2:  sub     di,bx
        pop     cx
        push    bx
        inc     [filco]
        mov     bx,[filco]
        cmp     [b],0
        jz      @cgisz
        mov     al,BYTE [filcs2+bx]
        jnz     @cgcnt
@cgisz: mov     al,BYTE [filcs+bx]
@cgcnt: mov     [filc],al
        pop     bx
        loop    @gb2

@vg1:   mov     ax,WORD [b64k+2]
        mov     es,ax
        mov     si,[o2]
        mov     cx,15
        mov     bx,[n2]
        shl     bx,1
        mov     di,WORD [m320+bx]
        add     di,[n1]
        mov     bx,[o]
@gb1:   push    cx
        mov     cx,bx
        shr     cx,1
        rep     movsw
        add     di,320
        sub     di,bx
        pop     cx
        loop    @gb1
END;

PROCEDURE Rotate(n,m : WORD);ASSEMBLER;
ASM
        mov     di,Offset(blok2)
        mov     cx,15
        mov     bx,[n]
        push    ds
        pop     es
@ro3:   push    cx
        mov     cx,[bx]
        add     bx,2
        xor     si,si
        or      cx,cx
        jz      @ro1
@ro2:   add     si,[m]
        loop    @ro2
@ro1:   add     si,Offset(blok)
        mov     cx,[m]
        shr     cx,1
        rep     movsw
        pop     cx
        loop    @ro3
END;

PROCEDURE Writes2(o1,c1 : WORD;a1 : SHORTINT;s1,w1 : WORD;dr : BOOLEAN);ASSEMBLER;
VAR
   bil : WORD;
   col : BYTE;

ASM
        mov     si,[o1]
        mov     di,Offset(blok)
        add     di,[s1]
        mov     ax,[c1]
        mov     [col],al
        push    ds
        pop     es
        mov     cx,15
        mov     dl,[a1]
@w2:    push    ds
        push    cs
        pop     ds
        lodsw
        pop     ds
        mov     [bil],32768
        push    cx
        push    ax
        mov     cx,16
@w1:    pop     ax
        push    ax
        and     ax,[bil]
        jz      @stb
        mov     al,[col]
@stb: {  call    WriteEsDiAl
        inc     di}
        stosb
        shr     [bil],1
        loop    @w1
        add     [col],dl
        pop     ax
        pop     cx
        add     di,[w1]
        sub     di,16
        cmp     [dr],0
        jz      @w3
        cmp     cx,8
        jnz     @w3
        neg     dl
@w3:    loop    @w2
END;

PROCEDURE Writes(n : STRING;m,o : WORD;dw : BOOLEAN);
VAR
   l : BYTE;

BEGIN
     FOR l := 1 TO Ord(n[0]) DO
         Writes2(Ofs(Font)+(Ord(n[l])-32)*30,23,1,(l-1)*16,Ord(n[0])*16,TRUE);
     IF dw AND (n[0] <> #0) THEN PutBlok(m,o,Ord(n[0])*16,Ofs(blok),FALSE);
END;

PROCEDURE WritesW(n : STRING;m,o : WORD;dw : BOOLEAN);
VAR
   l : BYTE;

BEGIN
     FOR l := 1 TO Ord(n[0]) DO
         Writes2(Ofs(Font)+(Ord(n[l])-32)*30,31,-1,(l-1)*16,Ord(n[0])*16,TRUE);
     IF dw AND (n[0] <> #0) THEN PutBlok(m,o,Ord(n[0])*16,Ofs(blok),TRUE);
END;

PROCEDURE WritesS(n : STRING;m,o : WORD;fg,bk : BYTE);
VAR
   l : BYTE;

PROCEDURE WritesS2(o1,l1 : WORD;fg,bk : BYTE);ASSEMBLER;
VAR
   bil : WORD;

ASM
        mov     ax,WORD [b64k+2]
        mov     es,ax
        mov     si,[o1]
        mov     di,[l1]
        mov     cx,8
@w2:    push    ds
        push    cs
        pop     ds
        lodsb
        pop     ds
        mov     [bil],128
        push    cx
        push    ax
        mov     cx,8
@w1:    pop     ax
        push    ax
        and     ax,[bil]
        mov     al,[bk]
        jz      @stb
        mov     al,[fg]
@stb:   {stosb}
        call    WriteEsDiAl
        inc     di
        shr     [bil],1
        loop    @w1
        pop     ax
        pop     cx
        add     di,320-8
        loop    @w2
END;

BEGIN
     FOR l := 1 TO Ord(n[0]) DO
         WritesS2(Ofs(FontG)+(Ord(n[l]))*16,o*320+m+(l-1)*8,fg,bk);
END;

PROCEDURE Writes3(n : STRING;m,o : WORD);
VAR
   l : BYTE;

BEGIN
     FOR l := 1 TO Ord(n[0]) DO
     BEGIN
          Writes2(Ofs(Font)+(Ord(n[l])-32)*30,31,-2,(l-1)*16,Ord(n[0])*16,FALSE);
     END;
     PutBlok(m,o,Ord(n[0])*16,Ofs(blok),FALSE);
END;

PROCEDURE Writest(n : STRING;m,o : WORD);
VAR
   l : BYTE;

PROCEDURE Writes4(o1,c1 : WORD;a1 : SHORTINT;s1 : WORD);ASSEMBLER;
VAR
   bil : WORD;
   col : BYTE;

ASM
        mov     ax,WORD [b64k+2]
        mov     es,ax
        mov     si,[o1]
        mov     di,[s1]
        mov     ax,[c1]
        mov     [col],al
        mov     cx,15
        mov     dl,[a1]
@w2:    push    ds
        push    cs
        pop     ds
        lodsw
        pop     ds
        mov     [bil],32768
        push    cx
        push    ax
        mov     cx,16
@w1:    pop     ax
        push    ax
        mov     [ninecol],0
        and     ax,[bil]
        jz      @stb
        mov     al,[col]
        mov     [ninecol],al
        sub     [ninecol],16
{        shr     [ninecol],1}
@stb:   call    WriteEsDiAl9
        shr     [bil],1
        loop    @w1
        add     [col],dl
        pop     ax
        pop     cx
        add     di,320*3
        sub     di,16*3
        cmp     cx,8
        jnz     @w3
        neg     dl
@w3:    loop    @w2
END;

BEGIN
     FOR l := 1 TO Ord(n[0]) DO
         Writes4(Ofs(Font)+(Ord(n[l])-32)*30,23,1,o*320+(l-1)*16*3+m);
END;

PROCEDURE Spin(s : STRING;n,m : WORD;b : BYTE);
BEGIN
     GetBlok(m*320+n,Ord(s[0])*16);
     FOR t := 0 TO MAXROT DIV 2 DO
     BEGIN
          Rotate(Ofs(Rotable[t]),Ord(s[0])*16);
          PutBlok(n,m,Ord(s[0])*16,Ofs(blok2),FALSE);
          Delay2(b);
     END;
     Writes(s,0,0,FALSE);
     FOR t := MAXROT DIV 2 DOWNTO 0 DO
     BEGIN
          Rotate(Ofs(Rotable[t]),Ord(s[0])*16);
          PutBlok(n,m,Ord(s[0])*16,Ofs(blok2),FALSE);
          Delay2(b);
     END;
END;

FUNCTION  GetInp(n : BYTE;m,o : WORD) : STRING;
VAR
    s : STRING;
    i : BYTE;
BEGIN
     s := '';i := 0;
     REPEAT
           t := GetAKey2;
           IF (keyd[t] = 'B') AND (i > 0) THEN
           BEGIN
                Dec(i);
                Writes(' ',m+(i*16),o,TRUE);
                s[0] := Chr(i);
           END ELSE
           IF (keyd[t] IN ['0'..'9','a'..'z']) AND (i < n) THEN
           BEGIN
                Writes(Upcase(keyd[t]),m+(i*16),o,TRUE);
                s := s + Upcase(keyd[t]);
                Inc(i);
           END;
     UNTIL keyd[t] = 'E';
     GetInp := s;
END;

FUNCTION  GetInp2(n : BYTE;m : BOOLEAN) : STRING;
VAR
    s : STRING;
    i : BYTE;
BEGIN
     s := '';i := 0;
     REPEAT
           t := GetAKey2;
           IF (keyd[t] = 'B') AND (i > 0) THEN
           BEGIN
                Dec(i);
                Write(#8,' ',#8);
                s[0] := Chr(i);
           END ELSE
           IF ((keyd[t] IN ['0'..'9','a'..'z']) OR (m AND (keyd[t] =' '))) AND (i < n) THEN
           BEGIN
                Write(Upcase(keyd[t]));
                s := s + Upcase(keyd[t]);
                Inc(i);
           END;
     UNTIL keyd[t] = 'E';
     GetInp2 := s;
END;

PROCEDURE FullSpin(s : STRING;n,m : WORD;b : BYTE);
BEGIN
     GetBlok(m*320+n,Ord(s[0])*16);
     FOR t := 0 TO MAXROT DO
     BEGIN
          Rotate(Ofs(Rotable[t]),Ord(s[0])*16);
          PutBlok(n,m,Ord(s[0])*16,Ofs(blok2),FALSE);
          Delay2(b);
          IF key[59] OR key[32] OR key[57] THEN Exit;
     END;
     FOR t := MAXROT-1 DOWNTO MAXROT DIV 2 DO
     BEGIN
          Rotate(Ofs(Rotable[t]),Ord(s[0])*16);
          PutBlok(n,m,Ord(s[0])*16,Ofs(blok2),FALSE);
          Delay2(b);
          IF key[59] OR key[32] THEN Exit;
     END;
     Writes(s,0,0,FALSE);
     FOR t := (MAXROT DIV 2)-1 DOWNTO 0 DO
     BEGIN
          Rotate(Ofs(Rotable[t]),Ord(s[0])*16);
          PutBlok(n,m,Ord(s[0])*16,Ofs(blok2),FALSE);
          Delay2(b);
          IF key[59] OR key[32] THEN Exit;
     END;
END;

PROCEDURE Half_Rot(s : STRING;n,m : INTEGER);
BEGIN
     Writes(s,0,0,FALSE);
     FOR t := MAXROT DIV 2 DOWNTO 0 DO
     BEGIN
          Rotate(Ofs(Rotable[t]),Ord(s[0])*16);
          PutBlok(n,m,Ord(s[0])*16,Ofs(blok2),FALSE);
          Delay2(25);
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE PutUp(n : POINTER);
BEGIN
ASM
        mov     ah,2
        mov     bh,0
        mov     dl,0
        mov     dh,30
        int     $10
        mov     ax,$b800
        mov     es,ax
        push    ds
        lds     si,[n]
        cld
        xor     di,di
@rdb:   lodsb
        cmp     al,255
        je      @storb
        stosb
        inc     di
        cmp     di,4000
        jnz     @okdi2
        inc     di
        mov     bx,$b800-$fa
        mov     es,bx
@okdi2: jmp     @rdb
@storb: lodsb
        cmp     al,255
        je      @skate
        xor     cx,cx
        push    ax
        lodsb
        mov     cl,al
        pop     ax
@stcnt: stosb
        inc     di
        cmp     di,4000
        jnz     @okdi1
        inc     di
        mov     bx,$b800-$fa
        mov     es,bx
@okdi1: loop    @stcnt
        jmp     @rdb
@skate: pop     ds
END;
    IF GetAKey2 = 0 THEN;
END;

FUNCTION GetAKey2 : BYTE;
VAR
   w,n,o : BYTE;
BEGIN
     IF NOT(kbdinst) THEN Exit;
     FOR n := 0 TO 127 DO key[n] := FALSE;
     REPEAT
           n := 0;
           FOR w := 0 TO 127 DO IF key[w] THEN
           BEGIN
                Inc(n);
                o := w;
           END;
     UNTIL n = 1;
     REPEAT UNTIL NOT key[o];
     GetAKey2 := o;
END;

FUNCTION GetAKey : BYTE;
VAR
   n : BYTE;
BEGIN
     REPEAT
           n := GetAKey2;
           IF n IN [1,59] THEN
           BEGIN
                Spin('ILLEGAL KEY',16*4,16*10,5);
                Delay2(150);
                Spin('ILLEGAL KEY',16*4,16*10,5);
                FOR t := 0 TO MAXROT DIV 2 DO
                BEGIN
                     Rotate(Ofs(Rotable[t]),11*16);
                     PutBlok(16*4,16*10,11*16,Ofs(blok2),FALSE);
                     Delay2(10);
                END;
                Writes('           ',16*4,16*10,TRUE);
           END;
     UNTIL NOT (n IN [1,59]);
     GetAKey := n;
END;

PROCEDURE Key_Define;
CONST
     JSEN = 1.6;
VAR
   fail : BOOLEAN;

FUNCTION ButHit : BOOLEAN;
VAR
   n : BOOLEAN;
BEGIN
     port[$201] := 255;Delay2(2);
     n := (port[$201] AND (16+32+64+128) < 16+32+64+128);
     IF n THEN
     BEGIN
          WHILE (port[$201] AND (16+32+64+128) < 16+32+64+128) DO;
          Delay2(30);
     END;
     ButHit := n;
     port[$201] := 0;
END;

BEGIN
   WITH p[curpl] DO
   IF idevice > 0 THEN
   REPEAT
     HClrScr;Wipe(b64k);
     Writes('PERFORM EACH ACTION',0,0,TRUE);
     Writes('BELOW FOLLOWED BY  ',0,16*1,TRUE);
     Writes('A BUTTON PRESS.',0,16*2,TRUE);
     Writes('CENTER',0,16*4,TRUE);
     REPEAT
           cudj[idevice-1] := Getc(2 SHL ((idevice-1)*2));
           clrj[idevice-1] := Getc(1 SHL ((idevice-1)*2));
     UNTIL ButHit;
     Writes('LEFT',0,16*5,TRUE);
     REPEAT
           lj[idevice-1] := Getc(1 SHL ((idevice-1)*2));
     UNTIL ButHit;
     Writes('RIGHT',0,16*6,TRUE);
     REPEAT
           rj[idevice-1] := Getc(1 SHL ((idevice-1)*2));
     UNTIL ButHit;
     Writes('UP',0,16*7,TRUE);
     REPEAT
           uj[idevice-1] := Getc(2 SHL ((idevice-1)*2));
     UNTIL ButHit;
     Writes('DOWN',0,16*8,TRUE);
     REPEAT
           dj[idevice-1] := Getc(2 SHL ((idevice-1)*2));
     UNTIL ButHit;
     lj[idevice-1] := clrj[idevice-1] - TRUNC((clrj[idevice-1] - lj[idevice-1])/JSEN);
     rj[idevice-1] := clrj[idevice-1] + TRUNC((rj[idevice-1] - clrj[idevice-1])/JSEN);
     uj[idevice-1] := cudj[idevice-1] - TRUNC((cudj[idevice-1] - uj[idevice-1])/JSEN);
     dj[idevice-1] := cudj[idevice-1] + TRUNC((dj[idevice-1] - cudj[idevice-1])/JSEN);
     fail := (lj[idevice-1] > clrj[idevice-1]) OR (rj[idevice-1] < clrj[idevice-1])
             OR (uj[idevice-1] > cudj[idevice-1]) OR (dj[idevice-1] < cudj[idevice-1]);
     calibrated[idevice-1] := NOT fail;
     IF fail THEN
     BEGIN
          Writes('CALIBRATION FAILURE!',0,16*10,TRUE);
          Writes('TRY AGAIN? (Y/N)',0,16*11,TRUE);
          REPEAT n := GetAKey2 UNTIL (n IN [21,49]);
          IF n = 49 THEN fail := FALSE;
     END;
   UNTIL NOT fail ELSE
   BEGIN
        Hclrscr;Wipe(b64k);
        Writes('DESIRED LEFT KEY',0,16*3,TRUE);
        keys[0] := GetAKey;
        Writes('DESIRED RIGHT KEY',0,16*4,TRUE);
        keys[1] := GetAKey;
        Writes('DESIRED UP KEY',0,16*5,TRUE);
        keys[2] := GetAKey;
        Writes('DESIRED DOWN KEY',0,16*6,TRUE);
        keys[3] := GetAKey;
        Writes('DESIRED JUMP KEY',0,16*7,TRUE);
        keys[4] := GetAKey;
   END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Test_Input;
BEGIN
     HClrscr;Wipe(b64k);
     Writes('TEST YOUR INPUT NOW.',0,10,TRUE);
     Writes('(ESC WHEN DONE)',0,30,TRUE);
     pl := curpl;
     WITH p[curpl] DO
     REPEAT
          GetInput;
          IF absu THEN Writes('D',152,100+24,TRUE) ELSE Writes(' ',152,100+24,TRUE);
          IF absd THEN Writes('U',152,100-24,TRUE) ELSE Writes(' ',152,100-24,TRUE);
          IF absl THEN Writes('L',152-24,100,TRUE) ELSE Writes(' ',152-24,100,TRUE);
          IF absr THEN Writes('R',152+24,100,TRUE) ELSE Writes(' ',152+24,100,TRUE);
          IF absb THEN Writes('J',152,100,TRUE) ELSE Writes(' ',152,100,TRUE);
     UNTIL key[1];
     REPEAT UNTIL NOT key[1];
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE MorePlayers;
BEGIN
     Inc(maxpl);IF maxpl = 5 THEN maxpl := 1;
     Spin(Itoa(maxpl),13*16,16*7,7);
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Check_It;
VAR
   prob : ARRAY[1..2] OF BOOLEAN;
   keyls : STRING[12];
   ch,maxls : BYTE;
   using_save : BOOLEAN;
   cha : CHAR;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
{$IFDEF REG}
PROCEDURE GetMore;
VAR
   z : BYTE;
   tmps : NameStruct;
   junk : ExtStr;
   junk2 : DirStr;

BEGIN
     t := 0;
     REPEAT
           IF t = 0 THEN FindFirst('*.jml',Archive,scrs) ELSE FindNext(scrs);
           z := DosError;
           IF z = 0 THEN
           BEGIN
                Inc(t);
                FSplit(scrs.name,junk2,scrnames[0,t].fname,junk);
                Assign(f,scrnames[0,t].fname+'.jml');{$I-} Reset(f,1);{$I+}
                IF (ioresult = 0) AND (FileSize(f) > SizeOf(NameStruct)) THEN
                BEGIN
                     Seek(f,1);
                     BlockRead(f,tmps,SizeOf(NameStruct));
                     Close(f);
                     scrnames[0,t].title := tmps.title;
                END ELSE Dec(t);
           END;
     UNTIL z <> 0;
     FOR z := 1 TO t DO IF maxls < 9 THEN
     BEGIN
          Inc(maxls);keyls[maxls] := Chr(maxls+1);
          Writes(Itoa(maxls)+'. '+scrnames[0,z].title,0,16*(maxls-1),TRUE);
     END;
END;
{$ENDIF}
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
BEGIN
     keyls[0] := #9;
     FOR t := 1 TO 9 DO keyls[t] := #255;
     keyls[1] := #2;
     {$IFDEF REG}
     keyls[2] := #3;keyls[3] := #4;keyls[4] := #5;keyls[5] := #6;maxls := 5;
     {$ELSE}
     maxls := 1;
     {$ENDIF}
     pl := 5;
     using_save := FALSE;
     FOR t := 1 TO 4 DO WITH p[t] DO
     BEGIN
          score := 0;
          lives := 0;
     END;
     SetHires;IF vmode = 1 THEN EgaGreys;
     level_start := 0;level_current := 0;
{$IFNDEF REG}
     Assign(f,'jmlives!.sav');{$I-} Reset(f,1);{$I+}
     IF ioresult = 0 THEN
     BEGIN
          Writes('USE SAVED GAME?',0,0,TRUE);
          REPEAT cha := keyd[GetAKey2] UNTIL cha IN ['y','n'];
          IF cha = 'y' THEN
          BEGIN
               using_save := TRUE;
               BlockRead(f,maxpl,SizeOf(maxpl));
               BlockRead(f,which_to_play,SizeOf(which_to_play));
               BlockRead(f,level_start,SizeOf(level_start));
               FOR t := 1 TO 4 DO
                   BlockRead(f,p[t],SizeOf(p[t]));
               Close(f);
          END ELSE Close(f);
     END;
{$ENDIF}
     prob[1] := FALSE;prob[2] := FALSE;HClrscr;Wipe(b64k);
     FOR t := 1 TO maxpl DO WITH p[t] DO
     BEGIN
          IF trainer THEN lives := 21 ELSE lives := 7;
          next_speed := 4;
          IF idevice > 0 THEN
          BEGIN
               IF NOT calibrated[idevice-1] THEN prob[idevice] := TRUE;
               curpl := t;
          END;
     END;
     FOR t := 1 TO 2 DO IF prob[t] THEN
     BEGIN
          Writes('PROBLEM(S):',0,0,TRUE);
          Writes('JOY '+Itoa(t)+' NOT CALIBRATED',0,t*20+10,TRUE);
          k := 38;
     END;
     IF k = 38 THEN
     BEGIN
          Writes('PRESS A KEY',0,4*20,TRUE);
          IF GetAKey2 = 0 THEN;
     END ELSE
     BEGIN
          Assign(f,'jmlives!.cfg');{$I-} Rewrite(f,1);{$I+}
          IF ioresult = 0 THEN
          BEGIN
               FOR t := 1 TO 4 DO
                   BlockWrite(f,p[t],SizeOf(player));
               BlockWrite(f,maxpl,SizeOf(maxpl));
               Close(f);
          END;
          SetHires;IF vmode = 1 THEN EgaGreys;
          IF NOT using_save THEN
          BEGIN
{$IFDEF SIMPLE}
               which_to_play := 1;
{$ELSE}
               Writes('1. BEGINNER',0,0,TRUE);
{$IFDEF REG}
               Writes('2. INTERMEDIATE',0,16,TRUE);
               Writes('3. ADVANCED',0,32,TRUE);
               Writes('4. GRAND LOOP',0,48,TRUE);
               Writes('5. RANOMIZER',0,64,TRUE);
               Assign(f,'jmlives!.sav');{$I-} Reset(f,1);{$I+}
               IF ioresult = 0 THEN
               BEGIN
                    Writes('6. SAVED GAME',0,80,TRUE);
                    keyls[6] := #7;maxls := 6;
                    Close(f);
               END;
               which_base := maxls;
               GetMore;
{$ENDIF}
               REPEAT
                     ch := GetAKey2;
               UNTIL Pos(Chr(ch),keyls) > 0;
               which_to_play := ch-1;
{$ENDIF}
               Game_Music := TRUE;
               IF (which_to_play = 6) AND (which_base = 6) THEN
               BEGIN
                    Assign(f,'jmlives!.sav');{$I-} Reset(f,1);{$I+}
                    using_save := TRUE;
                    BlockRead(f,maxpl,SizeOf(maxpl));
                    BlockRead(f,which_to_play,SizeOf(which_to_play));
                    BlockRead(f,level_start,SizeOf(level_start));
                    FOR t := 1 TO 4 DO
                        BlockRead(f,p[t],SizeOf(p[t]));
                    Close(f);
               END;
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
{$IFDEF DOX}
PROCEDURE MainHlp1;EXTERNAL;{$L MainHlp1}
PROCEDURE MainHlp2;EXTERNAL;{$L MainHlp2}
PROCEDURE MainHlp3;EXTERNAL;{$L MainHlp3}
PROCEDURE MainHlp4;EXTERNAL;{$L MainHlp4}
PROCEDURE MainHlp5;EXTERNAL;{$L MainHlp5}
PROCEDURE MainHlp6;EXTERNAL;{$L MainHlp6}   {Holy shit again!}
PROCEDURE Story   ;EXTERNAL;{$L Story}
PROCEDURE Order1  ;EXTERNAL;{$L Order1}
{$IFNDEF REG}
PROCEDURE Order2  ;EXTERNAL;{$L Order2}
{$ELSE}
PROCEDURE Order3  ;EXTERNAL;{$L Order3}
{$ENDIF}
{$ENDIF}
PROCEDURE Give_Help;
BEGIN
     r.ax := 3;Intr($10,r);
     {$IFDEF DOX}
     PutUp(@mainhlp1);
     PutUp(@mainhlp2);
     PutUp(@mainhlp3);
     PutUp(@mainhlp4);
     PutUp(@mainhlp5);
     PutUp(@mainhlp6);
     {$ENDIF}
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Order_Info;
BEGIN
     r.ax := 3;Intr($10,r);
     {$IFDEF DOX}
     PutUp(@order1);
     {$ENDIF}
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE PutUpOrder;
BEGIN
     {$IFDEF DOX}
     {$IFDEF REG}
     PutUp(@Order3);
     {$ELSE}
     PutUp(@Order2);
     {$ENDIF}
     {$ENDIF}
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Show_Story;
BEGIN
     r.ax := 3;Intr($10,r);
     {$IFDEF DOX}
     PutUp(@story);
     {$ENDIF}
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Opt_Change;
VAR
   n : String;
   id : BYTE;
BEGIN
     WITH p[curpl] DO
     BEGIN
          id := idevice;
          REPEAT id := (id + 1) MOD 3;
          UNTIL avail[id];
          IF id <> idevice THEN
          BEGIN
               idevice := id;
               Spin(Devs[id]+'  ',20+11*16,(curpl-1)*16,4);
               Spin(Devs2[id],3*16,5*16,4);
               n := Devs[id]+' INPUT';IF id = 0 THEN n := n + '  ';
               Spin(n,8*16,6*16,4);
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Pl_Change(m : BOOLEAN);
VAR
   n : String;
   id : BYTE;
BEGIN
     Writes(' ',0,16*(curpl-1),TRUE);
     id := p[curpl].idevice;
     Inc(curpl,Ord(m)*2-1);
     IF curpl = 5 THEN curpl := 1 ELSE
        IF curpl = 0 THEN curpl := 4;
     Writes('*',0,16*(curpl-1),TRUE);
     WITH p[curpl] DO
     BEGIN
          IF id <> idevice THEN
          BEGIN
               id := idevice;
               Spin(Devs2[id],3*16,5*16,4);
               n := Devs[id]+' INPUT';IF id = 0 THEN n := n + '  ';
               Spin(n,8*16,6*16,4);
          END;
     END;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE Show_Credits;
BEGIN
     SetHires;IF vmode = 1 THEN EgaGreys;
     Writes('DESIGN, SOUND FX,',0,0,TRUE);
     FullSpin('DESIGN, SOUND FX,',0,0,8);
     Writes('CODING, GRAPHICS -',0,16,TRUE);
     FullSpin('CODING, GRAPHICS -',0,16,8);
     Writes('      DAVE SHARPLESS',0,32,TRUE);
     FullSpin('      DAVE SHARPLESS',0,32,8);
     Writes('MUSIC COORDINATION -',0,58,TRUE);
     FullSpin('MUSIC COORDINATION -',0,58,8);
     Writes('      GEORGE HARIZAL',0,74,TRUE);
     FullSpin('      GEORGE HARIZAL',0,74,8);
     Writes('SATURN BITMAPS  -',0,100,TRUE);
     FullSpin('SATURN BITMAPS  -',0,100,8);
     Writes('         JIM NORWOOD',0,116,TRUE);
     FullSpin('         JIM NORWOOD',0,116,8);
     Writes('ADDITIONAL HELP -',0,142,TRUE);
     FullSpin('ADDITIONAL HELP -',0,142,8);
     Writes('         SHAWN GREEN',0,158,TRUE);
     FullSpin('         SHAWN GREEN',0,158,8);
     Writes('PRESS A KEY',0,184,TRUE);
     FullSpin('PRESS A KEY',0,184,8);
     IF GetAKey2 = 0 THEN;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE High_Scores(b : BOOLEAN);
TYPE
    sc_rec = RECORD
               na : STRING[3];
               sc : LONGINT;
             END;
VAR
   chk1,chk2 : LONGINT;
   scores : ARRAY[0..10] OF sc_rec;
   temp : sc_rec;

PROCEDURE ShowTable;
CONST
     curtofs : WORD = 0;
BEGIN
     FOR t := 0 TO 63 DO
     BEGIN
          drot1[(t+0)*3+0] := t;
          drot1[(t+0)*3+1] := 0;
          drot1[(t+0)*3+2] := 0;

          drot1[(t+64)*3+0] := 63;
          drot1[(t+64)*3+1] := 0;
          drot1[(t+64)*3+2] := t;

          drot1[(t+128)*3+0] := 63-t;
          drot1[(t+128)*3+1] := 0;
          drot1[(t+128)*3+2] := 63;

          drot1[(t+192)*3+0] := 0;
          drot1[(t+192)*3+1] := t;
          drot1[(t+192)*3+2] := 63;

          drot1[(t+256)*3+0] := 0;
          drot1[(t+256)*3+1] := 63;
          drot1[(t+256)*3+2] := 63-t;

          drot1[(t+320)*3+0] := t;
          drot1[(t+320)*3+1] := 63;
          drot1[(t+320)*3+2] := 0;

          drot1[(t+384)*3+0] := 63;
          drot1[(t+384)*3+1] := 63;
          drot1[(t+384)*3+2] := t;

          drot1[(t+448)*3+0] := 63-t;
          drot1[(t+448)*3+1] := 63-t;
          drot1[(t+448)*3+2] := 63-t;
     END;
     SetHires;IF vmode = 1 THEN EgaGreys;
     IF vmode = 2 THEN
     BEGIN
          port[$3c8] := 1;
          FOR t := 1*3 TO 32*3 DO port[$3c9] := 0;
     END;
     IF vmode = 2 THEN Writes3('-HALL OF FAME-',48,0) ELSE Writes('-HALL OF FAME-',48,0,TRUE);
     FOR t := 0 TO 10 DO WITH scores[t] DO
     BEGIN
          IF vmode = 2 THEN
          BEGIN
               Writes3(Ltoa(sc),16*3,t*15+22);
               Writes3(na,16*14,t*15+22);
          END ELSE
          BEGIN
               Writes(Ltoa(sc),16*3,t*15+22,TRUE);
               Writes(na,16*14,t*15+22,TRUE);
          END;
     END;
     curtofs := 0;t := 0;abstime := 0;
     REPEAT
     IF vmode = 2 THEN
     ASM
             mov     dx,$3da
     @wras:  in      al,dx
             test    al,8
             jz      @wras
             cld
             mov     dx,$3c8
             mov     al,1
             out     dx,al
             inc     dl
             mov     si,Offset(drot1[0])
             mov     di,[curtofs]
             add     si,di
             mov     cx,3*32
     @stot:  lodsb
             out     dx,al
             inc     di
             cmp     di,1536
             jnz     @oklt
             xor     di,di
             mov     si,Offset(drot1)
     @oklt:  loop    @stot
             add     [curtofs],3
             cmp     [curtofs],1536
             jnz     @okct
             mov     [curtofs],0
     @okct:
     END;
     Inc(t);
     UNTIL keypress OR ((AbsTime > 2040) AND b);
{     r.ax := $13;Intr($10,r);}
     SetHires;
     IF vmode = 1 THEN EgaGreys;
END;

BEGIN
     {b true means check p[pl]'s score}
     Assign(f,'jmlives!.his');{$I-} Reset(f,1);{$I+}
     IF ioresult > 0 THEN
     BEGIN
          FOR t := 0 TO 10 DO WITH scores[t] DO
          BEGIN
               na := '---';
               sc := 0;
          END;
     END ELSE
     BEGIN
          chk1 := 0;
          FOR t := 0 TO 10 DO WITH scores[t] DO
          BEGIN
               BlockRead(f,scores[t],SizeOf(sc_rec));
               Inc(chk1,sc+Ord(na[0])+Ord(na[1])+Ord(na[2])+Ord(na[3]) );
          END;
          BlockRead(f,chk2,SizeOf(LONGINT));
          Close(f);
          chk1 := chk1 SHR 1;
          IF chk2 <> chk1 THEN
          BEGIN
               Erase(f);
               port[$21] := $ff;
               WHILE TRUE DO;
          END;
     END;
     IF b AND (p[pl].score > scores[10].sc) THEN
     BEGIN
          scores[10].sc := p[pl].score;
{          r.ax := $13;Intr($10,r);}
          SetHires;
          IF vmode = 1 THEN EgaGreys;
          Writes('GREAT SCORE!',0,0,TRUE);
          Writes('ENTER YOUR INITIALS',0,40,TRUE);
          Writes('(3 CHARACTERS):',0,60,TRUE);
          scores[10].na := GetInp(3,15*16,60);
          FOR t := 0 TO 9 DO
              FOR a := t+1 TO 10 DO
                  IF scores[a].sc > scores[t].sc THEN
                  BEGIN
                       temp := scores[t];
                       scores[t] := scores[a];
                       scores[a] := temp;
                  END;
          Assign(f,'jmlives!.his');{$I-} ReWrite(f,1);{$I+}
          IF ioresult = 0 THEN
          BEGIN
               chk1 := 0;
               FOR t := 0 TO 10 DO WITH scores[t] DO
               BEGIN
                    BlockWrite(f,scores[t],SizeOf(sc_rec));
                    Inc(chk1,sc+Ord(na[0])+Ord(na[1])+Ord(na[2])+Ord(na[3]) );
               END;
               chk1 := chk1 SHR 1;
               BlockWrite(f,chk1,SizeOf(LONGINT));
               Close(f);
          END;
          ShowTable;
     END ELSE ShowTable;
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Main_Selector : BYTE;
CONST
     tcount : BYTE = 0;
BEGIN
     avail[1] := Getc(2) < 1600;
     avail[2] := Getc(8) < 1600;
     Assign(f,'jmlives!.cfg');{$I-} Reset(f,1);{$I+}
     IF ioresult = 0 THEN
     BEGIN
          FOR t := 1 TO 4 DO
              BlockRead(f,p[t],SizeOf(player));
          BlockRead(f,maxpl,SizeOf(maxpl));
          Close(f);
     END;
     REPEAT
{       r.ax := $13;Intr($10,r);}
       SetHires;
       IF vmode = 1 THEN EgaGreys;
       Writes('PLAYER 1 - '+Devs[p[1].idevice],20,16*0,TRUE);
       Writes('PLAYER 2 - '+Devs[p[2].idevice],20,16*1,TRUE);
       Writes('PLAYER 3 - '+Devs[p[3].idevice],20,16*2,TRUE);
       Writes('PLAYER 4 - '+Devs[p[4].idevice],20,16*3,TRUE);
       Writes('*',0,16*(curpl-1),TRUE);
       Writes('C) '+Devs2[p[curpl].idevice],0,16*5,TRUE);
       Writes('T) TEST '+Devs[p[curpl].idevice]+' INPUT',0,16*6,TRUE);
       Writes('P) PLAYERS - '+Itoa(maxpl),0,16*7,TRUE);
       Writes('O) ORDERING INFO',0,16*8,TRUE);
       Writes('H) SCORES D) CREDITS',0,16*9,TRUE);
       WritesW('S) START',0,16*10,TRUE);
       Writes('E) EDITOR',10*16,16*10,TRUE);
       Writes('R) STORY  L) HELP!',0,16*11,TRUE);
       IF tcount = 4 THEN Inc( tcount );
       REPEAT
             REPEAT k := GetAKey2 UNTIL k IN [1,46,20,25,24,35,31,19,18,38,75,77,72,80,32,28,57,15];
             CASE k OF
                46 : Key_Define;
                20 : Test_Input;
                25 : MorePlayers;
                24 : Order_Info;
                35 : High_Scores(FALSE);
                31 : Check_it;
                19 : Show_Story;
                38 : Give_Help;
                32 : Show_Credits;
                28,57,75,77 : Opt_Change;
                72,80 : Pl_Change(k = 80);
             END;
             IF k = 15 THEN
             BEGIN
                  Inc(tcount);
                  IF tcount = 4 THEN trainer := TRUE;
             END ELSE tcount := 0;
       UNTIL (k IN [1,46,20,24,35,19,18,38,32,31]) OR (tcount = 4);
     UNTIL k IN [1,31,18];
     Main_Selector := k;
END;

END.
