USES
    Dos,Crt,jman1u,dact,gird1u;

CONST
     vmode : BYTE = 0;
     egacross : ARRAY[0..255] OF BYTE = (0,2,6,13,1,1,4,7, 0,0,0,0,0,0,0,0,
                                         15,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         4,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0 );
     cgacross : ARRAY[0..255] OF BYTE = (0,1,2,1,2,1,2,1, 0,0,0,0,0,0,0,0,
                                         3,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0 );
VAR
   t : WORD;

   r : Registers;
   m320 : ARRAY[0..199] OF WORD;
   m40 : ARRAY[0..199] OF WORD;
   m80 : ARRAY[0..199] OF WORD;
   dbuf : ARRAY[0..255] OF BYTE;
   b64k : POINTER;
   curim : ARRAY[0..630] OF BYTE;
   lastims : ARRAY[0..30] OF BYTE;

PROCEDURE Wipe(n : POINTER);ASSEMBLER;
ASM
        les     di,[n]
        mov     cx,32767
        xor     ax,ax
        rep     stosw
END;

PROCEDURE WriteEsDiAl;ASSEMBLER;
ASM
        mov     [es:di],al
        push    es
        cmp     [vmode],1
        jnz     @nmode2
        push    dx
        push    cx
        push    bx
        push    di
        push    ax
        mov     bx,ax
        xor     bh,bh
        mov     ah,BYTE [egacross+bx]
        mov     dx,$3ce
        mov     al,0
        out     dx,ax
        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m40+bx]
        mov     ax,dx
        mov     cx,8
        div     cl
        mov     cl,ah
        cbw
        add     di,ax
        mov     bx,128
        shr     bx,cl
        mov     bh,bl
        xor     bh,255
        mov     dx,$3ce
        mov     al,8
        mov     ah,bl
        out     dx,ax

        mov     ax,$a000
        mov     es,ax
        or      BYTE [es:di],al         {AL is insignificant when using Set/Reset}

        pop     ax
        pop     di
        pop     bx
        pop     cx
        pop     dx
        jmp     @expr
@nmode2:
        push    dx
        push    cx
        push    bx
        push    di
        push    ax
        mov     bx,ax
        xor     bh,bh
        mov     ah,BYTE [cgacross+bx]
        push    ax

        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m80+bx]
        mov     ax,dx
        mov     cx,4
        div     cl
        mov     cl,ah
        shl     cl,1
        cbw
        add     di,ax
        pop     ax
        xchg    al,ah
        xor     ah,ah
        ror     al,1
        ror     al,1
        shr     ax,cl
        mov     bx,255-(128+64)
        ror     bl,cl
        mov     ah,bl

        mov     bx,$b800
        mov     es,bx
        mov     bl,BYTE [es:di]
        and     bl,ah
        or      bl,al
        mov     BYTE [es:di],bl

        pop     ax
        pop     di
        pop     bx
        pop     cx
        pop     dx

@expr:  pop     es
END;

PROCEDURE DrawImage(x,y,point : INTEGER;
                    remove,
                    draw0,
                    orit,
                    flip   : BOOLEAN;
                    andb   : BYTE);ASSEMBLER;
VAR
   drawx : WORD;
   ori : BYTE;
   wd,ht : INTEGER;

ASM
        mov     si,[point]
        mov     bx,[y]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        mov     [drawx],ax
        add     di,ax
        xor     ax,ax
        push    ds
        pop     es
        lodsb
        mov     [wd],ax
        inc     [wd]
        lodsb
        mov     [ht],ax
        push    di
        mov     di,offset (dbuf)
        cmp     [flip],0
        jz      @normdd
        mov     dx,[ht]
@flplsd:mov     cx,[wd]
        add     si,[wd]
        dec     si
@flpld: mov     al,[si]
        dec     si
        stosb
        loop    @flpld
        add     si,[wd]
        inc     si
        dec     dl
        jns     @flplsd
        jmp     @desume
@normdd:mov     ax,[wd]
        mov     cx,[ht]
        inc     cx
        mul     cx
        xchg    ax,cx
        rep     movsb
@desume:mov     es,WORD [b64k+2]
        mov     si,Offset(dbuf)
        pop     di
        mov     dl,[remove]
        mov     cl,[orit]
        mov     [ori],cl
        cld
        xor     cx,cx
        mov     ah,andb
@di1:   mov     cl,BYTE [wd]
        mov     bx,[drawx]
@di2:   cmp     bx,0
        js      @nomov
        cmp     bx,319
        jg      @nomov
        mov     al,[si]
        cmp     draw0,0
        jnz     @skp0t
        or      al,al
        jz      @nomov
@skp0t: or      dl,dl
        jz      @dodr
        mov     al,BYTE [es:di]
        and     al,ah
@dodr:  cmp     [ori],0
        jnz     @dodr2
        call    WriteEsDiAl
{        mov     BYTE [es:di],al}
        jmp     @nomov
@dodr2: mov     ah,BYTE [es:di]
        or      ah,al
        xchg    al,ah
        call    WriteEsDiAl
        xchg    al,ah
{        mov     BYTE [es:di],ah}
@nomov: inc     di
        inc     si
        inc     bx
        loop    @di2
        add     di,320
        mov     al,BYTE [wd]
        push    ax
        cbw
        sub     di,ax
        pop     ax
        dec     [ht]
        jns     @di1
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}

{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Moveimage(x,y,pointb,point,p1,p2,mask : INTEGER;
                    direct : BOOLEAN) : WORD;ASSEMBLER;

VAR
   movres,hilim,movex,movey,lastl,lolim,
   xsize,ysize : WORD;
   mas,
   endy,starty,
   endx,startx : BYTE;

ASM
        push    ds
        pop     es
        xor     bx,bx
        mov     si,[point]
        mov     ax,[mask]
        mov     [mas],al
        lodsb
        cbw
        mov     [xsize],ax
{        push    ax}
        inc     ax
        shr     ax,1
        add     ax,3
        mov     [hilim],ax
        sub     ax,5
        jns     @okll
        xor     ax,ax
@okll:  mov     [lolim],ax

{        pop     ax
        sub     ax,2
        cmp     [lolim],ax
        jl      @oklms
        mov     ax,[lolim]
@oklms: mov     [hilim],ax}
        lodsb
        inc     ax
        mov     [ysize],ax
        mov     al,[direct]

        mov     di,offset [curim]
        or      al,al
        jz      @normd
        mov     dx,[ysize]
@flpls: mov     cx,[xsize]
        inc     cx
        add     si,[xsize]
@flpl:  mov     al,[si]
        stosb                           (*Mirror image*)
        dec     si
        loop    @flpl
        add     si,[xsize]
        inc     si
        inc     si
        dec     dl
        jns     @flpls
        jmp     @dresume
@normd: mov     ax,[xsize]
        inc     ax
        mul     [ysize]
        mov     cx,ax

        rep     movsb                   (* New image @ 'curim' *)

@dresume:
        mov     si,offset curim
        mov     bx,[y]
        mov     [movey],bx
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        mov     [movex],ax
        add     di,ax                   (*DI = Screen location*)

        mov     ax,WORD [b64k+2]
        mov     es,ax                   (*ES = Screen SEG*)
        mov     dx,[ysize]              (*Get Y size*)
        mov     movres,0
        mov     ax,WORD [p1]
        mov     bx,WORD [p2]
        mov     bh,al
@mtosc: push    [movex]
        mov     cx,[xsize]
        add     si,[xsize]
        inc     si
        cmp     [movey],200
        jge     @skp1
        cmp     [movey],0
        jl      @skp1
        sub     si,[xsize]
        dec     si
        inc     cx
        or      dl,dl
        jnz     @mtos
        sub     cx,8
        jz      @skpa
        js      @skpa
        add     di,4
@mtos:  lodsb                           (*Read curim*)
        cmp     al,bh
        jnz     @notp1
        mov     al,bl
@notp1: mov     ah,BYTE [es:di]
        push    ax
        and     ah,$f8
        cmp     ah,248
        jnz     @popgo
        or      dl,dl
        jz      @onein
        or      [movres],3
@onein: or      [movres],1
@popgo: pop     ax
        and     ah,[mas]
        or      dl,dl
        jz      @okat2
        cmp     [disapp],0
        jnz     @n0ch
        or      al,al
        jz      @zoko
@n0ch:  or      ah,ah
        jz      @okat1
        js      @okat3
        cmp     ah,5
        jle     @okat1
        cmp     ah,7
        jle     @bkat1
        cmp     ah,39
        jle     @okat1
@bkat1: or      [movres],8
        jmp     @okat1
@okat3: or      [movres],32
@okat1: and     ah,7
        or      ah,ah
        jz      @zoko
        cmp     cx,[lolim]
        jl      @okat2
        cmp     cx,[hilim]
        jg      @okat2
        or      [movres],16
        cmp     ah,1
        jz      @fulc
        cmp     ah,2
        jnz     @okat2
        or      [movres],4
        jnz     @zoko
@fulc:  or      [movres],3
@okat2: and     ah,7
        cmp     ah,1
        jnz     @zoko
        or      dl,dl
        jnz     @zoko
        or      [movres],1
@zoko:  or      dl,dl
        jz      @nmto
        and     ah,7
        or      al,ah
        cmp     [movex],320
        jge     @nmto
        cmp     [movex],0
        jl      @nmto
        call    WriteEsDiAl
{        mov     BYTE [es:di],al}
@nmto:  inc     di
        inc     [movex]
        dec     cx
        jz      @eocx
        jmp     @mtos
@eocx:  add     di,319
        sub     di,[xsize]
        jmp     @xxx
@skp1:  mov     di,[movex]
@xxx:   pop     [movex]
        inc     [movey]
        dec     dl
        jns     @mtosc

{----------------------------------- New image drawn ----}

@skpa:  mov     di,offset lastims
        mov     bx,[pointb]
        shl     bx,1
        shl     bx,1
        add     di,bx
        mov     [lastl],di
        mov     ax,[di+0]
        sub     ax,[x]
        js      @leftward
        mov     bx,[xsize]
        inc     bx
        mov     [endx],bl
        sub     bx,ax
        mov     [startx],bl
        jmp     @conx

@leftward:
        neg     ax
        mov     [startx],0
        mov     [endx],al          {-}
@conx:  mov     ax,[di+2]
        sub     ax,[y]
        js      @downward
        mov     bx,[ysize]
        mov     [endy],bl
        sub     bx,ax
        mov     [starty],bl
        jmp     @cony
@downward:
        neg     ax
        mov     [starty],0
        dec     al
        mov     [endy],al       {-}
@cony:  mov     di,[lastl]
        push    di
        mov     bx,[di+2]
        mov     [movey],bx
        or      bx,bx
        jns     @oky
        xor     bx,bx
@oky:   shl     bx,1
        mov     ax,WORD [bx+m320]            (*ax is y*)
        mov     si,[di]
        mov     [movex],si
        add     si,ax                   (*si = scnloc*)
        mov     bl,[starty]
        mov     bh,[endy]
        mov     dl,[startx]
        mov     dh,[endx]
        xor     cx,cx
@doy:   xor     cl,cl
        push    [movex]
        cmp     [movey],200
        jge     @skp2
        cmp     [movey],0
        jl      @skp2

@dox:   cmp     cl,dl
        jl      @chks1
        cmp     cl,dh
        jl      @toff
@chks1: cmp     ch,bl
        jl      @nope
        cmp     ch,bh
        jg      @nope

@toff:  mov     al,BYTE [es:si]
        and     al,7
{        or      al,15}

{        mov     BYTE [es:si],al}
        xchg    si,di
        call    WriteEsDiAl
        xchg    si,di
@nope:  inc     cl
        inc     si
        cmp     cl,BYTE [xsize]
        jbe     @dox
        add     si,319
        sub     si,[xsize]
@skp2:  pop     [movex]
        inc     [movey]
        inc     ch
        cmp     ch,BYTE [ysize]
        jb      @doy

        pop     di
        mov     ax,[x]
        mov     [di],ax
        mov     ax,[y]
        mov     [di+2],ax
        mov     ax,[movres]
END;

BEGIN
     FOR t := 0 TO 199 DO m320[t] := t*320;
     FOR t := 0 TO 199 DO m40[t] := t*40;
     FOR t := 0 TO 199 DO
         IF Odd(t) THEN m80[t] := $2000+(t DIV 2)*80
         ELSE m80[t] := (t DIV 2)*80;
     FOR t := 8 TO 255 DO egacross[t] := egacross[(t DIV 8)*8];
     FOR t := 8 TO 255 DO cgacross[t] := cgacross[(t DIV 8)*8];

     CASE vmode OF
      0 : BEGIN
               GetMem(b64k,65535);
               r.ax := 4;Intr($10,r);
               r.ah := $b;r.bx := $0100;Intr($10,r);
          END;
      1 : BEGIN
               GetMem(b64k,65535);
               r.ax := $d;Intr($10,r);
               portw[$3ce] := $0005;
               portw[$3ce] := $0f01;
               portw[$3ce] := $0003;
          END;
      2 : BEGIN
               b64k := Ptr($A000,0);
               r.ax := $13;Intr($10,r);
               port[$3c8] := 0;
               FOR t := 0 TO 767 DO port[$3c9] := dactable[t];
          END;
     END;
     Wipe(b64k);
     DrawImage(50,50,Ofs(gird1),FALSE,FALSE,FALSE,FALSE,0);
     FOR t := 0 TO 80 DO
     BEGIN
         IF MoveImage(t,50,0,Ofs(jman1[3]),0,0,255,FALSE) = 0 THEN;
         IF MoveImage(50,t,1,Ofs(jman1[3]),0,0,255,FALSE) = 0 THEN;
     END;
     Readln;
END.
