     vmode : BYTE = 0;
     egacross : ARRAY[0..255] OF BYTE = (0,2,6,13,1,1,4,7, 0,0,0,0,0,0,0,0,
                                         15,0,0,0,0,0,0,0, 3,0,0,0,0,0,0,0,
                                         4,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0 );
     cgacross : ARRAY[0..255] OF BYTE = (0,1,2,1,2,1,2,1, 0,0,0,0,0,0,0,0,
                                         3,0,0,0,0,0,0,0, 2,0,0,0,0,0,0,0,
                                         1,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
                                         0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0 );
VAR
   t : WORD;

   r : Registers;
   m320 : ARRAY[0..199] OF WORD;
   m40 : ARRAY[0..199] OF WORD;
   m80 : ARRAY[0..199] OF WORD;
   dbuf : ARRAY[0..255] OF BYTE;
   b64k : POINTER;
   curim : ARRAY[0..630] OF BYTE;
   lastims : ARRAY[0..30] OF BYTE;

PROCEDURE Wipe(n : POINTER);ASSEMBLER;
ASM
        les     di,[n]
        mov     cx,32767
        xor     ax,ax
        rep     stosw
END;

PROCEDURE WriteEsDiAl;ASSEMBLER;
ASM
        mov     [es:di],al
        push    es
        cmp     [vmode],1
        jnz     @nmode2
        push    dx
        push    cx
        push    bx
        push    di
        push    ax
        mov     bx,ax
        xor     bh,bh
        mov     ah,BYTE [egacross+bx]
        mov     dx,$3ce
        mov     al,0
        out     dx,ax
        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m40+bx]
        mov     ax,dx
        mov     cx,8
        div     cl
        mov     cl,ah
        cbw
        add     di,ax
        mov     bx,128
        shr     bx,cl
        mov     bh,bl
        xor     bh,255
        mov     dx,$3ce
        mov     al,8
        mov     ah,bl
        out     dx,ax

        mov     ax,$a000
        mov     es,ax
        or      BYTE [es:di],al         {AL is insignificant when using Set/Reset}

        pop     ax
        pop     di
        pop     bx
        pop     cx
        pop     dx
        jmp     @expr
@nmode2:
        push    dx
        push    cx
        push    bx
        push    di
        push    ax
        mov     bx,ax
        xor     bh,bh
        mov     ah,BYTE [cgacross+bx]
        push    ax

        mov     ax,di
        mov     cx,320
        xor     dx,dx
        div     cx
        mov     bx,ax
        shl     bx,1
        mov     di,WORD [m80+bx]
        mov     ax,dx
        mov     cx,4
        div     cl
        mov     cl,ah
        shl     cl,1
        cbw
        add     di,ax
        pop     ax
        xchg    al,ah
        xor     ah,ah
        ror     al,1
        ror     al,1
        shr     ax,cl
        mov     bx,255-(128+64)
        ror     bl,cl
        mov     ah,bl

        mov     bx,$b800
        mov     es,bx
        mov     bl,BYTE [es:di]
        and     bl,ah
        or      bl,al
        mov     BYTE [es:di],bl

        pop     ax
        pop     di
        pop     bx
        pop     cx
        pop     dx

@expr:  pop     es
END;
