USES
    Dos,Crt,pel1u,gird1u,ladd1u,jman1u,ropes1u;

CONST
     SIZEX   = 16;
     SIZEY   = 10;

TYPE
    corc = RECORD
              x,y : WORD;
           END;

    descript = RECORD
                x,y : WORD;
                typ : SHORTINT;
                kill : BOOLEAN;
               END;
    Custom_Header = RECORD
                        title : STRING[18];
                        fname : NameStr;
                        ndots : WORD;
                        size1 : WORD;
                        size2 : WORD;
                    END;

VAR
   m320 :array[0..220] of word;
   fn : STRING;
   r : Registers;
   lastims : ARRAY[0..20,0..SIZEX*SIZEY DIV 2] OF INTEGER;
   t,a : WORD;
   key : CHAR;
   cor : corc;
   f : FILE;
   k,z : BYTE;
   curstep,usestep,
   curstep2,usestep2,
   fl,
   x1,y1 : WORD;
   pix : ARRAY[1..6] OF WORD;
   tab : ARRAY[1..1000,1..6] OF corc;
   tasize : ARRAY[1..30] OF BYTE;
   tasks : ARRAY[1..30,1..100] OF descript;
   curtask : BYTE;
   sstr : Custom_Header;

   citem : RECORD
              x,y,cofs : WORD;
              k        : BYTE;
           END;
   found : BOOLEAN;

{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE DrawImage(x,y,point : WORD;
                    remove : BOOLEAN);ASSEMBLER;
VAR
   drawx : WORD;
   wd,ht : BYTE;

ASM
        mov     si,[point]
        mov     bx,[y]
        mov     dl,[remove]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        mov     [drawx],ax
        add     di,ax
        mov     ax,0a000h
        mov     es,ax
        mov     al,[si]
        mov     [wd],al
        inc     [wd]
        mov     al,[si+1]
        mov     [ht],al
        add     si,2
        cld
        xor     cx,cx
@di1:   mov     cl,[wd]
        mov     bx,[drawx]
@di2:   cmp     bx,0
        js      @nomov
        cmp     bx,319
        jg      @nomov
        mov     al,[si]
        or      al,al
        jz      @nomov
        or      dl,dl
        jz      @dodr
        xor     al,al
@dodr:  mov     BYTE [es:di],al
@nomov: inc     di
        inc     si
        inc     bx
        loop    @di2
        add     di,320
        mov     al,[wd]
        cbw
        sub     di,ax
        dec     [ht]
        jns     @di1
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
PROCEDURE InitTable; ASSEMBLER;
ASM
        push    ds
        pop     es
        xor     ax,ax
        mov     cx,220
        cld
        mov     di,offset [m320]
@lop:   stosw
        add     ax,320
        loop    @lop
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}
FUNCTION Moveimage(x,y,pointb,point : WORD;
                    direct : BOOLEAN) : WORD;ASSEMBLER;

VAR
   movres,hilim,
   xsize,ysize : WORD;
   curim       : ARRAY[0..1023] OF BYTE;
   endy,starty,
   endx,startx : BYTE;

ASM
        push    ds
        pop     es
        xor     bx,bx
        mov     si,[point]
        lodsb
        cbw
        mov     [xsize],ax
        sub     ax,5
        mov     [hilim],ax
        lodsb
        inc     ax
        mov     [ysize],ax
        mov     al,[direct]

        mov     bx,[pointb]
        shl     bx,1
        shl     bx,1
        mov     di,offset [curim]
        or      al,al
        jz      @normd
        mov     dx,[ysize]
@flpls: mov     cx,[xsize]
        inc     cx
        add     si,[xsize]
@flpl:  mov     al,[si]
        stosb                           (*Mirror image*)
        dec     si
        loop    @flpl
        add     si,[xsize]
        inc     si
        inc     si
        dec     dl
        jns     @flpls
        jmp     @dresume
@normd: mov     ax,[xsize]
        inc     ax
        mul     [ysize]
        mov     cx,ax

        rep     movsb                   (* New image @ 'curim' *)

@dresume:
        mov     si,offset curim
        mov     bx,[y]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        add     di,ax                   (*DI = Screen location*)

        mov     ax,0a000h
        mov     es,ax                   (*ES = Screen SEG*)
        mov     dx,[ysize]              (*Get Y size*)
        mov     movres,0
@mtosc: mov     cx,[xsize]
        inc     cx
        or      dl,dl
@mtos:  lodsb                           (*Read curim*)
        mov     ah,BYTE [es:di]
        and     ah,7
        or      dl,dl
        jz      @okat2
        or      al,al
        jz      @zoko
        mov     al,$f8
        cmp     ah,4
        jle     @okat1
        cmp     ah,8
        jge     @okat1
        or      [movres],4
@okat1: cmp     ah,1
        jnz     @zoko
        cmp     cx,5
        jl      @okat2
        cmp     cx,[hilim]
        jg      @okat2
        or      [movres],3
@okat2: cmp     ah,1
        jnz     @zoko
        or      dl,dl
        jnz     @zoko
        or      [movres],1
@zoko:  or      dl,dl
        jz      @nmto
;        or      al,ah
        mov     BYTE [es:di],al
@nmto:  inc     di
        loop    @mtos
        add     di,319
        sub     di,[xsize]
        dec     dl
        jns     @mtosc

{----------------------------------- New image drawn ----}

        mov     di,offset lastims
        mov     ax,[di+0]
        sub     ax,[x]
        js      @leftward
        mov     bx,[xsize]
        inc     bx
        mov     [endx],bl
        sub     bx,ax
        mov     [startx],bl
        jmp     @conx

@leftward:
        neg     ax
        mov     [startx],0
        mov     [endx],al          {-}
@conx:  mov     ax,[di+2]
        sub     ax,[y]
        js      @downward
        mov     bx,[ysize]
        mov     [endy],bl
        sub     bx,ax
        mov     [starty],bl
        jmp     @cony
@downward:
        neg     ax
        mov     [starty],0
        dec     al
        mov     [endy],al       {-}
@cony:  mov     di,offset lastims
        push    di
        mov     bx,[di+2]
        shl     bx,1
        mov     ax,WORD [bx+m320]            (*ax is y*)
        mov     si,[di]
        add     si,ax                   (*si = scnloc*)
        mov     bl,[starty]
        mov     bh,[endy]
        mov     dl,[startx]
        mov     dh,[endx]
        xor     cx,cx
@doy:   xor     cl,cl
@dox:   cmp     cl,dl
        jl      @chks1
        cmp     cl,dh
        jl      @toff
@chks1: cmp     ch,bl
        jl      @nope
        cmp     ch,bh
        jg      @nope

@toff:  mov     al,BYTE [es:si]
        and     al,7
        {or      al,15}

        mov     BYTE [es:si],al
@nope:  inc     cl
        inc     si
        cmp     cl,BYTE [xsize]
        jbe     @dox
        add     si,319
        sub     si,[xsize]
        inc     ch
        cmp     ch,BYTE [ysize]
        jbe     @doy

        pop     di
        mov     ax,[x]
        mov     [di],ax
        mov     ax,[y]
        mov     [di+2],ax
        mov     ax,[movres]
END;
{\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/}

PROCEDURE Load_DAC;
TYPE
    raya = ARRAY[0..767] OF BYTE;
VAR
   ray : ^raya;
   f : FILE;
BEGIN
     New(ray);
     Assign(f,'..\dtable');
     Reset(f,1);BlockRead(f,ray^,768);Close(f);
     FOR t := 160*3 TO 192*3 DO ray^[t] := ray^[t-(128*3)];
     WITH r DO
     BEGIN
          ax := $1012;es := SEG(ray^);dx := OFS(ray^);
          ray^[$f8*3] := 63;ray^[$f8*3+1] := 63;ray^[$f8*3+2] := 63;
          bx := 0;cx := $100;Intr($10,r);
     END;
     Dispose(ray);
END;
FUNCTION GetOfs(n : BYTE) : WORD;
BEGIN
     CASE n OF
      1 : GetOfs := Ofs(pel1);
      2 : GetOfs := Ofs(gird1);
      3 : GetOfs := Ofs(ladd1);
      4 : GetOfs := Ofs(jman1);
      5 : GetOfs := Ofs(ropes1[0]);
      6 : GetOfs := Ofs(ropes1[1]);
     END;
END;
PROCEDURE DrawIt(n,m,o : WORD);
BEGIN
     CASE n OF
      1 : DrawImage(m,o,GetOfs(1),FALSE);
      2 : DrawImage(m,o,GetOfs(2),FALSE);
      3 : DrawImage(m,o,GetOfs(3),FALSE);
      4 : DrawImage(m,o,GetOfs(4),FALSE);
      5 : DrawImage(m,o,GetOfs(5),FALSE);
      6 : DrawImage(m,o,GetOfs(6),FALSE);
     END;
END;
PROCEDURE SetVGA;
BEGIN
     directvideo := FALSE;
     r.ax := $13;Intr($10,r);
     Load_DAC;InitTable;
     FOR t := 1 TO 6 DO DrawIt(t,180+(t*20),190);
     port[$3c0] := $11;port[$3c0] := 2;port[$3c0] := $20;
END;
PROCEDURE Load_Table;
BEGIN
     Assign(f,fn+'.scn');{$I-} Reset(f,1); {$I+}
     FOR t := 0 TO 300 DO lastims[0,t] := 0;
     FOR a := 1 TO 6 DO pix[a] := 0;
     IF ioresult <> 0 THEN exit;
     FOR a := 1 TO 6 DO
     BEGIN
          BlockRead(f,pix[a],2);
          FOR t := 1 TO pix[a] DO
              BlockRead(f,tab[t][a],SizeOF(corc));
     END;
     BlockRead(f,tasize,Sizeof(tasize));
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN
          BlockRead(f,tasks[t],tasize[t]*Sizeof(descript));
     Close(f);
END;

PROCEDURE ScrSave(fnn : STRING);
VAR
   d : TEXT;
   zz,
   v : word;

BEGIN
     v := 0;zz := 0;
     FOR a := 1 TO 17 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;sstr.title := 'UNKNOWN';sstr.fname := fnn;
     Inc(v,(pix[1]+zz)*4 + 1);
     Assign(d,fnn+'.scr');ReWrite(d);
     t := pix[1]+pix[2]+pix[3]+pix[4]+pix[5]+pix[6];
     sstr.size1 := t*6+2;
     sstr.size2 := v*2+2;
     Write(d,Chr(lo(sstr.size1+sstr.size2+SizeOf(Custom_Header))),
             Chr(hi(sstr.size1+sstr.size2+SizeOf(Custom_Header))));
     FOR z := 0 TO 18 DO Write(d,sstr.title[z]);
     FOR z := 0 TO 8 DO Write(d,sstr.fname[z]);
     Write(d,chr(lo(sstr.ndots)),chr(hi(sstr.ndots)));
     Write(d,Chr(lo(sstr.size1)),Chr(hi(sstr.size1)));
     Write(d,Chr(lo(sstr.size2)),Chr(hi(sstr.size2)));
     write(d,chr(lo(t)),chr(hi(t)));
     v := 0;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN v := a;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN
     BEGIN
          FOR t := 1 TO pix[a] DO
          BEGIN
               Write(d,chr(lo(tab[t,a].x)),chr(hi(tab[t,a].x)),
                       chr(lo(tab[t,a].y)),chr(hi(tab[t,a].y)),
                       chr(lo(a)),chr(hi(a)));
          END;
     END;
     v := 0;zz := 0;
     FOR a := 1 TO 17 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;
     Inc(v,(pix[1]+zz)*4 + 1);

     write(d,chr(lo(pix[1])),chr(hi(pix[1])));
     v := pix[1]+zz;
     z := 0;
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN Inc(z);
     FOR t := 1 TO pix[1]+zz DO
     BEGIN
          write(d,chr(lo(tab[t,1].x)),chr(hi(tab[t,1].x)),
                  chr(lo(tab[t,1].y)),chr(hi(tab[t,1].y)),
                  chr(lo(v)),chr(hi(v)));
          Inc(v,tasize[t]);Write(d,chr(lo(v-1)),chr(hi(v-1)));
     END;
     v := 0;z := 0;
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN Inc(v);
     FOR t := 1 TO 17 DO IF tasize[t] > 0 THEN
     BEGIN
          Inc(z);
          FOR a := 1 TO tasize[t] DO
          BEGIN
               write(d,chr(lo(tasks[t,a].x)),chr(hi(tasks[t,a].x)),
                       chr(lo(tasks[t,a].y)),chr(hi(tasks[t,a].y)),
                       chr(lo(tasks[t,a].typ)),chr(hi(tasks[t,a].typ)),
                       chr(lo(ord(tasks[t,a].kill))),chr(hi(ord(tasks[t,a].kill))));
          END;
     END;
     Close(d);
END;

PROCEDURE Save_Table;
VAR
   d : TEXT;
   zz,
   v : word;
BEGIN
{     ScrSave(fn);Exit;}
     Assign(f,fn+'.scn');{$I-} ReWrite(f,1); {$I+}
     FOR a := 1 TO 6 DO
     BEGIN
          BlockWrite(f,pix[a],2);
          FOR t := 1 TO pix[a] DO
              BlockWrite(f,tab[t][a],SizeOF(corc));
     END;
     BlockWrite(f,tasize,Sizeof(tasize));
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN
          BlockWrite(f,tasks[t],tasize[t]*SizeOf(descript));
     Close(f);
{     Assign(d,fn+'.in1');ReWrite(d);
     t := pix[1]+pix[2]+pix[3]+pix[4]+pix[5]+pix[6];
     Write(d,fn,' : ARRAY[0..',t*3,'] OF WORD = (',t,',');
     v := 0;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN v := a;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN
     BEGIN
          FOR t := 1 TO pix[a] DO
          BEGIN
               IF (t-1) MOD 6 = 0 THEN
               BEGIN
                    Writeln(d);Write(d,'     ');
               END;
               Write(d,tab[t,a].x,',',tab[t,a].y,',',a);
               IF NOT ((a=v) AND (t=pix[a])) THEN Write(d,',');
          END;
     END;
     Writeln(d,');');Writeln(d);
     v := 0;zz := 0;
     FOR a := 1 TO 30 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;
     Inc(v,(pix[1]+zz)*4 + 1);
     Write(d,fn,'_tasks : ARRAY[1..',v,'] OF WORD = (',pix[1],',');
     v := pix[1]+zz;
     z := 0;
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN Inc(z);
     FOR t := 1 TO pix[1]+zz DO
     BEGIN
          Write(d,tab[t,1].x,',',tab[t,1].y,',',v);
          Inc(v,tasize[t]);Write(d,',',v-1);
          IF (t <> pix[1]) OR (z > 0) THEN Write(d,',');
          IF t MOD 6 = 0 THEN
          BEGIN
               Writeln(d);
               Write(d,'       ');
          END;
     END;
     v := 0;z := 0;
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN Inc(v);
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN
     BEGIN
          Inc(z);
          Writeln(d);
          Write(d,'       ');
          FOR a := 1 TO tasize[t] DO
          BEGIN
               Write(d,tasks[t,a].x,',',tasks[t,a].y,',',tasks[t,a].typ,',',ORD(tasks[t,a].kill));
               IF a MOD 6 = 0 THEN
               BEGIN
                    Writeln(d);
                    Write(d,'       ');
               END;
               IF (a <> tasize[t]) OR (z < v) THEN Write(d,',');
          END;
     END;
     Writeln(d,');');
     Close(d);
}
     Assign(d,fn+'d');ReWrite(d);
     t := pix[1]+pix[2]+pix[3]+pix[4]+pix[5]+pix[6];
     write(d,chr(lo(t)),chr(hi(t)));
     v := 0;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN v := a;
     FOR a := 1 TO 6 DO IF pix[a] > 0 THEN
     BEGIN
          FOR t := 1 TO pix[a] DO
          BEGIN
               Write(d,chr(lo(tab[t,a].x)),chr(hi(tab[t,a].x)),
                       chr(lo(tab[t,a].y)),chr(hi(tab[t,a].y)),
                       chr(lo(a)),chr(hi(a)));
          END;
     END;
     Close(d);
     v := 0;zz := 0;
     FOR a := 1 TO 30 DO IF tasize[a]> 0 THEN
     BEGIN
          Inc(v,tasize[a]*4);
          IF a > pix[1] THEN Inc(zz);
     END;
     Inc(v,(pix[1]+zz)*4 + 1);

     Assign(d,fn+'t');ReWrite(d);
     write(d,chr(lo(pix[1])),chr(hi(pix[1])));
     v := pix[1]+zz;
     z := 0;
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN Inc(z);
     FOR t := 1 TO pix[1]+zz DO
     BEGIN
          write(d,chr(lo(tab[t,1].x)),chr(hi(tab[t,1].x)),
                  chr(lo(tab[t,1].y)),chr(hi(tab[t,1].y)),
                  chr(lo(v)),chr(hi(v)));
          Inc(v,tasize[t]);Write(d,chr(lo(v-1)),chr(hi(v-1)));
     END;
     v := 0;z := 0;
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN Inc(v);
     FOR t := 1 TO 30 DO IF tasize[t] > 0 THEN
     BEGIN
          Inc(z);
          FOR a := 1 TO tasize[t] DO
          BEGIN
               write(d,chr(lo(tasks[t,a].x)),chr(hi(tasks[t,a].x)),
                       chr(lo(tasks[t,a].y)),chr(hi(tasks[t,a].y)),
                       chr(lo(tasks[t,a].typ)),chr(hi(tasks[t,a].typ)),
                       chr(lo(ord(tasks[t,a].kill))),chr(hi(ord(tasks[t,a].kill))));
          END;
     END;
     Close(d);
END;
PROCEDURE DrawPix(n : BYTE);
BEGIN
     IF n = 0 THEN
     BEGIN
          SetVGA;
          FOR a := 1 TO 6 DO
              FOR t := 1 TO pix[a] DO
                  DrawIt(a,tab[t][a].x,tab[t][a].y);
     END ELSE
     BEGIN
          FOR t := 1 TO tasize[n] DO
              Drawimage(tasks[n,t].x,tasks[n,t].y,GetOfs(tasks[n,t].typ),tasks[n,t].kill);
     END;
     curtask := n;
END;

BEGIN
     FOR t := 1 TO 30 DO tasize[t] := 0;
     FOR t := 1 TO 6 DO pix[t] := 0;
     fn := paramstr(1);
     IF fn = '' THEN Halt(255);
     Load_Table;
     curtask := 0;
     curstep := 8;curstep2 := 8;
     DrawPix(0);
     r.ax := 0;Intr($33,r);
     citem.cofs := GetOfs(1);
     citem.k := 1;
     WITH r DO
     REPEAT
           IF keypressed THEN WITH citem DO
           BEGIN
                key := ReadKey;
                IF key IN ['1'..'6'] THEN
                BEGIN
                     FOR t := y TO 202 DO
                         IF MoveImage(x,t,0,cofs,FALSE)=1 THEN;
                     cofs := GetOfs(Ord(key)-48);
                     k := Ord(key)-48;
                     IF MoveImage(x,y,0,cofs,FALSE)=1 THEN;
                END ELSE
                IF key IN [''..''] THEN
                        tasize[ORD(key)-1] := 0
                ELSE IF key IN ['B'..'R'] THEN
                     BEGIN
                          t := ORD(key)-ORD('A');
                          IF t <= pix[1] THEN
                             FOR z := 1 TO 20 DO
                             BEGIN
                                  Drawimage(tab[t,1].x,tab[t,1].y,Ofs(pel1),TRUE);
                                  Delay(10);
                                  Drawimage(tab[t,1].x,tab[t,1].y,Ofs(pel1),FALSE);
                                  Delay(10);
                             END;
                     END
                ELSE
                BEGIN
                     IF keypressed THEN
                     BEGIN
                          key := ReadKey;
                          CASE key OF
                            #77 : IF curstep < 10 THEN Inc(curstep);
                            #75 : IF curstep > 1 THEN Dec(curstep);
                            #80 : IF curstep2 > 1 THEN Dec(curstep2);
                            #72 : IF curstep < 10 THEN Inc(curstep2);
                          END;
                     END ELSE
                     IF key IN ['!','a'..'r'] THEN
                     BEGIN
                          IF key IN ['a'..'r'] THEN DrawPix(ORD(Upcase(key))-65)
                          ELSE curtask := 0;
                     END ELSE IF key = 's' THEN Save_Table;
                END;
           END;
           ax := 3;Intr($33,r);
           WITH citem DO
           BEGIN
                GotoXY(1,25);
                Write(curstep:3,curstep2:3,x:4,y:4,curtask:3);
                x1 := x;y1 := y;
                x := cx DIV 2;
                y := dx;
                ax := $200;Intr($16,r);
                IF (al AND 2) = 2 THEN y := y1;
                IF (al AND 4) = 4 THEN x := x1;
                IF (al AND 8) = 8 THEN
                BEGIN
                     usestep := 1;
                     usestep2 := 1;
                END ELSE
                BEGIN
                     usestep := curstep;
                     usestep2 := curstep2;
                END;
                x := (x DIV usestep)*usestep;
                y := (y DIV usestep2)*usestep2;
                IF MoveImage(x,y,0,cofs,FALSE)=1 THEN;
                IF bx = 1 THEN
                BEGIN
                     IF curtask = 0 THEN
                     BEGIN
                          found := FALSE;
                          FOR t := 1 TO pix[k] DO
                              IF (tab[t][k].x = x) AND (tab[t][k].y = y) THEN found := TRUE;
                          IF NOT found THEN
                          BEGIN
                               Inc(pix[k]);
                               tab[pix[k]][k].x := x;
                               tab[pix[k]][k].y := y;
                               DrawImage(x,y,cofs,FALSE);
                          END;
                     END ELSE
                     BEGIN
                          repeat
                                ax := 3;Intr($33,r);
                          until bx = 0;
                          Inc(tasize[curtask]);
                          tasks[curtask,tasize[curtask]].x := x;
                          tasks[curtask,tasize[curtask]].y := y;
                          tasks[curtask,tasize[curtask]].typ := k;
                          tasks[curtask,tasize[curtask]].kill := FALSE;
                          Drawimage(x,y,Getofs(k),FALSE);
                     END;
                END ELSE
                IF bx = 2 THEN
                BEGIN
                     IF curtask = 0 THEN
                     BEGIN
                          fl := 0;
                          FOR t := 1 TO pix[k] DO
                              IF (tab[t][k].x = x) AND (tab[t][k].y = y) THEN fl := t;
                          IF fl > 0 THEN
                          BEGIN
                               FOR t := fl+1 TO pix[k] DO tab[t-1][k] := tab[t][k];
                               Dec(pix[k]);
                               DrawImage(x,y,cofs,TRUE);
                               IF (k=1) THEN
                               BEGIN
                                    FOR t := fl TO 29 DO
                                        tasks[t] := tasks[t+1];
                                    FOR t := fl TO 29 DO
                                        tasize[t] := tasize[t+1];
                                    tasize[30] := 0;
                               END;
                          END;
                     END ELSE
                     BEGIN
                          repeat
                                ax := 3;Intr($33,r);
                          until bx = 0;
                          Inc(tasize[curtask]);
                          tasks[curtask,tasize[curtask]].x := x;
                          tasks[curtask,tasize[curtask]].y := y;
                          tasks[curtask,tasize[curtask]].typ := k;
                          tasks[curtask,tasize[curtask]].kill := TRUE;
                          Drawimage(x,y,Getofs(k),TRUE);
                     END;
                END;
           END;
     UNTIL r.bx = 7;
     r.ax := 3;Intr($10,r);
END.
