{$I Defines.inc}
UNIT Intro;

INTERFACE

USES
    Adlibu,FX,Dos,Routines,Globals,Writesu,ropes1u,gird1u,jman1u,
    rock1u,rock2u,rock3u,comutu,comutmu,comutdu,coms1u,comju;

PROCEDURE Do_Intro;
PROCEDURE Pre_Intro;

CONST
     MAXOFS = 10;
     MAXMA = 700;
     TX = 16;SEP = -1;TY = 0;
     LX = 238;
     {$I dac1.inc}
     ROCKABS = 15;

TYPE
    PRAY = ARRAY[-320..640*32] OF BYTE;

var
   prd : ^PRAY;
   n,m : integer;
   ma : ARRAY[0..MAXMA-1] OF INTEGER;
   igof,itodo,
   taofs,ry,pump,
   s1pumps : WORD;
   old21,
   oldk,stage : BYTE;
   lastimx : ARRAY[0..200] OF WORD;

IMPLEMENTATION

PROCEDURE intscrd;EXTERNAL;{$L intscrd}
PROCEDURE intscrt;EXTERNAL;{$L intscrt}
PROCEDURE intscr2d;EXTERNAL;{$L intscr2d}
PROCEDURE intscr2t;EXTERNAL;{$L intscr2t}
PROCEDURE lid;EXTERNAL;{$L lid}
PROCEDURE jmd;EXTERNAL;{$L jmd}
{$IFDEF PICS}
PROCEDURE Saturn;EXTERNAL;{$L Saturn.obj}
{$ENDIF PICS}

PROCEDURE Rd_Dac(b : BOOLEAN);
BEGIN
     Load_Dac;
     IF b THEN
     BEGIN
          port[$3c8] := 160;
          FOR t := 160*3 TO 200*3 DO port[$3c9] := 0;
          port[$3c8] := 202;
          FOR t := 202*3 TO 255*3 do
              port[$3c9] := dactable1[t];
     END;
END;

PROCEDURE ShipCols;
CONST
     dvals : ARRAY[0..4*3-1] OF BYTE = ($3a,0,$3c,$3d,$3d,0,$3d,1,0,0,0,$3b);
BEGIN
     egacross[240] := 1;egacross[232] := 4;
     egacross[224] := 5;egacross[208] := 14;
     egacross[160] := 5;egacross[161] := 14;
     egacross[162] := 4;egacross[163] := 1;
     IF vmode = 2 THEN
     BEGIN
          port[$3c8] := 160;
          FOR t := 0 TO 4*3-1 DO port[$3c9] := dvals[t];
     END;
END;

PROCEDURE DrawImag(x,y,point : INTEGER;
                    remove,
                    draw0,
                    orit,
                    flip   : BOOLEAN;
                    andb   : BYTE);ASSEMBLER;
VAR
   drawx : WORD;
   ori : BYTE;
   wd,ht : INTEGER;

ASM
        mov     si,[point]
        mov     bx,[y]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[x]
        mov     [drawx],ax
        add     di,ax
        xor     ax,ax
        push    ds
        pop     es
        mov     al,BYTE [cs:si]
        inc     si
        mov     [wd],ax
        inc     [wd]
        mov     al,BYTE [cs:si]
        inc     si
        mov     [ht],ax
        push    di
        mov     di,offset (dbuf)
        cmp     [flip],0
        jz      @normdd
        mov     dx,[ht]
@flplsd:mov     cx,[wd]
        add     si,[wd]
        dec     si
@flpld: mov     al,BYTE [cs:si]
        dec     si
        stosb
        loop    @flpld
        add     si,[wd]
        inc     si
        dec     dl
        jns     @flplsd
        jmp     @desume
@normdd:mov     ax,[wd]
        mov     cx,[ht]
        inc     cx
        mul     cx
        xchg    ax,cx
        push    ds
        push    cs
        pop     ds
        rep     movsb
        pop     ds
@desume:mov     ax,WORD [b64k+2]
        mov     es,ax
        mov     si,Offset(dbuf)
        pop     di
        mov     dl,[remove]
        mov     cl,[orit]
        mov     [ori],cl
        cld
        xor     cx,cx
        mov     ah,andb
@di1:   mov     cl,BYTE [wd]
        mov     bx,[drawx]
@di2:   cmp     bx,0
        js      @nomov
        cmp     bx,319
        jg      @nomov
        mov     al,[si]
        cmp     draw0,0
        jnz     @skp0t
        or      al,al
        jz      @nomov
@skp0t: or      dl,dl
        jz      @dodr
        mov     al,BYTE [es:di]
        and     al,ah
@dodr:  cmp     [ori],0
        jnz     @dodr2
{        mov     BYTE [es:di],al}
        call     WriteEsDiAl
        jmp     @nomov
@dodr2: mov     ah,BYTE [es:di]
        or      ah,al
{        mov     BYTE [es:di],ah}
        xchg     ah,al
        call     WriteEsDiAl
        xchg     ah,al
@nomov: inc     di
        inc     si
        inc     bx
        loop    @di2
        add     di,320
        mov     al,BYTE [wd]
        push    ax
        cbw
        sub     di,ax
        pop     ax
        dec     [ht]
        jns     @di1
END;

procedure wig;ASSEMBLER;
CONST
     cofs : WORD = 0;

ASM
        mov     dx,32
        mov     ax,$a000
        mov     es,ax
        mov     bx,[cofs]
        mov     di,0
@lopt:  push    di
        mov     ax,WORD [ma+bx]
        add     bx,2
        cmp     bx,MAXMA*2
        jnz     @okma2
        xor     bx,bx
@okma2: mov     si,di
        shl     si,1
        add     si,160
        sub     si,ax
        cld
        mov     cx,160
        or      ax,ax
        js      @okdi
        mov     si,di
        shl     si,1
        add     di,318
        add     si,318+160
        sub     si,ax
        std
@okdi:
      {mov     cx,155}
        add     si,WORD [prd]
        add     si,320
        mov     ax,WORD [prd+2]
        push    ds
        mov     ds,ax
        rep     movsw
        pop     ds
        pop     di
        add     di,320
        dec     dx
        jnz     @lopt
        inc     WORD [cofs]
        inc     WORD [cofs]
        cmp     WORD [cofs],MAXMA*2
        jnz     @okma
        mov     WORD [cofs],0
@okma:
END;

PROCEDURE Drot;ASSEMBLER;
CONST
     rdir : INTEGER = 1;
     dofs : BYTE = 171;
ASM
        mov     dx,$3da
@wras:  in      al,dx
        test    al,8
        jz      @wras
        mov     dx,$3c8
        mov     al,[dofs]
        cmp     [rdir],0
        js      @back
        out     dx,al
        inc     dx
        xor     ax,ax
        out     dx,al
        out     dx,al
        out     dx,al
        inc     [dofs]
        cmp     [dofs],201
        jnz     @ok1
        neg     [rdir]
@ok1:   mov     al,63
        jmp     @drex
@back:
        out     dx,al
        inc     dx
        mov     al,63
        out     dx,al
        out     dx,al
        out     dx,al
        dec     [dofs]
        cmp     [dofs],169
        jnz     @ok2
        neg     [rdir]
@ok2:   mov     al,0
@drex:  out     dx,al
        out     dx,al
        out     dx,al
END;

PROCEDURE Moveima(x,y,point : WORD);ASSEMBLER;
VAR
   xsize,ysize,xsiz,workx : WORD;

ASM
        push    ds
        pop     es

        mov     si,[point]
        lodsb
        inc     ax
        cbw
        mov     [xsize],ax
        mov     [xsiz],ax
        lodsb
        inc     ax
        cbw
        mov     [ysize],ax

        mov     si,offset lastimx+4
        mov     bx,[si-4]
        shl     bx,1
        mov     di,WORD [m320+bx]
        mov     ax,[si-2]
        mov     [workx],ax
        add     di,ax
        mov     ax,WORD [b64k+2]
        mov     es,ax
        mov     bx,[ysize]
        mov     ax,[workx]
        or      ax,ax
        js      @nv1
        add     ax,[xsize]
        cmp     ax,320
        jl      @okv1
        sub     ax,320
        sub     [xsiz],ax
        jz      @nopll
        js      @nopll
        jmp     @okv1
@nv1:   neg     ax
        sub     [xsiz],ax
        jz      @nopll
        js      @nopll
        add     di,ax
        add     si,ax
@okv1:
        mov     dx,$3da
@wras:  in      al,dx
        test    al,8
        jz      @wras
@wras2: in      al,dx
        test    al,8
        jnz     @wras2
        mov     dx,[xsize]
        sub     dx,[xsiz]
@puli:  mov     cx,[xsiz]
        cmp     [vmode],2
        jnz     @lpx1
        rep     movsb
        jmp     @lpcx
@lpx1:  lodsb
        call    WriteEsDiAl
        inc     di
        loop    @lpx1
{        rep     movsb}
@lpcx:  add     di,320
        add     si,dx
        sub     di,[xsiz]
        dec     bx
        jnz     @puli

@nopll:
        mov     bx,[y]
        mov     WORD [lastimx],bx
        shl     bx,1
        mov     di,WORD [bx+m320]
        mov     ax,[x]
        mov     [workx],ax
        mov     WORD [lastimx+2],ax
        add     di,ax
        push    di
        mov     si,di
        mov     di,offset (lastimx) + 4
        push    ds
        push    ds
        pop     es
        mov     ax,WORD [b64k+2]
        mov     ds,ax
        mov     dx,[ysize]
@cpy:   mov     cx,[xsize]
        rep     movsb
        add     si,320
        sub     si,[xsize]
        dec     dx
        jnz     @cpy
        pop     ds
        pop     di
        mov     ax,WORD [b64k+2]
        mov     es,ax
        mov     ax,[xsize]
        mov     [xsiz],ax
        mov     ax,[workx]
        mov     si,[point]
        add     si,2
        or      ax,ax
        js      @nv2
        add     ax,[xsize]
        cmp     ax,320
        jl      @okv2
        sub     ax,320
        sub     [xsiz],ax
        jz      @noptt
        js      @noptt
        jmp     @okv2
@nv2:   neg     ax
        sub     [xsiz],ax
        jz      @noptt
        js      @noptt
        add     di,ax
        add     si,ax
@okv2:
        mov     dx,[ysize]
        mov     bx,[xsize]
        sub     bx,[xsiz]
@puti:  mov     cx,[xsiz]
@gc:    lodsb
        or      al,al
        jz      @npt1
        call    WriteEsDiAl
{        mov     BYTE [es:di],al}
@npt1:  inc     di
        loop    @gc
        add     di,320
        add     si,bx
        sub     di,[xsiz]
        dec     dx
        jnz     @puti
@noptt:
END;

{$F+}
PROCEDURE Int_D;
BEGIN
     CASE t OF
       4 : DrawImag(TX+5+(sep*1),TY,ofs(jmd),FALSE,FALSE,FALSE,FALSE,0); {j}
       0 : DrawImag(TX+34+(sep*2),TY,ofs(jmd)+($340+2)*1,FALSE,FALSE,FALSE,FALSE,0);    {u}
       3 : DrawImag(TX+65+(sep*3),TY,ofs(jmd)+($340+2)*2,FALSE,FALSE,FALSE,FALSE,0);       {m}
       1 : DrawImag(TX+96+(sep*4),TY,ofs(jmd)+($340+2)*3,FALSE,FALSE,FALSE,FALSE,0);      {p}
       5 : DrawImag(TX+127+(sep*5),TY,ofs(jmd)+($340+2)*2,FALSE,FALSE,FALSE,FALSE,0);         {m}
       2 : DrawImag(TX+158+(sep*6),TY,ofs(jmd)+($340+2)*4,FALSE,FALSE,FALSE,FALSE,0);            {a}
       7 : DrawImag(TX+189+(sep*7),TY,ofs(jmd)+($340+2)*5,FALSE,FALSE,FALSE,FALSE,0);               {n}
       6 : BEGIN
                DrawImag(LX,TY,ofs(lid),FALSE,FALSE,FALSE,FALSE,0);               {liv}
                DrawImag(LX+30,TY,ofs(lid)+$4e2,FALSE,FALSE,FALSE,FALSE,0);               {es!}
           END;
     END;
END;
{$F-}

{$F+} PROCEDURE Ng;BEGIN END;{$F-}
PROCEDURE Int_1;
CONST
     MAXIMOV = 26;
     lastj : BOOLEAN = FALSE;
     imoves : ARRAY[0..MAXIMOV,0..1] OF BYTE = ( (2,27),(16,1),(2,10),(1,5),
                                                 (8,4),(33,1),(2,12),(8,24),
                                                 (1,22),(16,1),(2,8),(33,4),
                                                 (0,2),(1,3),(2,5),(1,2),
                                                 (0,24),(1,14),(33,1),(4,22),
                                                 (1,5),(2,5),(8,60),(1,5),
                                                 (2,73),(0,16),(16,2) );
     MAXIMOV2 = 5;
     imoves2 : ARRAY[0..MAXIMOV2,0..1] OF BYTE = ( (2,6),(4,16),(1,13),(2,74),
                                                   (1,37),(0,40) );

BEGIN
     WITH p[pl] DO CASE stage OF
      0 : BEGIN
               IF ry < 86 THEN
               BEGIN
                    AbsTime := 0;
                    IF (ry = 0) AND Adlib THEN SndOutput($b0+FX2[14].r1,$21);
                    Inc(pump);
                    IF pump MOD 1 = 0 THEN Inc(ry);
                    IF MoveImage(10,ry,0,Ofs(rock3[pump MOD 3]),0,0,255,FALSE) = 0 THEN;
                    WHILE AbsTIme < ROCKABS DO;
{                    MoveIma(10,ry,Ofs(rock3[(pump DIV 4) MOD 3]));}
               END ELSE
               BEGIN
                    IF Adlib THEN SndOutput($b0+FX2[14].r1,$1);
                    IF MoveImage(10,ry,0,Ofs(rock3[3]),0,0,255,FALSE) = 0 THEN;
{                    MoveIma(10,ry,Ofs(rock3[3]));}
                    p[1].x := 28;p[1].y := 94;
                    pl := 1;igof := 0;
                    itodo := imoves2[igof,1];
                    Delay2(500);InitPl;
                    Draw_Man;Inc(stage);
                    GameCols;
                    FOR t := 171 TO 200 DO egacross[t] := 0;
                    FOR t := 209 TO 222 DO egacross[t] := 7;
                    FOR t := 224 TO 237 DO egacross[t] := 4;
               END;
          END;
      1 : IF (AbsTime > 10) THEN
          BEGIN
               AbsTime := 0;
               rres := MoveImage(x,y,pl,Ofs(jman1[im]),
                                            32,32,255,NOT dir);
               res := rres AND 15;
               IF res AND 4 = 4 THEN
                  Pel_Hit(pnt2);
               Check_Ladder;
               IF (ltouch < 5) OR (drtouch) THEN wasmoving := FALSE;
               lastj := jump OR jumpup;
               left   := (imoves2[igof,0] AND 1)  > 0;
               right  := (imoves2[igof,0] AND 2)  > 0;
               up     := (imoves2[igof,0] AND 4)  > 0;
               down   := (imoves2[igof,0] AND 8)  > 0;
               jumpup := (imoves2[igof,0] AND 16) > 0;
               jump   := (imoves2[igof,0] AND 32) > 0;
               lrorj  := (imoves2[igof,0] AND 64) > 0;
               IF (jump OR jumpup) AND (NOT lastj) THEN jpump := 0;
               Do_Actions;
               Check_Ladder;
               Check_Green;
               IF NOT(jump OR jumpup) THEN Dec(itodo);
               IF itodo = 0 THEN
               BEGIN
                    Inc(igof);
                    itodo := imoves2[igof,1];
                    IF igof > MAXIMOV2 THEN
                    BEGIN
                         Inc(stage);
                         igof := 0;
                         itodo := imoves[igof,1];
                         InitPl;
                         pnt1 := @intscrd;pnt2 := @intscrt;taskp := pnt2;
                         abstime := 0;intscrp := @intscrd;
                         Hclrscr;Wipe(b64k);Rd_Dac(TRUE);
                         Modify(@Ng,@Int_D,@Ng,@Ng,@Ng,@Ng,@Ng);
                    END;
               END;
          END;
      2 : BEGIN
               IF AbsTime > 10 THEN
               BEGIN
                    AbsTime := 0;
                    IF s1pumps < 21 THEN
                    BEGIN
                         DrawImage(152,s1pumps*8,Ofs(ropes1[1]),FALSE,FALSE,FALSE,FALSE,0);
                         Inc(s1pumps);
                    END ELSE
                    IF s1pumps < 22 THEN
                    BEGIN
                         DrawImage(152,8*22,Ofs(gird1),FALSE,FALSE,FALSE,FALSE,0);
                         DrawImage(152+8,8*22,Ofs(gird1),FALSE,FALSE,FALSE,FALSE,0);
                         Inc(s1pumps);
                         p[pl].x := 152;
                         p[pl].y := -8;
                    END ELSE
                    IF s1pumps IN [22..23] THEN WITH p[pl] DO
                    BEGIN
                          rres := MoveImage(x,y,pl,Ofs(jman1[im]),
                                            32,32,255,NOT dir);
                          res := rres AND 15;
                          Check_Ladder;MovePlayer;
                          Check_Ladder;Check_Green;
                          IF (ltouch < 5) OR ((res AND 7)>0) THEN pdeath := 0;
                          IF (im = 0) AND (y > 100) THEN Inc(s1pumps);
                    END ELSE
                    BEGIN
                         DrawImage(152,(22-(s1pumps-23))*8,Ofs(ropes1[1]),TRUE,FALSE,FALSE,FALSE,$f8);
                         Inc(s1pumps);
                         IF s1pumps = 46 THEN
                         BEGIN
                              Inc(stage);
                              DrawPtrs(TRUE);
                         END;
                    END;
               END;
          END;
      3 : IF (AbsTime > 10) THEN
          BEGIN
               AbsTime := 0;
               rres := MoveImage(x,y,pl,Ofs(jman1[im]),
                                            32,32,255,NOT dir);
               res := rres AND 15;
               IF res AND 4 = 4 THEN
                  Pel_Hit(pnt2);
               Check_Ladder;
               IF (ltouch < 5) OR (drtouch) THEN wasmoving := FALSE;
               lastj := jump OR jumpup;
               left   := (imoves[igof,0] AND 1)  > 0;
               right  := (imoves[igof,0] AND 2)  > 0;
               up     := (imoves[igof,0] AND 4)  > 0;
               down   := (imoves[igof,0] AND 8)  > 0;
               jumpup := (imoves[igof,0] AND 16) > 0;
               jump   := (imoves[igof,0] AND 32) > 0;
               lrorj  := (imoves[igof,0] AND 64) > 0;
               IF (jump OR jumpup) AND (NOT lastj) THEN jpump := 0;
               Do_Actions;
               Check_Ladder;Check_Green;
               IF NOT(jump OR jumpup) THEN Dec(itodo);
               IF itodo = 0 THEN
               BEGIN
                    Inc(igof);
                    itodo := imoves[igof,1];
                    IF igof > MAXIMOV THEN Inc(stage);
               END;
          END;
     END;
END;

PROCEDURE PicScreen;
VAR
     t3,t2 : INTEGER;
     k1 : BYTE;

BEGIN
{$IFDEF PICS}
     lastimx[0] := 100;lastimx[1] := 320;
     FX_Inits(FX2[14]);
     Displaypic(@Saturn);t2 := 340;ShipCols;
     port[$21] := 255-2;
     IF Adlib THEN SndOutput($b0+FX2[14].r1,$21);
     REPEAT
           Dec(t2);
           MoveIma(t2,200-16,Ofs(rock1[(Abs(t2) DIV 2) MOD 2]));
     UNTIL (t2 < -32) OR (key[57]);
     t3 := 200-16;k1 := 2;
     IF NOT key[57] THEN
     REPEAT
           Inc(pump);
           CASE t2 OF
             80..110 : MoveIma(t2,t3,Ofs(rock2[((pump DIV 2) MOD 2)+3]));
             111..139 : MoveIma(t2,t3,Ofs(rock2[((pump DIV 2) MOD 2)+5]));
             ELSE MoveIma(t2,t3,Ofs(rock2[((pump DIV 2) MOD 3)+0]));
           END;
           IF pump MOD 2 = 0 THEN
           BEGIN
                Inc(t2);
                IF Abs(t2) MOD 2 = 0 THEN Dec(t3);
           END;
           IF (t2 > 0) AND Adlib THEN SndOutput($40+FX2[14].r2,t2 DIV 9);
     UNTIL (t2 = 140) OR (key[57]);
     port[$21] := old21;
     IF Adlib THEN
     BEGIN
          SndOutput($b0+FX2[14].r1,1);
          SndOutput($40+FX2[14].r2,0);
     END;
     IF t2 = 140 THEN
     BEGIN
          MoveIma(320,100,Ofs(rock2[0]));
          Delay2(400);
     END;
{$ENDIF}
END;

PROCEDURE Do_Intro;
BEGIN
     SetVga;old21 := port[$21];
     {SetBorder(0);}
     PicScreen;
     port[$21] := old21;
     IF key[57] THEN
     BEGIN
          IF Adlib THEN SndOutput($b0+FX2[14].r1,$1);
          p[1].idevice := 0;p[2].idevice := 0;
          in_intro := FALSE;
          GameCols;
          Exit;
     END;
     New(prd);
     FOR t := 171 TO 200 DO egacross[t] := 0;
     FOR t := 0 TO MAXMA DO ma[t] :=0 ;
     FOR t := 0 TO 40 DO
         ma[t+80] := TRUNC(t*t/10);
     FOR t := 0 TO 56 DO
         ma[80+40+t] := 160-TRUNC(t*t/10);
     FOR t := 0 TO 40 DO
         ma[80+40+56+t] := -160+TRUNC(t*t/10);
     FOR t := 0 TO 63 DO
         ma[250+t] := ((TRUNC(120*Sin(t*(2*pi/63)))));
     FOR t := 0 TO 95 DO
         ma[350+t] := ((TRUNC(20*Sin(t*(2*pi/23)))));
     HClrScr;Wipe(b64k);Rd_Dac(FALSE);
     GameCols;
     pnt1 := @intscr2d;pnt2 := @intscr2t;taskp := pnt2;
     abstime := 0;s1pumps := 0;taofs := 0;
     intscrp := @intscr2d;DrawPtrs(TRUE);
     ry := 0;pump := 0;stage := 0;
     Modify(@Ng,@Ng,@Ng,@Ng,@Ng,@Ng,@Ng);
     REPEAT
           Int_1;
     UNTIL (stage = 4) OR key[57];

     IF NOT key[57] THEN
     BEGIN
          FOR n := -320 TO 640*32 DO prd^[n] := 0;
          FOR t := 0 TO 32 DO
              FOR n := 0 TO 319 DO prd^[t*640+n+160] := mem[Seg(b64k^):t*320+n];

          old21 := port[$21];
          port[$21] := 255;
          oldk := port[$60] AND 128;
          IF vmode = 2 THEN
          BEGIN
               REPEAT
                     Wig;
                     Drot;
               UNTIL (port[$60] AND 128) <> oldk;
          END ELSE
          BEGIN
               REPEAT UNTIL (port[$60] AND 128) <> oldk;
          END;
          port[$21] := old21;
     END;
     Dispose(prd);
     p[1].idevice := 0;p[2].idevice := 0;
     in_intro := FALSE;
     GameCols;
     IF Adlib THEN SndOutput($b0+FX2[14].r1,$1);
END;

FUNCTION KeyDel(n : WORD) : BOOLEAN;
BEGIN
{     n := 0;}
     abstime := 0;
     REPEAT UNTIL (abstime > n) OR keypress;
     KeyDel := NOT keypress;
END;

PROCEDURE Pre_Intro;
CONST
     OX = 130;
     OY = 130;
     drlight : ARRAY[0..2] OF BYTE = (0,0,6);
     crson : ARRAY[0..2] OF BYTE = (0,0,9);
     crsoff : ARRAY[0..2] OF BYTE = (0,0,11);
     pldot : ARRAY[0..2] OF BYTE = (0,0,2);
     MAXMV = 28;
     mvray : ARRAY[0..MAXMV-1,0..1] OF BYTE = ( (2,7),(8,1),(2,2),(8,1),(2,2),(8,4),
                                                (2,3),(32,1),(1,12),(4,1),(1,2),(16,1),
                                                (4+1,2),(32,1),(1,1),(1+8,3),(1,8),(32,1),
                                                (2,2),(4,4),(2,3),(16,1),(4,6),(16,1),(4,1),
                                                (32,1),(4,2),(8,3) );
VAR
   tmpr : ARRAY[16*3..31*3+2] OF BYTE;
   jmx,jmy : WORD;
   mvcnt,
   mvdir,
   mvind : BYTE;

FUNCTION MoveIm : BOOLEAN;
VAR
   rr : BOOLEAN;
BEGIN
     rr := FALSE;

     IF AbsTime MOD 30 = 0 THEN
     BEGIN
          AbsTime := 1;
          Dec(jmx,ORD((mvdir AND 1) > 0) );
          Inc(jmx,ORD((mvdir AND 2) > 0) );
          Dec(jmy,ORD((mvdir AND 4) > 0) );
          Inc(jmy,ORD((mvdir AND 8) > 0) );
          IF (mvdir AND 16) > 0 THEN FX_Jump ELSE
          IF (mvdir AND 32) > 0 THEN
          BEGIN
               FX_Pel;
               DrawImage(jmx,jmy+1,Ofs(pldot),TRUE,FALSE,FALSE,FALSE,$f8);
          END ELSE FX_Walk;
          IF MoveImage(jmx,jmy,0,Ofs(comj),0,0,255,FALSE) = 0 THEN;
          Dec(mvcnt);
          IF mvcnt = 0 THEN
          BEGIN
               Inc(mvind);mvcnt := mvray[mvind,1];
               mvdir := mvray[mvind,0];
               IF mvind = MAXMV THEN rr := TRUE;
          END;
     END;
     MoveIm := rr;
END;

BEGIN
     {$IFDEF PREINT}
     SetHires;
     IF vmode = 2 THEN
     BEGIN
          Load_Dac;
          VgaGreys;
     END;
     GameCols;
     DrawImage(OX,OY+45,Ofs(comut),FALSE,FALSE,FALSE,FALSE,0);
     DrawImage(OX,OY,Ofs(comutm),FALSE,FALSE,FALSE,FALSE,0);
     DrawImage(OX+45,OY+25,Ofs(comutd),FALSE,FALSE,FALSE,FALSE,0);
     Delay2(800);
     AbsTime := 0;
     REPEAT
           IF Odd((AbsTime DIV 100))
              THEN DrawImage(OX+9,OY+14,Ofs(crsoff),FALSE,FALSE,FALSE,FALSE,0)
              ELSE DrawImage(OX+9,OY+14,Ofs(crson),FALSE,FALSE,FALSE,FALSE,0);
     UNTIL (AbsTime > 800) OR (keypress);
     IF NOT keypress THEN
     BEGIN
          DrawImage(OX+45+6,OY+25+12,Ofs(drlight),FALSE,FALSE,FALSE,FALSE,0);
          DrawImage(OX+5,OY+4,Ofs(coms1[0]),FALSE,TRUE,FALSE,FALSE,0);
{$IFNDEF REG}
          Writes('(SHAREWARE VERSION)',0,90,TRUE);
{$ELSE}
          Writes('(FULL VERSION)',0,90,TRUE);
{$ENDIF}
          IF KeyDel(1000) THEN
          BEGIN
               DrawImage(OX+45+6,OY+25+12,Ofs(drlight),TRUE,FALSE,FALSE,FALSE,0);
               Delay2(300);
               DrawImage(OX+5,OY+4,Ofs(coms1[1]),FALSE,TRUE,FALSE,FALSE,0);
               Delay2(400);
               AbsTime := 1;mvcnt := 0;mvind := 255;
               jmx := OX+5+15;jmy := OY+4+13;
               mvdir := 0;mvcnt := 1;
               REPEAT UNTIL MoveIm OR keypress;
               IF KeyDel(600) THEN;
          END;
     END;
     {$ENDIF}
END;

END.
