UNIT sc02u;

INTERFACE

USES
    Globals,Crt1,FX,Routines,robot1u,Adlibu;

FUNCTION sc02_0 : BOOLEAN;
PROCEDURE sc02_1;
PROCEDURE sc02_2;
PROCEDURE sc02_3;
PROCEDURE sc02_4;
PROCEDURE sc02_5;
PROCEDURE sc02_6;

TYPE
    rrec = RECORD
             pumps,
             seqm,
             lx,seqd,seq,
             x,y : INTEGER;
             im  : SHORTINT;
             inmotion : BOOLEAN;
           END;

CONST
     SXY : ARRAY[0..1,0..1] OF WORD = ((208,21*8-2),(96,102));
     MAXSEQ : ARRAY[0..1] OF BYTE = (6,4);
     MAXPER = 5;
     MAXSEQS = 6;
     seqs : ARRAY[0..1,0..MAXSEQS*MAXPER-1,0..1] OF BYTE =
            ( ( (8+2,4),(4+1,16),(8+2,6),(8+1,0),(8+1,0),
               (8+2,12),(4+1,20),(8+0,8),(8+1,0),(8+1,0),
               (8+0,28),(4+1,8),(8+0,8),(8+1,0),(8+1,0),
               (8+2,8),(16+1,8),(8+0,10),(16+1,8),(8+0,8),
               (8+0,6),(16+1,8),(8+0,12),(16+1,8),(8+2,8),
               (8+2,42),(8+1,0),(8+1,0),(8+1,0),(8+1,0)
              ),

              ( (8+0,22),(16+1,16),(8+2,6),(8+1,0),(8+1,0),
                (8+0,6),(4+1,16),(8+2,12),(4+1,8),(8+2,28),
                (8+2,6),(4+1,8),(8+0,36),(8+1,0),(8+1,0),
                (8+2,16),(16+1,8),(8+0,14),(16+1,8),(8+2,10),
                (8+1,0),(8+1,0),(8+1,0),(8+1,0),(8+1,0),
                (8+1,0),(8+1,0),(8+1,0),(8+1,0),(8+1,0)
               ) );
VAR
   robots : ARRAY[0..1] OF rrec;
   n : WORD;
   l2ss : STRING[30];

IMPLEMENTATION

PROCEDURE scr02d;EXTERNAL;{$L scr02d}
PROCEDURE scr02t;EXTERNAL;{$L scr02t}

{$F+}
PROCEDURE sc02_t;
BEGIN
     WITH FX2[0] DO IF (tick < 23*4) AND (p[pl].pdeath < 2) THEN
     BEGIN
          IF Adlib THEN SndOutput($a0+r1,(tick MOD 23)*3)
             ELSE IF Odd(tick) THEN Sound((tick MOD 23)*7+300) ELSE Sound(65000);
          Inc(tick);
          IF tick = 23*4 THEN
             IF Adlib THEN SndOutput($b0+r1,$02) ELSE NoSound;
     END ELSE
     BEGIN
     END;
END;
{$F-}
PROCEDURE sc02_snd;
BEGIN
     FX2[0].minor := -1;
     FX2[0].tick := 0;
     IF Adlib AND (p[pl].pdeath < 2) THEN SndOutput($b0+FX2[0].r1,FX2[0].init[0] OR $20);
END;

FUNCTION sc02_0 : BOOLEAN;
BEGIN
     FX_Inits(FX2[0]);
     Modify(@sc02_1,@sc02_2,@sc02_3,@sc02_4,@sc02_5,@sc02_6,@sc02_t);
     scrtitle := 'ROBOTS';bonus := 1500;current_level := 2;
     Play(@scr02d,@scr02t,0,0,255);
     sc02_0 := NOT plstopnow;
END;

PROCEDURE sc02_1;
VAR
   m : BYTE;
   sfnd : BOOLEAN;
BEGIN
     FOR n := 0 TO 1 DO WITH robots[n] DO
     BEGIN
          IF MoveImage(x,y,n+5,Ofs(robot1[im+ORD(lx<>x)*2]),48,48+n*8,255,(lx > x) )=0 THEN;
          lx := x;Inc(pumps);
          IF pumps MOD 1 = 0 THEN im := (im + 1) MOD 2;
          IF inmotion THEN
          BEGIN
{               gotoxy(1,1);write(seq);delay(100);}
               IF random(40) = 4 THEN sc02_snd;
               IF seqd < 0 THEN seqd := seqs[n,seq,0];
               IF seqm <> seqs[n,seq,1] THEN
               BEGIN
                    x := x + ((seqs[n,seq,0] AND 3)-1)*4;
                    y := y + (((seqs[n,seq,0] SHR 3) AND 3)-1)*4;
                    Scan(x,y+10,Ofs(l2ss));sfnd := FALSE;
                    FOR m := 8 TO 12 DO IF l2ss[m] = #1 THEN sfnd := TRUE;
                    IF (NOT sfnd) AND (x<>lx) THEN Inc(y,2);
                    Scan(x,y+9,Ofs(l2ss));sfnd := FALSE;
                    FOR m := 8 TO 12 DO IF l2ss[m] = #1 THEN sfnd := TRUE;
                    IF (x<>lx) AND (sfnd) THEN Dec(y,2);

{                    gotoxy(1,1);write(l2ss);}
                    Inc(seqm);
               END;
               IF (seqm >= seqs[n,seq,1]) THEN
               BEGIN
                    seqm := 0;
                    seqd := -1;
                    seq := (seq + 1) MOD (MAXSEQ[n]*MAXPER);
                    IF seq MOD MAXPER = 0 THEN inmotion := FALSE;
               END;
          END;
     END;
END;

PROCEDURE sc02_2;
BEGIN
{     IF NOT (robots[0].inmotion OR robots[1].inmotion) THEN}
     FOR n := 0 TO 1 DO WITH robots[n] DO IF NOT(inmotion) THEN
     BEGIN
          inmotion := TRUE;
          seqm := 0;
          seqd := -1;
          sc02_snd;
     END;
END;

PROCEDURE sc02_3;
BEGIN
END;

PROCEDURE sc02_4;
BEGIN
END;

PROCEDURE sc02_5;
BEGIN
     FOR n := 0 TO 1 DO WITH robots[n] DO
       BEGIN
          im := 0;
          pumps := 0;
          x := SXY[n,0];
          lx := x;
          y := SXY[n,1];
          inmotion := FALSE;
          seq := 0;
     END;
     FOR n := 1 TO 24 DO l2ss[n] := #0;l2ss[0] := #23;
END;

PROCEDURE sc02_6;
BEGIN
END;

END.
