UNIT sc12u;

INTERFACE

USES
    Adlibu,Globals,FX,Routines,drag1u,spear1u;

FUNCTION sc12_0 : BOOLEAN;
PROCEDURE sc12_1;
PROCEDURE sc12_2;
PROCEDURE sc12_3;
PROCEDURE sc12_4;
PROCEDURE sc12_5;
PROCEDURE sc12_6;

TYPE
    drags = RECORD
              pumps,
              x,y : INTEGER;
              onrope,
              onladd,
              dir : BOOLEAN;
              im : BYTE;
            END;

CONST
     THEBOT = 167;

VAR
   assy,tasrun,
   dragsh,
   n,m : INTEGER;
   drag : ARRAY[0..1] OF drags;
   sh : RECORD
          pumps,
          x,y : INTEGER;
          dir,
          shoot : BOOLEAN;
        END;
IMPLEMENTATION

PROCEDURE scr12d;EXTERNAL;{$L scr12d}
PROCEDURE scr12t;EXTERNAL;{$L scr12t}

{$F+}
PROCEDURE sc12_t;
BEGIN
END;
{$F-}

PROCEDURE sc12_snd;
BEGIN
     IF Adlib AND (p[pl].pdeath < 2) THEN WITH FX2[7] DO
     BEGIN
          SndOutput($b0+r1,init[0] OR $20);
          SndOutput($b0+r1,init[0]);
     END;
END;

FUNCTION sc12_0 : BOOLEAN;
BEGIN
     FX_Inits(FX2[7]);
     Modify(@sc12_1,@sc12_2,@sc12_3,@sc12_4,@sc12_5,@sc12_6,@sc12_t);
     scrtitle := 'DRAGON SLAYER';bonus := 0;current_level := 7;
     Play(@scr12d,@scr12t,0,7,255);
     sc12_0 := NOT plstopnow;
END;

PROCEDURE sc12_1;
CONST
     MAXPUMP = 16;
     ary : ARRAY[0..MAXPUMP-1] OF SHORTINT =
           (2,2,1,1,0,0,0,0,-1,-1,-2,-2,-2,-2,-2,-2);
BEGIN
     IF p[pl].y = THEBOT-1 THEN assy := THEBOT - 5*8 ELSE
        IF p[pl].y > THEBOT-1 THEN assy := THEBOT-15*8 ELSE
           assy := p[pl].y;
     FOR n := 0 TO 1 DO WITH drag[n] DO
     BEGIN
          IF onrope THEN
          BEGIN
               Inc(y,2);
               Inc(pumps);im := (pumps MOD 2)+2;
               IF y = THEBOT THEN
               BEGIN
                    onrope := FALSE;
                    dir := x > 160;
               END;
               m := MoveImage(x,y,20-n,Ofs(drag1[im]),0,0,47,FALSE);
          END ELSE
          BEGIN
               IF onladd THEN
               BEGIN
                    Dec(y,2);
                    Inc(pumps);im := (pumps MOD 2)+2;
                    m := MoveImage(x,y,20-n,Ofs(drag1[im]),0,0,47,FALSE);
                    IF ((m AND 3) = 1) THEN
                    BEGIN
                         Dec(y,2);
                         onladd := FALSE;
                         dir := x > 160;
                    END;
               END ELSE
               BEGIN
                    Dec(x,(Ord(dir)*2-1)*4);
                    Inc(pumps);im := (pumps MOD 2);
                    m := MoveImage(x,y,20-n,Ofs(drag1[im]),0,0,47,dir);
                    IF (((x = 4*4) AND (y IN [THEBOT-8*5,THEBOT-8*15])) OR
                       ((x = 4*72) AND (y IN [THEBOT,THEBOT-8*10]))) AND
                       (y > assy) THEN onladd := TRUE ELSE
                    IF ((x = 4*0) OR (x=4*76)) AND
                       NOT(y = THEBOT) THEN onrope := TRUE;
               END;
          END;
          IF (m AND 8) = 8 THEN
          BEGIN
               DrawImage(x,y,Ofs(drag1[im]),TRUE,FALSE,FALSE,dir,7);
               Inc(p[pl].score,50);
               x := -32;
               y := THEBOT;
               pumps := 0;
               dir := FALSE;
               onrope := FALSE;
               onladd := FALSE;
               Inc(dragsh);
               IF dragsh MOD 4 = 0 THEN
               IF tasrun < 13 THEN
               BEGIN
                  FOR m := taskp^[tasrun*4+3] TO taskp^[tasrun*4+4] DO
                      DrawImage(taskp^[m*4+1],taskp^[m*4+2],
                                GetOfs(taskp^[m*4+3]),taskp^[m*4+4] > 0,FALSE,FALSE,FALSE,$f8);
                  Inc(tasrun);
                  sh.pumps := MAXPUMP-1;
                  dragsh := 0;
               END;
          END;
     END;
     IF sh.shoot THEN WITH sh DO
     BEGIN
          Inc(pumps);
          IF pumps = MAXPUMP THEN
          BEGIN
               IF MoveImage(x,y,18,Ofs(spear1),104,0,7,dir) = 0 THEN;
               shoot := FALSE;
          END ELSE
          BEGIN
               Dec(x,(Ord(dir)*2-1)*6);
               Dec(y,ary[pumps]);
               IF MoveImage(x,y,18,Ofs(spear1),0,0,255,dir) = 0 THEN;
          END;
     END;
END;

PROCEDURE sc12_2;
BEGIN
END;

PROCEDURE sc12_3;
BEGIN
     IF p[pl].jump AND (NOT sh.shoot) THEN WITH sh DO
     BEGIN
          shoot := TRUE;sc12_snd;
          dir := NOT p[pl].dir;
          x := p[pl].x-16*(Ord(dir)*2-1);
          y := p[pl].y;
          pumps := 0;
     END;
     p[pl].jump := FALSE;
END;

PROCEDURE sc12_4;
BEGIN
END;

PROCEDURE sc12_5;
BEGIN
     FOR n := 0 TO 1 DO with drag[n] DO
     BEGIN
          x := -32 - (n*96);
          y := THEBOT;
          pumps := 0;
          dir := FALSE;
          onrope := FALSE;
          onladd := FALSE;
     END;
     sh.shoot := FALSE;
     tasrun := 1;
     dragsh := 0;
END;

PROCEDURE sc12_6;
BEGIN
END;

END.
