UNIT sc35u;

INTERFACE

USES
    Adlibu,Globals,FX,Routines,hatch1u;

FUNCTION sc35_0 : BOOLEAN;
PROCEDURE sc35_1;
PROCEDURE sc35_2;
PROCEDURE sc35_3;
PROCEDURE sc35_4;
PROCEDURE sc35_5;
PROCEDURE sc35_6;

VAR
   n,m : INTEGER;
   hatch : RECORD
             ex,ey,
             hx,hy,
             pumps : INTEGER;
             imdir,
             imh,ime : SHORTINT;
             hatched,
             chase : BOOLEAN;
           END;

IMPLEMENTATION

PROCEDURE scr35d;EXTERNAL;{$L scr35d}
PROCEDURE scr35t;EXTERNAL;{$L scr35t}

PROCEDURE sc35_snd;
CONST
     s35 : WORD = 0;
     rn : BYTE = 0;
BEGIN
     Inc(s35);
     IF (s35 MOD 3 = 0) AND Adlib AND (p[pl].pdeath < 2) THEN
     BEGIN
          rn := Random(20) DIV 10;
          WITH FX2[9+rn] DO
          BEGIN
               SndOutput($b0+r1,init[0]);
               SndOutput($b0+r1,init[0] OR $20);
          END;
     END;
END;

{$F+}
PROCEDURE sc35_t;
CONST
     tpump : WORD = 0;
BEGIN
     Inc(tpump);
     IF tpump MOD 12 = 0 THEN WITH hatch DO IF hatched THEN
     BEGIN
          IF pumps > 4*4 THEN sc35_snd;
          Inc(pumps);
          IF pumps < 4 THEN
             ime := pumps;
          IF pumps >= 4*4 THEN
          BEGIN
               chase := TRUE;
               Inc(imh,imdir);
               IF imh IN [4,7] THEN
                  imdir := -imdir;
               IF hx < p[pl].x THEN Inc(hx,2) ELSE
                  IF hx > p[pl].x THEN Dec(hx,2);
               IF hy < p[pl].y THEN Inc(hy,1) ELSE
                  IF hy > p[pl].y THEN Dec(hy,1);
               IF MoveImage(hx,hy,19,Ofs(hatch1[imh]),0,0,255,FALSE) = 0 THEN;
          END;
     END;
END;
{$F-}

FUNCTION sc35_0 : BOOLEAN;
BEGIN
     FX_Inits(FX2[9]);
     FX_Inits(FX2[10]);
     WITH hatch DO
     BEGIN
          pumps := 0;
          hatched := FALSE;
     END;
     Modify(@sc35_1,@sc35_2,@sc35_3,@sc35_4,@sc35_5,@sc35_6,@sc35_t);
     scrtitle := 'HATCHLINGS';bonus := 1500;current_level := 43;
     Play(@scr35d,@scr35t,0,9,10);
     sc35_0 := NOT plstopnow;
END;

PROCEDURE sc35_1;
BEGIN
     WITH hatch DO IF hatched THEN
     BEGIN
          IF p[pl].pdeath > 1 THEN
          BEGIN
               DrawImage(ex,ey,Ofs(hatch1[ime]),TRUE,FALSE,FALSE,FALSE,7);
               IF chase THEN DrawImage(hx,hy,Ofs(hatch1[imh]),TRUE,FALSE,FALSE,FALSE,7);
               hatched := FALSE;
          END ELSE WITH hatch DO IF hatched THEN
          BEGIN
               IF MoveImage(ex,ey,20,Ofs(hatch1[ime]),0,0,255,FALSE) = 0 THEN;
               IF pumps >= 4*4 THEN
                  IF MoveImage(hx,hy,19,Ofs(hatch1[imh]),0,0,255,FALSE) = 0 THEN;
          END;
     END;
END;

PROCEDURE sc35_2;
BEGIN
     WITH hatch DO
     BEGIN
          IF hatched THEN
          BEGIN
               DrawImage(ex,ey,Ofs(hatch1[ime]),TRUE,FALSE,FALSE,FALSE,7);
               IF chase THEN DrawImage(hx,hy,Ofs(hatch1[imh]),TRUE,FALSE,FALSE,FALSE,7);
          END;
          chase := FALSE;
          hatched := TRUE;
          ime := 0;pumps := -1;imh := 4;
          ex := somex;
          ey := somey+2;
          hx := ex;
          hy := ey-2;
          imh := 4;
          imdir := 1;
     END;
END;

PROCEDURE sc35_3;
BEGIN
END;

PROCEDURE sc35_4;
BEGIN
END;

PROCEDURE sc35_5;
BEGIN
     WITH hatch DO
     BEGIN
          pumps := 0;
          hatched := FALSE;
     END;
END;

PROCEDURE sc35_6;
BEGIN
END;

END.
